<?php
/*
 * ----------------------------------------------------------------------------
 * BBSLogin.php                                                      05/05/2013
 * This is a login screen for the BBS's VADV-PHP page.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2013 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

$GLOBALS['VA_ACTION'] = 'Logging In...';

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');

if ((IsLoggedIn()) &&
    (isset($_GET['url']))) {
    RedirectUser(urldecode($_GET['url']));
}

//Output header
$pagetitle = 'Log In';
include($themepath . '/templates/header.php');



// Start processes for the login box
$loginerror = '';
$enc_script = '';
$status = false;

if ((isset($_SESSION['auth'])) && (!$_SESSION['auth'])) {

    if ((isset($_SESSION['error'])) && ($_SESSION['error'])) {

        if (isset($_SESSION['login'])) {
            // Destroy the session information.
            $_SESSION = array('');
            session_destroy();
            session_start();
        }

        $loginerror = 'Invalid username or password!' . "\n";
    }

    // User is NOT logged in...
    $status = false;

    // Get login id for this session...
    $loginId = '';
    for ($i = 1; $i <= $GLOBALS['VA_USERS'][0]; $i++) {
        if ($GLOBALS['VA_USERS'][$i]['session'] == session_id()) {
            $loginId = $GLOBALS['VA_USERS'][$i]['id'];
            break;
        }
    }

    // Get encryption method for JavaScript login
    switch ($GLOBALS['CONFIG']['encryption']) {
        case 'md5':
            $enc_script = '<script language="JavaScript" type="text/javascript" src="' . $includeDir . 'javascript/md5.js"></script>' . "\n";
            break;
        case 'sha1':
            $enc_script = '<script language="JavaScript" type="text/javascript" src="' . $includeDir . 'javascript/sha1.js"></script>' . "\n";
            break;
        case 'sha256':
            $enc_script = '<script language="JavaScript" type="text/javascript" src="' . $includeDir . 'javascript/sha256.js"></script>' . "\n";
            break;
        default:
            $enc_script = '';
            break;
    }
}else{
    $status = true;
}



//Output page
include($themepath . '/templates/login.php');

//Output footer
include($themepath . '/templates/footer.php');

?>