<?php
/*
 * ----------------------------------------------------------------------------
 * Files-DispTopics.php                                              04/05/2014
 * This script will display the file forum topics to the user based on the
 * user's security level, access flags and age.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2009 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

// Useful if a user hits the back button.
session_cache_limiter('nocache');

$GLOBALS['VA_ACTION'] = 'Listing Files';
$pagetitle = 'File Area';

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');

$classDatabases = new vadvDatabases;

// Get the topic numbers.
$topics = $classDatabases->GetTopics('F');

// Set the file string variable.
$file = $GLOBALS['VA_SYSPATHS']['main'] . '/DBGROUP.CFG';
if (!file_exists($file)) {
    die('<br /><h4>Requested configuration file is missing. Please press the BACK button on your browser.</h4>');
}
$dbFile = $GLOBALS['VA_SYSPATHS']['main'] . '/DATABASE.CFG';
if (!file_exists($dbFile)) {
    die('<br /><h4>Requested configuration file is missing. Please press the BACK button on your browser.</h4>');
}

$notopics = 0;

// Read the file.
$fileString = ReadCfgFile($file);
$dbFileString = ReadCfgFile($dbFile);
$filetopics = array();
$k = 0;

if ($topics[0] == 0) {
    $notopics = 1;
} else {
    for ($i = 1; $i <= $topics[0]; $i++) {
        // Retrieve the topic information.
        $topic = $classDatabases->GetTopicInfo($topics[$i], 'F', $fileString);

        if ($topic && $topic['dbno'] != 0) {
            $filetopics[$k] = $topic;

            $topicDesc = htmlspecialchars(trim($topic['desc']));
            if ($topic['desc'] == '') {
                $topicDesc = '(No Topic Description)';
            }
            $filetopics[$k]['topicDesc'] = $topicDesc;

            // Get database information and check for new messages.
            $flag = 1;
            $newMessage = 0;
            if ($GLOBALS['CONFIG']['newfilescan'] >= 0) {
                for ($j = 1; $flag <= $topic['dbno']; $j++) {
                    $db = $classDatabases->GetDbInfo($topics[$i], $j, $dbFileString);

                    // If a hard drive and the user has access...
                    if (($db['devicetype'] == 0) &&
                        ($classDatabases->DbAccess($db))) {
                        $flag++;
                        $msgInfo = $classDatabases->GetMessageInfo($db, $db['msgcnt']);
                        if (($msgInfo['timestamp'] > 0) &&
                            ($msgInfo['daysold'] <= $GLOBALS['CONFIG']['newfilescan'])) {
                            $newMessage = 1;
                            break;
                        }
                    }
                }
            }
            $filetopics[$k]['newMessage'] = $newMessage;
        }
        $k++;
    }
}

// Output header
include($themepath . '/templates/header.php');

// Output page
include($themepath . '/templates/filedisptopics.php');

// Output footer
include($themepath . '/templates/footer.php');

?>