<?php
/*
 * ----------------------------------------------------------------------------
 * Forum-DispTopics.php                                              04/06/2014
 * This script will display the message forum topics to the user based on the
 * user's security level, access flags and age.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2014 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

// Useful if a user hits the back button.
session_cache_limiter('nocache');

$GLOBALS['VA_ACTION'] = 'Reading Messages';
$pagetitle = 'Message Forums';

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');

$classDatabases = new vadvDatabases;
$classVADVPHPDat = new datVADVPHP;

// If the newmessagescan parameter is passed, update the user's settings.
if (isset($_GET['newmessagescan'])) {
    if ($_GET['newmessagescan'] == 0) {
        $GLOBALS['USER_SETTINGS']['newmessagescan'] = 0;
    } else {
        $GLOBALS['USER_SETTINGS']['newmessagescan'] = 1;
    }
    session_cache_limiter('nocache');

    // Update the user's settings.
    $fileString = $classVADVPHPDat->Read();
    $fileString = $classVADVPHPDat->Put($fileString, $userno, $GLOBALS['USER_SETTINGS']);
    $classVADVPHPDat->Write($fileString);

    // Reload the page.
    RedirectUser(GetCurrentUrl(0));
}

if (isset($_POST['msgupd'])) {
    $msgupd = (integer) $_POST['msgupd'];
} else {
    $msgupd = 0;
}

// Get the topic numbers.
$topictypes = 'M';
if (($GLOBALS['USER']['securitylevel'] >= 255) &&
    ($GLOBALS['CONFIG']['showcustomdbs'])) {
    $topictypes = 'MO';
}
$topics = $classDatabases->GetTopics($topictypes);

// Set the file string variable.
$file = $GLOBALS['VA_SYSPATHS']['main'] . '/DBGROUP.CFG';
if (!file_exists($file)) {
    die('<br /><h4>Requested configuration file is missing. Please press the BACK button on your browser.</h4>');
}
$dbFile = $GLOBALS['VA_SYSPATHS']['main'] . '/DATABASE.CFG';
if (!file_exists($dbFile)) {
    die('<br /><h4>Requested configuration file is missing. Please press the BACK button on your browser.</h4>');
}

$notopics = 0;

// Read the file.
$fileString = ReadCfgFile($file);
$dbFileString = ReadCfgFile($dbFile);
$forums = array();
$k = 0;

if ($topics[0] == 0) {
    $notopics = 1;
} else {
    for ($i = 1; $i <= $topics[0]; $i++) {
        // Retrieve the topic information.
        $topic = $classDatabases->GetTopicInfo($topics[$i], $topictypes, $fileString);

        if (($topic) && ($topic['dbno'] != 0)) {
            $forums[$k] = $topic;

            $topicDesc = htmlspecialchars(trim($topic['desc']));
            if ($topicDesc == '') {
                $topicDesc = '(No Topic Description)';
            }
            $forums[$k]['desc'] = $topicDesc;

            // Get database information and check for new messages.
            $flag = 1;
            $newMessage = 0;
            if ((IsLoggedIn()) &&
                ($GLOBALS['USER_SETTINGS']['newmessagescan'] == 0)) {
                for ($j = 1; $flag <= $topic['dbno']; $j++) {
                    $db = $classDatabases->GetDbInfo($topics[$i], $j, $dbFileString);
                    // If the user has access...
                    if ($classDatabases->DbAccess($db)) {
                        $flag++;
                        $pntFile = $GLOBALS['VA_SYSPATHS']['db'] . '/' . $db['filename'] . '.QSC';
                        $pntFileString = ReadCfgFile($pntFile);
                        $pnt = $classDatabases->GetMessagePointer($db, $GLOBALS['USER']['userno'], $pntFileString);
                        // Check message update.
                        if ($pnt < $db['msgno']) {
                            if ($msgupd == 0) {
                                $newMessage = 1;
                                break;
                            } else {
                                $classDatabases->WriteMessagePointer($db, $GLOBALS['USER']['userno'], $db['msgno'], $pntFileString);
                            }
                        }
                    }
                }
            }
            $forums[$k]['newmsg'] = $newMessage;
        }
    $k++;
    }
}

// Output header.
include($themepath . '/templates/header.php');

// Output page
include($themepath . '/templates/disptopics.php');

// Output footer
include($themepath . '/templates/footer.php');

?>