<?php
/*
 * ----------------------------------------------------------------------------
 * MsgInfo.php                                                       12/22/2009
 * This script displays information about the specified message.
 * The variable $t is passed to the script to set the topic number.
 * The variable $d is passed to the script to set the database number.
 * The variable $m is passed to the script to set the message number.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2008 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

$GLOBALS['VA_ACTION'] = 'Reading Messages';

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');

$classDatabases = new vadvDatabases;
$classNetworks = new vadvNetworks;

$userno = $GLOBALS['USER']['userno'];

// Set the passed variables.
// Topic.
if (isset($_GET['t'])) {
    $t = $_GET['t'];
} else {
    die('<br /><h4>Invalid parameters. Please press the BACK button on your browser.</h4>');
}

// Database.
if (isset($_GET['d'])) {
    $d = $_GET['d'];
} else {
    die('<br /><h4>Invalid parameters. Please press the BACK button on your browser.</h4>');
}

// Message.
if (isset($_GET['m'])) {
    $m = (integer) $_GET['m'];
} else {
    die('<br /><h4>Invalid parameters. Please press the BACK button on your browser.</h4>');
}

// Get the local network info.
$networks = $classNetworks->GetNetworkInfo();

// Get the database information.
if (($t == 'e') ||
    ($d == 'e')) {
    // Get the message information.
    $t = 'e';
    $d = 'e';
    $db = $classDatabases->SetEmailInfo($userno);
    $msgInfo = $classDatabases->GetMessageInfo($db, $m);

    // Check to see if the user has access to this email message.
    if ($msgInfo['touserno'] != $userno) {
        die('<br /><h4>You do not have access to this message. Press the BACK button on your browser.</h4>');
    }
} else if (($t == 's') ||
           ($d == 's')) {
    // Get the message information.
    $t = 's';
    $d = 's';
    $db = $classDatabases->SetSentEmailInfo($userno);
    $msgInfo = $classDatabases->GetMessageInfo($db, $m);

    // Check to see if the user has access to this email message.
    if ($msgInfo['fromuserno'] != $userno) {
        die('<br /><h4>You do not have access to this message. Press the BACK button on your browser.</h4>');
    }
} else {
    $t = (integer) $t;
    $d = (integer) $d;
    $db = $classDatabases->GetDbInfo($t, $d);

    if (!$classDatabases->DbAccess($db)) {
        die('<br /><h4>You do not have access to this section.</h4>');
    }

    // Get the message information.
    $msgInfo = $classDatabases->GetMessageInfo($db, $m);
    if ($GLOBALS['USER']['securitylevel'] < $db['minreadsl']) {
        die('<br /><h4>You do not have access to this message. Press the BACK button on your browser.</h4>');
    }
}

// Get network information.
$netInfo = $classNetworks->ReadNetworksLst();

// To/From user information.
if ($msgInfo['fromuserno'] == 0) {
    $fromuserno = '';
} else {
    $fromuserno = ' #' . $msgInfo['fromuserno'];
}
if ($msgInfo['touserno'] == 0) {
    $touserno = '';
} else {
    $touserno = ' #' . $msgInfo['touserno'];
}

$fromnet = $msgInfo['fromnetid'];
$tonet = $msgInfo['tonetid'];

if ($fromnet == 0) {
    $fromnetdesc = '';
    $fromnetnode = '';
} else {
    if (isset($netInfo[$fromnet]['desc'])) {
        $fromnetdesc = $netInfo[$fromnet]['desc'];
    } else {
        $fromnetdesc = 'UnknownNET';
    }
    $fromnetnode = ' @' . $msgInfo['fromnetnode'];
}
if ($tonet == 0) {
    $tonetdesc = '';
    $tonetnode = '';
} else {
    if (isset($netInfo[$tonet]['desc'])) {
        $tonetdesc = $netInfo[$tonet]['desc'];
    } else {
        $tonetdesc = 'UnknownNET';
    }
    $tonetnode = ' @' . $msgInfo['tonetnode'];
}

// Determine the type of database.
switch ($db['dbtype']) {
    case 'E':
        $type = 'Email';
        break;
    case 'F':
        $type = 'File';
        break;
    case 'M':
        $type = 'Message';
        break;
    default:
        $type = 'Message';
        break;
}

// Output header
$pagetitle = $type . ' Information';
include($themepath . '/templates/msg_info_header.php');

// Output page
include($themepath . '/templates/msg_info.php');

// Output footer
include($themepath . '/templates/msg_info_footer.php');
?>