<?php
/*
 * ----------------------------------------------------------------------------
 * Post-Email.php                                                    12/22/2009
 * This script displays the new message/reply form to the user.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2009 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

// Useful if a user hits the back button.
session_cache_limiter('nocache');

$GLOBALS['VA_ACTION'] = 'Sending Email';

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');

$classDatabases = new vadvDatabases;
$classNetworks = new vadvNetworks;
$classUserfileDat = new datUserfile;
$classVadvUsers = new vadvUsers;

if ((!isset($_POST['referer'])) && (!isset($_GET['referer']))) {
    die('<br /><h4>Invalid message parameters. Please press the BACK button on your browser.</h4>');
}
if (isset($_GET['referer'])) {
    $_POST['referer'] = urldecode($_GET['referer']);
}

$dbInfo = $classDatabases->SetEmailInfo($GLOBALS['USER']['userno']);
$VA_NETWORKS = $classNetworks->GetNetworkInfo();

// Check user's write security level.
if (($GLOBALS['USER']['userno'] == 0) ||
    ($GLOBALS['USER']['userno'] == $GLOBALS['CONFIG']['guestacct'])) {
    die('<br /><h4>You do not have access to email others. Please press the BACK button on your browser.</h4>');
}

if ($GLOBALS['USER']['securitylevel'] < $dbInfo['minwritesl']) {
    if ((!isset($_GET['u'])) ||
        ($_GET['u'] != 1)) {
        die('<br /><h4>You do not have access to email others. Please press the BACK button on your browser.</h4>');
    }
}

// Set the passed variables.
if ((isset($_POST['reply'])) && ($_POST['reply'] != 0)) {
    $reply = (integer) $_POST['reply'];
    $u = 0;
    $msgInfo = $classDatabases->GetMessageInfo($dbInfo, $reply);
} else {
    $reply = 0;
    $u = 0;
    if ((isset($_GET['u'])) && (intval($_GET['u']) > 0)) {
        $u = (integer) $_GET['u'];
    } else if ((isset($_POST['u'])) && (intval($_POST['u']) > 0)) {
        $u = (integer) $_POST['u'];
    }
}

if (isset($_POST['m'])) {
    $m = (integer) $_POST['m'];
} else {
    $m = $reply;
}

// Check to see if the message was already created and needs to be processed.
if ((isset($_POST['msgflag'])) && ($_POST['msgflag'] == 1)) {
    if ((!isset($_SERVER['HTTP_REFERER'])) ||
        (strpos($_SERVER['HTTP_REFERER'], $_SERVER['HTTP_HOST']) === FALSE)) {
        die('<br /><h4>You are not allowed to access this script from an outside source.<br />Press the BACK button on your browser.</h4>');
    }

    if (isset($_POST['startuser'])) {
        $startUser = (integer) $_POST['startuser'];
    } else {
        $startUser = 1;
    }
    if (isset($_POST['touser'])) {
        $toUser = substr(trim($_POST['touser']), 0, 80);
        $toUser = urldecode($toUser);
        $toUser = str_replace("\r\n", "\n", $toUser);
        $toUser = str_replace("\r", "\n", $toUser);
        $array = explode("\n", $toUser);
        $toUser = strip_tags($array[0]);

        $find = array("/bcc\:/i",
                      "/content\-type\:/i",
                      "/mime\-type\:/i",
                      "/cc\:/i",
                      "/to\:/i");
        $toUser = preg_replace($find, '', $toUser);
        $toUser = trim($toUser);

        if (($toUser != '') && (isset($_POST['tonetid']))) {
            $toNetId = (integer) $_POST['tonetid'];
            // Determine if a local or network email.
            if ($toNetId == 0) {
                // If sending a message to all, it has to be local and by a sysop.
                if (substr(strtolower($toUser), 0, 9) == 'all users') {
                    if ($GLOBALS['USER']['securitylevel'] < 255) {
                        die ('<br /><h4>You are trying to send a message to all users, but do not have security access.</h4>');
                    } else {
                        $toUserString = 'allusers';
                        // Remove any spaces. ('all users' now is 'allusers' len(8))
                        $toUser = str_replace(' ', '', $toUser);
                        $allSign = '';
                        $allValue = 0;
                        if (strlen($toUser) > 9) {
                            $allSign = substr($toUser, 8, 1);
                            switch ($allSign) {
                                case '>':
                                    $allSign = '>';
                                    $allValue = (integer) substr($toUser, 9);
                                    break;
                                case '<':
                                    $allSign = '<';
                                    $allValue = (integer) substr($toUser, 9);
                                    break;
                                case '=':
                                    $allSign = '=';
                                    $allValue = (integer) substr($toUser, 9);
                                    break;
                                case '!':
                                    $allSign = '!';
                                    $allValue = strtoupper(substr($toUser, 9, 1));
                                    break;
                                case '$':
                                    $allSign = '$';
                                    $allValue = strtoupper(substr($toUser, 9, 1));
                                    break;
                                default:
                                    die ('<br /><h4>Improper format to send to all users. Send to \'all users <>= securitylevel\' or \'all users !$ flag\'.</h4>');
                                    break;
                            }
                        } else {
                            die('<br /><h4>You are attempting to send a message to all users, but have not provided any parameters.</h4>');
                        }
                    }
                } else {
                    $toUserString = $toUser . '@0*' . $toNetId;
                }
            } else {
                // If trying to send to non-local, display error.
                if (substr(strtolower($toUser), 0, 9) == 'all users') {
                    die('<br /><h4>You can send a message to all local users only. You are attempting to send to a network address.</h4>');
                } else {
                    $atpos = strpos($toUser, '@');
                    if ($atpos === FALSE) die('<br /><h4>Invalid recipient address. Please enter in the format of user@networkaddress. Please press the BACK button on your browser.</h4>');
                    $toUserString = $toUser . '*' . $toNetId;
                }
            }
        } else {
            die('<br /><h4>Invalid message parameters. Please press the BACK button on your browser.</h4>');
        }
    } else {
        die('<br /><h4>Invalid message parameters. Please press the BACK button on your browser.</h4>');
    }

    if (isset($_POST['subject'])) {
        $msgSubject = $_POST['subject'];
    } else {
        die('<br /><h4>Invalid message parameters. Please press the BACK button on your browser.</h4>');
    }

    if (isset($_POST['msgbody'])) {
        $msgBody = $_POST['msgbody'];
    } else {
        die('<br /><h4>Invalid message parameters. Please press the BACK button on your browser.</h4>');
    }

    $attFilename = '';
    if ((isset($_FILES['attfile'])) && ($_FILES['attfile']['size'] > 0)) {
        // Validate user access for upload files.
        if (($GLOBALS['USER']['securitylevel'] < $GLOBALS['VA_MAIN']['emlotherfile']) ||
            ((trim(ini_get('file_uploads')) == '')) ||
             (!is_dir(ini_get('upload_tmp_dir')))) {
            die('<br /><h4>There was an error with your attached file. Please press the BACK button on your browser.</h4>');
            // Erase the uploaded file.
            if (is_uploaded_file($_FILES['attfile']['tmp_name'])) {
                unlink($_FILES['attfile']['tmp_name']);
            }
        }

        // Access granted, continue...
        if ($_FILES['attfile']['error'] == 'UPLOAD_ERR_OK') {
            if (is_uploaded_file($_FILES['attfile']['tmp_name'])) {
                $userDirectory = $GLOBALS['VA_SYSPATHS']['sysop'] . '/' . $GLOBALS['USER']['userno'];
                $filename = ConvertLongFilename($_FILES['attfile']['name'], $userDirectory);
                $attFilename = str_replace('/', "\\", $userDirectory . '/' . $filename);
                if (!is_dir($userDirectory)) {
                    mkdir($userDirectory);
                }
                move_uploaded_file($_FILES['attfile']['tmp_name'], $attFilename);

                // Add any information to the message itself.
                $msgBody = rtrim($msgBody) . "\r\n\r\n\r\n--------------";
                $msgBody = $msgBody . "\r\nAttached file: " . $filename;
                if ($filename != $_FILES['attfile']['name']) {
                    $msgBody = $msgBody . "\r\nOriginal filename: " . $_FILES['attfile']['name'] . "\r\nThe filename was changed for compatibility reasons.";
                }
            }
        } else {
            switch ($_FILES['attfile']['error']) {
                case 'UPLOAD_ERR_FORM_SIZE':
                    unlink($_FILES['attfile']['tmp_name']);
                    die('<br /><h4>Attached file is too big (>5MB). Please press the BACK button on your browser.</h4>');
                    break;
                case 'UPLOAD_ERR_PARTIAL':
                    unlink($_FILES['attfile']['tmp_name']);
                    die('<br /><h4>Attached file upload was interrupted. Please press the BACK button on your browser.</h4>');
                    break;
                case 'UPLOAD_ERR_NO_FILE':
                    die('<br /><h4>Invalid attachment. Please press the BACK button on your browser.</h4>');
                    break;
                default:
                    die('<br /><h4>An error with the file attachment occurred. Please press the BACK button on your browser.</h4>');
                    break;
            }
        }
    }

    if (isset($_POST['attfilename'])) {
        $attFilename = trim($_POST['attfilename']);
    }

    $pos = strrpos($_POST['referer'], '/');
    $url = substr($_POST['referer'], 0, $pos);

    // If not sent to all, send it..
    if ($toUserString != 'allusers') {
        // Log the email.
        $log = 'E-Mail Sent     "' . $GLOBALS['USER']['handle'] . '" --> "' . $toUserString . '" - ' . $msgSubject;
        WriteLog('VADV-PHP.LOG', $log);
        $classDatabases->WriteEmail($GLOBALS['USER']['userno'], $toUserString, $msgSubject, $msgBody, $reply, $attFilename);
    } else {
        // ...otherwise, loop through all the users to send it.
        if ($startUser == 1) {
            // Log the email.
            $log = 'E-Mail Sent     "' . $GLOBALS['USER']['handle'] . '" --> "ALL USERS" - ' . $msgSubject;
            WriteLog('VADV-PHP.LOG', $log);
        }

        $userCount = $classVadvUsers->Count();

        // Estimate the time it will take to process all of these emails. First,
        // it will calculate based on user count, then it will calculate based
        // on the time that has passed in relation to the number of users
        // processed.
        $exeTime = time();
        if (isset($_POST['exetime'])) {
            $estTime = ((($exeTime - $_POST['exetime']) / 100) * ($userCount - $startUser + 1) / 60);
        } else {
            $estTime = (1.1 * ($userCount - $startUser + 1)) / 60;
        }
        $estTime = round($estTime, 2);

        // Calculate percentage done.
        $pctDone = round(($startUser / $userCount) * 100, 0);



        // Start outputting the 'sending email...please wait' page if necessary
        // Output header
        $pagetitle = 'Email Area';
        include($themepath . '/templates/header.php');

        // Output page
        include($themepath . '/templates/sendemailall.php');

        // Output footer
        include($themepath . '/templates/footer.php');



        ob_flush();

        for ($i = $startUser; $i <= $userCount; $i++) {
            if ($i < ($startUser + 100)) {
                // Reset the time counter for each user.
                set_time_limit(120);
                $toUser = $classUserfileDat->Get($i);
                // If user is not deleted, or a guest...
                if (($toUser['securitylevel'] > 0) &&
                    ($i != $GLOBALS['CONFIG']['guestacct'])) {
                    // Set the to user string.
                    $toUserString = $i . '@0*0';
                    switch ($allSign) {
                        case '':
                            $classDatabases->WriteEmail($GLOBALS['USER']['userno'], $toUserString, $msgSubject, $msgBody, $reply, $attFilename, 0);
                            break;
                        case '>':
                            if ($toUser['securitylevel'] > $allValue) {
                                $classDatabases->WriteEmail($GLOBALS['USER']['userno'], $toUserString, $msgSubject, $msgBody, $reply, $attFilename, 0);
                            }
                            break;
                        case '<':
                            if ($toUser['securitylevel'] < $allValue) {
                                $classDatabases->WriteEmail($GLOBALS['USER']['userno'], $toUserString, $msgSubject, $msgBody, $reply, $attFilename, 0);
                            }
                            break;
                        case '=':
                            if ($toUser['securitylevel'] == $allValue) {
                                $classDatabases->WriteEmail($GLOBALS['USER']['userno'], $toUserString, $msgSubject, $msgBody, $reply, $attFilename, 0);
                            }
                            break;
                        case '!':
                            if (strpos($toUser['flags'], $allValue) !== FALSE) {
                                $classDatabases->WriteEmail($GLOBALS['USER']['userno'], $toUserString, $msgSubject, $msgBody, $reply, $attFilename, 0);
                            }
                            break;
                        case '$':
                            if (strpos($toUser['accflags'], $allValue) !== FALSE) {
                                $classDatabases->WriteEmail($GLOBALS['USER']['userno'], $toUserString, $msgSubject, $msgBody, $reply, $attFilename, 0);
                            }
                            break;
                        default:
                            $classDatabases->WriteEmail($GLOBALS['USER']['userno'], $toUserString, $msgSubject, $msgBody, $reply, $attFilename, 0);
                            break;
                    }
                }
            } else {
                // After 100 emails, reload the script to continue. This avoids server timeouts.
                print '<form name="reloadPost" method="POST" action="post-email.php" enctype="multipart/form-data">' . "\n";
                print '<input type="hidden" name="referer" value="' . $_POST['referer'] . '" />' . "\n";
                print '<input type="hidden" name="reply" value="' . $_POST['reply'] . '" />' . "\n";
                print '<input type="hidden" name="u" value="' . $_POST['u'] . '" />' . "\n";
                print '<input type="hidden" name="msgflag" value="1">' . "\n";
                print '<input type="hidden" name="startuser" value="' . ($startUser + 100) . '" />' . "\n";
                print '<input type="hidden" name="touser" value="' . $_POST['touser'] . '" />' . "\n";
                print '<input type="hidden" name="tonetid" value="' . $_POST['tonetid'] . '" />' . "\n";
                print '<input type="hidden" name="subject" value="' . $_POST['subject'] . '" />' . "\n";
                print '<input type="hidden" name="msgbody" value="' . $_POST['msgbody'] . '" />' . "\n";
                print '<input type="hidden" name="attfilename" value="' . $attFilename . '" />' . "\n";
                print '<input type="hidden" name="exetime" value="' . $exeTime . '" />' . "\n";
                print '<noscript>' . "\n";
                print '<b>Press submit to send to the next 100 users.</b><br />Enable JavaScript to not see this message.<br />';
                print '<input type="submit" name="submit" />' . "\n";
                print '</noscript>' . "\n";
                print '</form>' . "\n";
                print '<script language="JavaScript" type="text/javascript">' . "\n";
                print '<!--' . "\n";
                print 'document.reloadPost.submit();' . "\n";
                print '//-->' . "\n";
                print '</script>' . "\n";
                die();
            }
        }
    }

    if ($reply > 0) {
        // Return to message.
        RedirectUser($url . '/email-viewmsg.php?m=' . $m);
    } else {
        // Return to message listing.
        if ($u > 0) {
            RedirectUser($_POST['referer']);
        } else {
            RedirectUser($url . '/email-dispmsg.php');
        }
    }
}


$cnt = 0;
$net = array();
foreach($VA_NETWORKS as $netInfo) {
    if ((isset($netInfo['nettype'])) &&
        ($netInfo['nettype'] != 2) &&   // If not a VLive network
        ($netInfo['nettype'] != 5)) {   // If not a QWK network
        if ((isset($netInfo['settings']['systemid'])) &&
            ($netInfo['settings']['systemid'] != '0')) {
            if (($GLOBALS['USER']['securitylevel'] >= 255) ||
                ($netInfo['accflag'] == '') || // If a access flag is set..
                (strpos($GLOBALS['USER']['flags'], $netInfo['accflag']) !== FALSE)) {  // If the user has the flag

                    switch ($netInfo['nettype']) {
                        case 1:
                            $type = 'VirtualNET';
                            break;
                        case 3:
                            $type = 'Internet';
                            break;
                        case 4:
                            $type = 'FIDOnet';
                            break;
                        case 9:
                            $type = 'WWIVnet';
                            break;
                        default:
                            $type = 'Unknown';
                            break;
                    }

                    $net[$cnt]['netno'] = $netInfo['netno'];
                    $net[$cnt]['desc'] = $netInfo['desc'];
                    $net[$cnt]['sortdesc'] = strtolower($netInfo['desc']);
                    $net[$cnt]['type'] = $type;
                    $cnt++;
            }
        }
    }
}

// Organize the array alphabetically by description.
$sortarr = array();
foreach ($net as $row) {
    $sortarr[] = $row['sortdesc'];
}
array_multisort($sortarr, $net);


$maxsize = ini_get('upload_max_filesize');
$megpos = strpos(strtoupper($maxsize), 'M');
if ($megpos !== FALSE) {
    $maxsize = substr($maxsize, 0, $megpos);
    $maxsize = 1024 * 1024 * $maxsize;
}








// Output header
$pagetitle = 'Email Area';
include($themepath . '/templates/header.php');

// Output page
include($themepath . '/templates/postemail.php');

// Output footer
include($themepath . '/templates/footer.php');

?>