<?php
/*
 * ----------------------------------------------------------------------------
 * Post-Message.php                                                  12/22/2009
 * This script displays the new message/reply form to the user.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2008 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

// Useful if a user hits the back button.
session_cache_limiter('nocache');

$GLOBALS['VA_ACTION'] = 'Posting Messages';

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');

$classDatabases = new vadvDatabases;

$backURL = '';

if (!isset($_POST['referer'])) {
    die('<br /><h4>Invalid message parameters. Please press the BACK button on your browser.</h4>');
}else{
    $pos = strrpos($_POST['referer'], '/')+1;
    $url = substr($_POST['referer'], $pos);
    $backURL = $url;
}

$error = 0;
// Set the passed variables.
// Topic.
if (isset($_POST['t'])) {
    $t = (integer) $_POST['t'];
} else {
    $error = 1;
}

// Database.
if (isset($_POST['d'])) {
    $d = (integer) $_POST['d'];
} else {
    $error = 1;
}

$dbInfo = $classDatabases->GetDbInfo($t, $d);

// Check user's write security level.
if (($GLOBALS['USER']['userno'] == 0) ||
    ($GLOBALS['USER']['userno'] == $GLOBALS['CONFIG']['guestacct']) ||
    ($GLOBALS['USER']['securitylevel'] < $dbInfo['minwritesl'])) {
    die('<br /><h4>You do not have access to post in this area. Please press the BACK button on your browser.</h4>');
}

// Set the passed variables.
if ((isset($_POST['reply'])) && ($_POST['reply'] != 0)) {
    $reply = (integer) $_POST['reply'];
    $msgInfo = $classDatabases->GetMessageInfo($dbInfo, $reply);
} else {
    $reply = 0;
}

if ($error == 1) {
    die('<br /><h4>Invalid message parameters. Please press the BACK button on your browser.</h4>');
}

if ((isset($_POST['msgflag'])) && ($_POST['msgflag'] == 1)) {
    if ((!isset($_SERVER['HTTP_REFERER'])) ||
        (strpos($_SERVER['HTTP_REFERER'], $_SERVER['HTTP_HOST']) === FALSE)) {
        die('<br /><h4>You are not allowed to access this script from an outside source.<br />Press the BACK button on your browser.</h4>');
    }

    if (isset($_POST['subject'])) {
        $msgSubject = $_POST['subject'];
    } else {
        die('<br /><h4>Invalid message parameters. Please press the BACK button on your browser.</h4>');
    }

    if (isset($_POST['msgbody'])) {
        $msgBody = $_POST['msgbody'];
    } else {
        die('<br /><h4>Invalid message parameters. Please press the BACK button on your browser.</h4>');
    }

    // Log the email.
    $log = 'Message Sent    "' . $GLOBALS['USER']['handle'] . '" --> "' . $dbInfo['desc'] . '" - ' . $msgSubject;
    WriteLog('VADV-PHP.LOG', $log);
    $classDatabases->WriteMessage($dbInfo, $GLOBALS['USER']['userno'], $msgSubject, $msgBody, $reply);

    // Return to message listing.
    $pos = strrpos($_POST['referer'], '/');
    $url = substr($_POST['referer'], 0, $pos);
    RedirectUser($url . '/forum-dispmsg.php?t=' . $t . '&d=' . $d);
}

if (trim($dbInfo['desc']) != '') {
    $dbDesc = htmlspecialchars($dbInfo['desc']);
} else {
    $dbDesc = '(No Description)';
}

//Output header
$pagetitle = 'Message Forums';
include($themepath . '/templates/header.php');



//Output page
include($themepath . '/templates/postmessage.php');

// Output footer
include($themepath . '/templates/footer.php');

?>