<?php
/*
 * ----------------------------------------------------------------------------
 * Search.php                                                        04/05/2014
 * This script searches databases and displays its results.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2014 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

// Useful if a user hits the back button.
session_cache_limiter('nocache');

$GLOBALS['VA_ACTION'] = 'Searching Databases';

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');

$classDatabases = new vadvDatabases;

$userno = $GLOBALS['USER']['userno'];

// Set the passed variables.
// Topic.
if (isset($_REQUEST['t'])) {
    $t = (integer) $_REQUEST['t'];
} else {
    die('<br /><h4>Invalid parameters. Please press the BACK button on your browser.</h4>');
}

// Database.
if (isset($_REQUEST['d'])) {
    $d = (integer) $_REQUEST['d'];
} else {
    die('<br /><h4>Invalid parameters. Please press the BACK button on your browser.</h4>');
}

// Get the database information.
if (($t == 'e') ||
    ($d == 'e')) {
    if (($GLOBALS['USER']['userno'] == 0) ||
        ($GLOBALS['USER']['userno'] == $GLOBALS['CONFIG']['guestacct']) ||
        ($GLOBALS['USER']['securitylevel'] == 0)) {
        die(VADV_LoginError());
    }
    $t = 'e';
    $d = 'e';
    $db = $classDatabases->SetEmailInfo($userno);
} else {
    $db = $classDatabases->GetDbInfo($t, $d);
}
if (!$classDatabases->DbAccess($db)) {
    die('<br /><h4>You do not have access to this section. Please press the BACK button on your browser.</h4>');
}

if ((isset($_REQUEST['submit'])) &&
    ($_REQUEST['submit'] == 'Cancel')) {
    if ($db['dbtype'] == 'M') {
        RedirectUser('forum-dispmsg.php?t=' . $t . '&d=' . $d);
    }
    if ($db['dbtype'] == 'F') {
        RedirectUser('files-dispmsg.php?t=' . $t . '&d=' . $d);
    }
    if ($db['dbtype'] == 'E') {
        RedirectUser('email-dispmsg.php');
    }
    RedirectUser('<?php print $rootDir; ?>index.php');
}

if (((!isset($_REQUEST['search'])) ||
     (trim($_REQUEST['search'] == ''))) &&
    ((!isset($_REQUEST['results'])) ||
     (trim($_REQUEST['results'] == ''))) &&
    (isset($_SESSION['searchresults']))) {
    unset($_SESSION['searchresults']);
}

if (((isset($_REQUEST['search'])) &&
    (trim($_REQUEST['search']) != '')) &&
    ((isset($_SESSION['searchresults'])) &&
     ($_SESSION['searchresults']) != '')) {
//    ((!isset($_REQUEST['sno'])) ||
//     ($_REQUEST['sno'] > 0))) {
    $search = (string) trim(strtolower($_REQUEST['search']));
    if (strlen($search) > 80) {
        $search = substr($search, 0, 80);
    }
} else {
    // No search string specified, so display form to get search specifications.
    // Output header
    $pagetitle = 'Search';
    include($themepath . '/templates/header.php');

    $noresults = 0;
    $dbtype = '';
    $typetxt = '';

    if (isset($_SESSION['searchresults'])) {
        unset($_SESSION['searchresults']);
        $noresults = 1;
    }

    if ($db['dbtype'] == 'E') {
        $dbtype = 'email-dispmsg.php';
        $typetxt = 'Back to Email';
    } else if ($db['dbtype'] == 'F') {
        $dbtype = 'files-dispmsg.php?t=' . $t . '&d=' . $d;
        $typetxt = 'Back to Files';
    } else {
        $dbtype = 'forum-dispmsg.php?t=' . $t . '&d=' . $d;
        $typetxt = 'Back to Messages';
    }

    // Output form page
    include($themepath . '/templates/searchform.php');

    // Output footer
    include($themepath . '/templates/footer.php');
    $_SESSION['searchresults'] = ' ';
    die();
}

$opt['default'] = FALSE;

// Setup search options...
if (isset($_REQUEST['type'])) {
    $opt['type'] = (integer) $_REQUEST['type'];
} else {
    $opt['type'] = 0;
}

if (isset($_REQUEST['n'])) {
    $opt['n'] = (integer) $_REQUEST['n'];
} else {
    $opt['n'] = 30;
}

if (isset($_REQUEST['f'])) {
    $opt['f'] = (boolean) $_REQUEST['f'];
    if ($opt['f']) {
        $opt['default'] = TRUE;
    }
} else {
    $opt['f'] = FALSE;
}

if (isset($_REQUEST['r'])) {
    $opt['r'] = (boolean) $_REQUEST['r'];
    if ($opt['r']) {
        $opt['default'] = TRUE;
    }
} else {
    $opt['r'] = FALSE;
}

if (isset($_REQUEST['s'])) {
    $opt['s'] = (boolean) $_REQUEST['s'];
    if ($opt['s']) {
        $opt['default'] = TRUE;
    }
} else {
    $opt['s'] = FALSE;
}

if (isset($_REQUEST['b'])) {
    $opt['b'] = (boolean) $_REQUEST['b'];
    if ($opt['b']) {
        $opt['default'] = TRUE;
    }
} else {
    $opt['b'] = FALSE;
}

if (isset($_REQUEST['a'])) {
    $opt['a'] = (boolean) $_REQUEST['a'];
    if ($opt['a']) {
        $opt['default'] = TRUE;
    }
} else {
    $opt['a'] = FALSE;
}

// If no options, then search subjects.
if (!$opt['default']) {
    $opt['s'] = TRUE;
}

// Search...
if ((isset($_SESSION['searchresults'])) &&
    (isset($_REQUEST['results'])) &&
    (!isset($_REQUEST['sno']))) {
    // Results exist, so no search needed.
    $results = trim($_SESSION['searchresults']);
} else {
    if (isset($_SESSION['searchresults'])) {
        if (isset($_REQUEST['sno'])) {
            $results = $_SESSION['searchresults'];
        } else {
            unset($_SESSION['searchresults']);
            $results = ' ';
        }
    } else {
        $results = ' ';
    }

    if (!isset($_REQUEST['sno'])) {
        $msgno = $db['msgno'];
    } else {
        $msgno = (integer) $_REQUEST['sno'];
        $pct = floor((($db['msgno'] - $msgno) / $db['msgno']) * 100);

        // Output header
        $pagetitle = 'Searching...';
        include($themepath . '/templates/header.php');

        // Output page (This is the page that shows a progress bar when a search takes some time - doesn't show often and when it does, it's quick!)
        include($themepath . '/templates/searchpbar.php');

        // Output footer
        include($themepath . '/templates/footer.php');

        ob_flush();
    }

    // Reorganize the search string.
    $q = explode(' ', $search);
    $query = '';
    for ($i = 0; $i < count($q); $i++) {
        if (trim($q[$i]) != '') {
            $query .= trim($q[$i]) . ' ';
        }
    }
    $query = explode(' ', trim($query));

    $datfile = $GLOBALS['VA_SYSPATHS']['db'] . '/' . $db['filename'] . '.DAT';
    $binfile = $GLOBALS['VA_SYSPATHS']['db'] . '/' . $db['filename'] . '.BIN';
    if (!file_exists($datfile)) {
        die('<br /><h4>Requested database is missing. Please press the BACK button on your browser.</h4>');
    }

    // Read the file.
    $datFileString = ReadCfgFile($datfile);

    if (!file_exists($binfile)) {
        $binFileString = '';
    } else {
        if ($opt['b']) {
            $binFileString = ReadCfgFile($binfile);
        }
    }

    for ($i = $msgno; $i > 0; $i--) {
        $found = FALSE;
        $array = array();
        $msgInfo = $classDatabases->GetMessageInfo($db, $i, $datFileString);

        // Check message age.
        if ($opt['n'] > 0) {
            $age = floor((lTime() - $msgInfo['timestamp']) / 86400);
            if ($age > $opt['n']) {
                break;
            }
        }

        if ((($opt['f']) &&
            (!$found)) &&
            (($db['dbtype'] != 'E') ||
             ($msgInfo['touserno'] == $userno))) {
            for ($j = 0; $j < count($query); $j++) {
                if (stristr(trim($msgInfo['fromhandle']), trim($query[$j])) !== FALSE) {
                    if ($opt['type'] == 0) {
                        $found = TRUE;
                        break;
                    } else {
                        $array[$j] = $query[$j];
                        if (count($array) == count($query)) {
                            $found = TRUE;
                            break;
                        }
                    }
                }
            }
        }
        if ((($opt['r']) &&
            (!$found)) &&
            (($db['dbtype'] != 'E') ||
             ($msgInfo['touserno'] == $userno))) {
            for ($j = 0; $j < count($query); $j++) {
                if (stristr(trim($msgInfo['tohandle']), trim($query[$j])) !== FALSE) {
                    if ($opt['type'] == 0) {
                        $found = TRUE;
                        break;
                    } else {
                        $array[$j] = $query[$j];
                        if (count($array) == count($query)) {
                            $found = TRUE;
                            break;
                        }
                    }
                }
            }
        }
        if ((($opt['s']) &&
            (!$found)) &&
            (($db['dbtype'] != 'E') ||
             ($msgInfo['touserno'] == $userno))) {
            for ($j = 0; $j < count($query); $j++) {
                if (stristr(trim($msgInfo['subject']), trim($query[$j])) !== FALSE) {
                    if ($opt['type'] == 0) {
                        $found = TRUE;
                        break;
                    } else {
                        $array[$j] = $query[$j];
                        if (count($array) == count($query)) {
                            $found = TRUE;
                            break;
                        }
                    }
                }
            }
        }
        if ((($opt['a']) &&
            (!$found)) &&
            (($db['dbtype'] != 'E') ||
             ($msgInfo['touserno'] == $userno))) {
            for ($j = 0; $j < count($query); $j++) {
                if (stristr(trim($msgInfo['attfilename']), trim($query[$j])) !== FALSE) {
                    if ($opt['type'] == 0) {
                        $found = TRUE;
                        break;
                    } else {
                        $array[$j] = $query[$j];
                        if (count($array) == count($query)) {
                            $found = TRUE;
                            break;
                        }
                    }
                }
            }
        }
        if ((($opt['b']) &&
            (!$found)) &&
            (($db['dbtype'] != 'E') ||
             ($msgInfo['touserno'] == $userno))) {
            $message = $classDatabases->GetMessage($db, $i, 2, $binFileString, $msgInfo);
            for ($j = 0; $j < count($query); $j++) {
                if (stristr($message, trim($query[$j])) !== FALSE) {
                    if ($opt['type'] == 0) {
                        $found = TRUE;
                        break;
                    } else {
                        $array[$j] = $query[$j];
                        if (count($array) == count($query)) {
                            $found = TRUE;
                            break;
                        }
                    }
                }
            }
        }
        if ($found) {
            $results .= $i . '*';
        }
        if (count(explode('*', $results)) > 200) {
            break;
        }
        if ($i < ($msgno - 100)) {
            $_SESSION['searchresults'] = $results;
            RedirectUser('search.php?t=' . $t . '&d=' . $d . '&search=' . $search . '&type=' . $opt['type'] . '&n=' . $opt['n'] . '&f=' . $opt['f'] . '&r=' . $opt['r'] . '&s=' . $opt['s'] . '&b=' . $opt['b'] . '&a=' . $opt['a'] . '&sno=' . --$i);
        }
    }
    if ($results != '') {
        $results = substr($results, 0, strlen($results) - 1);
    }

    $_SESSION['searchresults'] = $results;
    RedirectUser('search.php?t=' . $t . '&d=' . $d . '&search=' . $search . '&results=1&type=' . $opt['type'] . '&n=' . $opt['n'] . '&f=' . $opt['f'] . '&r=' . $opt['r'] . '&s=' . $opt['s'] . '&b=' . $opt['b'] . '&a=' . $opt['a']);
}

// Put the results into an array.
$resultsArray = explode('*', $results);
sort($resultsArray, SORT_NUMERIC);

// Display results.

// Output header
$pagetitle='Search';
include($themepath . '/templates/header.php');


if ($db['dbtype'] == 'F') {
    // --- FILE LAYOUT ---------------------------------------------------------
    // Retrieve the topic information.
    $topic = $classDatabases->GetTopicInfo($t, 'F');

    $topicDesc = htmlspecialchars(trim($topic['desc']));
    if ($topicDesc == '') {
        $topicDesc = '(No Topic Description)';
    }

    $dbDesc = htmlspecialchars(trim($db['desc']));
    if ($dbDesc == '') {
        $dbDesc = '(No Description)';
    }

    if (strlen($dbDesc) > 31) {
        $dbDesc = substr($dbDesc, 0, 31) . '...';
        $dbDesc = $dbDesc . '...';
    }

    // Retrieve the number of messages.
    $msgno = count($resultsArray);

    // Set the passed variables.
    if (isset($_REQUEST['m'])) {
        $m = (integer) $_REQUEST['m'];
    } else {
        $m = $msgno;
    }
    if ($m > $msgno) {
        $m = $msgno;
    }
    if ($m <= 0) {
        $m = 1;
    }

    // Set up Prev/Next links
    $prevlink = false;
    $prevcnt = 0;
    $prevnum = 0;
    $nextlink = false;
    $nextcnt = 0;
    $nextnum = 0;
    if ($m > 25) {
        $prevnum = $m - 25;
        $prevcnt = 25;
        if ($prevnum < 25) {
            $prevcnt = $num;
        }
        $prevlink = true;
    }

    if ($m < $msgno) {
        $nextnum = $m + 25;
        if ($nextnum > $msgno) {
            $nextnum = $msgno;
        }
        $nextcnt = 25;
        if (($msgno - $m) < 25) {
            $nextcnt = ($msgno - $m);
        }
        $nextlink = true;
    }

    $backbase = 'files-dispmsg';

    // Set the fileString variable.
    $file = $GLOBALS['VA_SYSPATHS']['db'] . '/' . $db['filename'] . '.DAT';
    if (!file_exists($file)) {
        die('<br /><h4>Requested database is missing. Please press the BACK button on your browser.</h4>');
    }

    $nofiles = false;
    $filesearch = array();
    $j = 0;

    // Read the file.
    $fileString = ReadCfgFile($file);


    // Run the loop that will display the results.
    for ($i = $m; $i >= ($m - 24); $i--) {
        if ($msgno == 0) {
            $nofiles = true;
            break;
        }

        if ($i <= 0) {
            break;
        }
        // Get the message information.
        $msgInfo = $classDatabases->GetMessageInfo($db, $resultsArray[$i - 1], $fileString);
        $dateTime = ConvertDateTime($msgInfo['creation']);
        $filesearch[$j] = array();

        $filesearch[$j]['date'] = $dateTime['date'];
        $filesearch[$j]['time'] = $dateTime['time'];
        $filesearch[$j]['m'] = $resultsArray[$i -1];

        // Check for email address.
        $from = $msgInfo['fromhandle'];
        $pos = strpos($from, '@');
        if (is_int($pos)) {
            $from = substr($from, 0, $pos);
        }
        $char = substr($from, 0, 1);
        if ($char == '<') {
            $from = substr($from, 1);
        }
        if ($char == '"') {
            $pos = strpos($from, '"', 1);
            $from = substr($from, 1, $pos - 1);
        }
        $filesearch[$j]['from'] = htmlspecialchars(trim($from));

        $filesearch[$j]['subject'] = htmlspecialchars(trim(StripANSICodes(StripBBSCodes($msgInfo['subject']))));
        if ($filesearch[$j]['subject'] == '') {
            $filesearch[$j]['subject'] = '(No Description)';
        }

        $filename = $msgInfo['attfilename'];
        if ($filename != '') {
            if ($GLOBALS['CONFIG']['filehost'] != '') {
                $file = ConvertDir($GLOBALS['CONFIG']['hostname'], $db['filepath']) . '/' . $filename;
            } else {
                $file = $db['filepath'] . '/' . $filename;
            }
        } else {
            $file = '';
        }

        if ($file != '') {
            if (!file_exists($file)) {
                $filesize = '0 bytes';
            } else {
                $realpath = realpath($file);

                if ($realpath !== FALSE) {
                    $file = $realpath;
                    $filename = basename($realpath);
                }

                $filesize = filesize($file);

                if ($filesize >= 1073741824) {
                    $filesize = round($filesize / 1073741824, 1) . 'GB';
                } else if ($filesize >= 1048576) {
                    $filesize = round($filesize / 1048576, 1) . 'MB';
                } else if ($filesize >= 1024) {
                    $filesize = intval($filesize / 1024) . 'KB';
                } else {
                    $filesize = $filesize . ' bytes';
                }
            }
        } else {
            $filesize = '0 bytes';
        }
        $filesearch[$j]['filename'] = $filename;
        $filesearch[$j]['filesize'] = $filesize;
        $filesearch[$j]['deleted'] = $msgInfo['deleted'];
        $j++;
    }
}else if ($db['dbtype'] == 'E') {
    // Not implemented.
} else {
    // --- MESSAGE LAYOUT ----------------------------------------------------------------------------------------------------------------------------------------------------------
    // Retrieve the topic information.
    $topic = $classDatabases->GetTopicInfo($t, 'M');

    $topicDesc = htmlspecialchars(trim($topic['desc']));
    if ($topicDesc == '') {
        $topicDesc = '(No Topic Description)';
    }

    $dbDesc = htmlspecialchars(trim($db['desc']));
    if ($dbDesc == '') {
        $dbDesc = '(No Description)';
    }

    if (strlen($dbDesc) >= 31) {
        $dbDesc = $dbDesc . '...';
    }

    // Retrieve the number of messages.
    $msgno = count($resultsArray);

    // Set the passed variables.
    if (isset($_REQUEST['m'])) {
        $m = (integer) $_REQUEST['m'];
    } else {
        $m = $msgno;
    }
    if ($m > $msgno) {
        $m = $msgno;
    }
    if ($m <= 0) {
        $m = 1;
    }


    // Set up Prev/Next links
    $prevlink = false;
    $prevcnt = 0;
    $prevnum = 0;
    $nextlink = false;
    $nextcnt = 0;
    $nextnum = 0;
    if ($m > 25) {
        $prevnum = $m - 25;
        $prevcnt = 25;
        if ($prevnum < 25) {
            $prevcnt = $prevnum;
        }
        $prevlink = true;
    }

    if ($m < $msgno) {
        $nextnum = $m + 25;
        if ($nextnum > $msgno) {
            $nextnum = $msgno;
        }
        $nextcnt = 25;
        if (($msgno - $m) < 25) {
            $nextcnt = ($msgno - $m);
        }
        $nextlink = true;
    }

    $backbase = 'forum-dispmsg';


    // Set the fileString variable.
    $file = $GLOBALS['VA_SYSPATHS']['db'] . '/' . $db['filename'] . '.DAT';
    if (!file_exists($file)) {
        die('<br /><h4>Requested database is missing. Please press the BACK button on your browser.</h4>');
    }

    $nomsgs = false;
    $msgsearch = array();
    $j = 0;

    // Read the file.
    $fileString = ReadCfgFile($file);

    // Run the loop that will display the messages.
    for ($i = $m; $i >= ($m - 24); $i--) {
        if ($msgno == 0) {
            $nomsgs = true;
            break;
        }

        if ($i <= 0) {
            break;
        }

        // Get the message information.
        $msgInfo = $classDatabases->GetMessageInfo($db, $resultsArray[$i - 1], $fileString);
        $dateTime = ConvertDateTime($msgInfo['creation']);
        $msgsearch[$j] = array();

        $msgsearch[$j]['date'] = $dateTime['date'];
        $msgsearch[$j]['time'] = $dateTime['time'];
        $msgsearch[$j]['m'] = $resultsArray[$i -1];

        // Check for email address.
        $from = $msgInfo['fromhandle'];
        $pos = strpos($from, '@');
        if (is_int($pos)) {
            $from = substr($from, 0, $pos);
        }
        $char = substr($from, 0, 1);
        if ($char == '<') {
            $from = substr($from, 1);
        }
        if ($char == '"') {
            $pos = strpos($from, '"', 1);
            $from = substr($from, 1, $pos - 1);
        }
        $msgsearch[$j]['from'] = htmlspecialchars(trim($from));

        // Check for email address.
        $to = $msgInfo['tohandle'];
        $pos = strpos($to, '@');
        if (is_int($pos)) {
            $to = substr($to, 0, $pos);
        }
        $char = substr($to, 0, 1);
        if ($char == '<') {
            $to = substr($to, 1);
        }
        if ($char == '"') {
            $pos = strpos($to, '"', 1);
            $to = substr($to, 1, $pos - 1);
        }
        $to = htmlspecialchars(trim($to));

        $msgsearch[$j]['subject'] = htmlspecialchars(trim(StripANSICodes(StripBBSCodes($msgInfo['subject']))));
        if ($msgsearch[$j]['subject'] == '') {
            $msgsearch[$j]['subject'] = '(No Subject)';
        }

        $pos = strpos($to, '@');
        if (is_int($pos)) {
            $to = substr($to, 0, $pos);
        }
        $msgsearch[$j]['to'] = $to;
        $msgsearch[$j]['attfilename'] = $msgInfo['attfilename'];
        $msgsearch[$j]['deleted'] = $msgInfo['deleted'];
        $j++;
    }
}




// Output page
include($themepath . '/templates/searchresults.php');

// Output footer
include($themepath . '/templates/footer.php');

?>