<?php
/*
 * ----------------------------------------------------------------------------
 * SentEmail-DispMsg.php                                             04/05/2014
 * This script will display all of the user's email messages that was sent.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2014 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

$GLOBALS['VA_ACTION'] = 'Reading Email';
$pagetitle = 'E-Mail Area';

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');

$classDatabases = new vadvDatabases;
$classVADVPHPDat = new datVADVPHP;

if (($GLOBALS['USER']['userno'] == 0) ||
    ($GLOBALS['USER']['userno'] == $GLOBALS['CONFIG']['guestacct']) ||
    ($GLOBALS['USER']['securitylevel'] == 0)) {
    die(VADV_LoginError());
}
$userno = $GLOBALS['USER']['userno'];

// If the hidedeleted parameter is passed, update the user's settings.
if (isset($_GET['hidesentdeleted'])) {
    if ($_GET['hidesentdeleted'] == 0) {
        $GLOBALS['USER_SETTINGS']['hidesentdeleted'] = 0;
    } else {
        $GLOBALS['USER_SETTINGS']['hidesentdeleted'] = 1;
    }
    session_cache_limiter('nocache');

    // Update the user's settings.
    $fileString = $classVADVPHPDat->Read();
    $fileString = $classVADVPHPDat->Put($fileString, $userno, $GLOBALS['USER_SETTINGS']);
    $classVADVPHPDat->Write($fileString);

    // Reload the page.
    RedirectUser(GetCurrentUrl(0));
}

// Setup the email database information.
$db = $classDatabases->SetSentEmailInfo($userno);

// Determine if the user has access to this section.
if (!$classDatabases->DbAccess($db)) {
    die('<br /><h4>You do not have access to this section. Please press the BACK button on your browser.</h4>');
}


// Retrieve the number of messages.
$msgno = $db['msgno'];

// Determine if there is posted data to process.
if ((isset($_POST['emailform'])) &&
    (($_POST['emailform'] == 1))) {
    if (isset($_POST['markedmail'])) {
        $marked = $_POST['markedmail'];
    } else {
        $marked = array('');
    }

    for ($i = 0; $i < count($marked); $i++) {
        $msg = $marked[$i];

        // Retrieve the database information.
        $db = $classDatabases->SetSentEmailInfo($GLOBALS['USER']['userno']);

        // Get the message information.
        $msgInfo = $classDatabases->GetMessageInfo($db, $msg);

        if ($msgInfo['fromuserno'] == $userno) {
            //if ($msgInfo['deleted'] == 0) {
                /*
                // If an attached file, then delete it. Non-reversible!
                if ($msgInfo['attfilename'] != '') {
                    if ($GLOBALS['CONFIG']['hostname'] != '') {
                        $file = ConvertDir($GLOBALS['CONFIG']['hostname'], $db['filepath']) . '/' . $msgInfo['attfilename'];
                    } else {
                        $file = $db['filepath'] . '/' . $msgInfo['attfilename'];
                    }

                    if ($msgInfo['attfilepath'] == '') {
                        if (file_exists($file)) {
                            unlink($file);
                        }
                    } else {
                        if ($GLOBALS['CONFIG']['hostname'] != '') {
                            $userDir = ConvertUnc($GLOBALS['VA_SYSPATHS']['sysop'] . '/' . $GLOBALS['USER']['userno'] . '/' . $msgInfo['attfilename']);
                        } else {
                            $userDir = $GLOBALS['VA_SYSPATHS']['sysop'] . '/' . $GLOBALS['USER']['userno'] . '/' . $msgInfo['attfilename'];
                        }
                        if ($msgInfo['attfilepath'] == $userDir) {
                            if ($GLOBALS['CONFIG']['hostname'] != '') {
                                $file = ConvertDir($GLOBALS['CONFIG']['hostname'], $msgInfo['attfilepath']);
                            } else {
                                $file = $msgInfo['attfilepath'];
                            }
                        }
                        if (file_exists($file)) {
                            unlink($file);
                        }
                    }
                    $msgInfo['attfilesize'] = 0;
                    $msgInfo['attfilename'] = '';
                    $msgInfo['attfilepath'] = '';
                }
                */

                // Mark the message as deleted and save the new information.
                // $msgInfo['deleted'] = 1;
                // $classDatabases->WriteMessageInfo($db, $msg, $msgInfo);
                // Until this database is added to vcleandb, all messages are permanently
                // deleted if you uncomment this next line.
                $classDatabases->DeleteMessage($db, $msg);
            //} else {
            //    $msgInfo['deleted'] = 0;
            //    $classDatabases->WriteMessageInfo($db, $msg, $msgInfo);
            //}
        }
    }
}

// Retrieve the number of user messages.
if ($GLOBALS['USER_SETTINGS']['hidesentdeleted'] == 1) {
    $msgstat = $classDatabases->GetSentEmailCount($userno, 0);
} else {
    $msgstat = $classDatabases->GetSentEmailCount($userno);
}
$msgcnt = $msgstat['msgno'];
$msgtotal = $msgstat['msgtotal'];
$nondeleted = $msgstat['msgtotal'] - $msgstat['deleted'];
$unread = $msgstat['unread'];
$deleted = $msgstat['deleted'];

if ($GLOBALS['USER_SETTINGS']['hidesentdeleted'] == 1) {
    $msgtotal = $nondeleted;
} else {
    $msgtotal = $msgcnt;
}

// Message.
if (isset($_GET['m'])) {
    $m = (integer) $_GET['m'];
} else {
    $m = $msgcnt;
}
if ($m > $msgcnt) {
    $m = $msgcnt;
}
if ($m <= 0) {
    $m = 1;
}

// Set up our Prev/Next links
$prevcnt = 0;
$prevnum = 0;
$prevlink = false;
$nextcnt = 0;
$nextnum = 0;
$nextlink = false;
if ($m > 25) {
    $prevnum = $m - 25;
    $prevcnt = 25;
    if ($prevnum < 25) {
        $prevcnt = $prevnum;
    }
    $prevlink = true;
}

if ($m < $msgcnt) {
    $nextnum = $m + 25;
    if ($nextnum > $msgcnt) {
        $nextnum = $msgcnt;
    }
    $nextcnt = 25;
    if (($msgcnt - $m) < 25) {
        $nextcnt = ($msgcnt - $m);
    }
    $nextlink = true;
}

// Set the fileString variable.
$file = $GLOBALS['VA_SYSPATHS']['db'] . '/' . $db['filename'] . '.DAT';
if (!file_exists($file)) {
    die('<br /><h4>Requested database is missing. Please press the BACK button on your browser.</h4>');
}

$nomsgs = false;
$usermessages = array();
$j = 0;

// Read the file.
$fileString = ReadCfgFile($file);

// Run the loop that will display the messages.
$forCnt = $msgtotal;
for ($i = $m; $forCnt >= ($msgtotal - 24); $i--) {
    if (($msgcnt == 0) ||
        (($GLOBALS['USER_SETTINGS']['hidesentdeleted'] == 1) &&
        ($nondeleted == 0))) {
        $nomsgs = true;
        break;
    }

    if ($i <= 0) {
        break;
    }

    // Get the message information.
    $msgInfo = $classDatabases->GetMessageInfo($db, $msgstat[$i - 1], $fileString);
    $dateTime = ConvertDateTime($msgInfo['creation'], 'F j, Y');


    // If from the current user...
    if ($msgInfo['fromuserno'] == $userno) {
        if (($GLOBALS['USER_SETTINGS']['hidesentdeleted'] == 0) ||
            ($msgInfo['deleted'] == 0)) {
            $forCnt--;

            $usermessages[$j] = $msgInfo;

            $usermessages[$j]['date'] = $dateTime['date'];
            $usermessages[$j]['time'] = $dateTime['time'];
            $usermessages[$j]['tz'] = $dateTime['tz'];

            $from = $msgInfo['fromhandle'];
            if ($from == '') {
                $from = $msgInfo['fromuserno'];
            }
            $char = substr($from, 0, 1);
            if ($char == '<') {
                $from = substr($from, 1);
            }
            if ($char == '"') {
                $pos = strpos($from, '"', 1);
                $from = substr($from, 1, $pos - 1);
            }
            $from = htmlspecialchars(trim($from));
            if ($msgInfo['fromnetid'] != 1) {
                $from = $from . '@' . $msgInfo['fromnetnode'] . '*' . $msgInfo['fromnetid'];
            }
            $usermessages[$j]['from'] = $from;

            $usermessages[$j]['subject'] = htmlspecialchars(trim(StripASCIICodes(StripANSICodes(StripBBSCodes($msgInfo['subject'])))));
            if ($usermessages[$j]['subject'] == '') {
                $usermessages[$j]['subject'] = '(No Subject)';
            }

            $to = $msgInfo['tohandle'];
            if ($to == '') {
                $to = $msgInfo['touserno'];
            }
            $char = substr($to, 0, 1);
            if ($char == '<') {
                $to = substr($to, 1);
            }
            if ($char == '"') {
                $pos = strpos($to, '"', 1);
                $to = substr($to, 1, $pos - 1);
            }
            $to = htmlspecialchars(trim($to));
            if ($msgInfo['tonetid'] != 1) {
                $to = $to . '@' . $msgInfo['tonetnode'] . '*' . $msgInfo['tonetid'];
            }
            $usermessages[$j]['to'] = $to;


            $usermessages[$j]['msgid'] = $msgstat[$i - 1];
            $usermessages[$j]['msgno'] = $i;
            $j++;
        }
    }
}

// To keep the count display correct
if ($GLOBALS['USER_SETTINGS']['hidesentdeleted'] == 0) {
    $ttlmsgs = $msgtotal;
}else{
    $ttlmsgs = $nondeleted;
}

// -----------------------------------

// Output header
include($themepath . '/templates/header.php');

// Output page
include($themepath . '/templates/dispsentemail.php');

// Output footer
include($themepath . '/templates/footer.php');

?>