<?php
/*
 * ----------------------------------------------------------------------------
 * Subscribe.php                                                     04/05/2014
 * This script will allow the user to join or ignore subs in the new message
 * scans.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2014 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

// Useful if a user hits the back button.
session_cache_limiter('nocache');

$GLOBALS['VA_ACTION'] = 'Changing Subscription';

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');

$classDatabases = new vadvDatabases;
$classUserfileDat = new datUserfile;

if (($GLOBALS['USER']['userno'] == 0) ||
    ($GLOBALS['USER']['userno'] == $GLOBALS['CONFIG']['guestacct']) ||
    ($GLOBALS['USER']['securitylevel'] == 0)) {
    die(VADV_LoginError());
}

// Set the passed variables.
// Topic.
if (isset($_GET['t'])) {
    $t = (integer) $_GET['t'];
} else {
    $t = 1;
}

if ($t < 1) {
    $t = 1;
}

// Check for cancel button.
if (isset($_POST['cancel'])) {
    RedirectUser('forum-dispdb.php?t=' . $t);
}

// Get the topic information.
$topic = $classDatabases->GetTopicInfo($t, 'M');

// If this is an invalid section, display an error message.
if (!$topic) {
    die('<br /><h4>Invalid topic. Please press the BACK button on your browser.</h4>');
}

// Determine if the user has access to this section.
if ($topic['dbno'] == 0) {
    die('<br /><h4>You do not have access to this section. Please press the BACK button on your browser.</h4>');
}

// Set the fileString variable.
$file = $GLOBALS['VA_SYSPATHS']['main'] . '/DATABASE.CFG';
if (!file_exists($file)) {
    die('<br /><h4>Requested configuration file is missing. Please press the BACK button on your browser.</h4>');
}

// Read the file.
$fileString = ReadCfgFile($file);

if ((isset($_POST['subscribeform'])) &&
    ($_POST['subscribeform'] == 1)) {
    if (isset($_POST['markedsubs'])) {
        $marked = $_POST['markedsubs'];
    } else {
        $marked = array();
    }

    $flag = 0;
    for ($i = 1; $flag <= $topic['dbno']; $i++) {
        $db = $classDatabases->GetDbInfo($t, $i, $fileString);

        if ($classDatabases->DbAccess($db)) {
            $flag++;

            $found = FALSE;
            for ($j = 0; $j < count($marked); $j++) {
                if ($marked[$j] == $i) {
                    $found = TRUE;
                    break;
                }
            }

            $ptr = $classDatabases->GetMessagePointer($db, $GLOBALS['USER']['userno']);

            if ($found) {
                if ($ptr >= 32760) {
                    $classDatabases->WriteMessagePointer($db, $GLOBALS['USER']['userno'], 1);
                }
            } else {
                if ($ptr < 32760) {
                    $classDatabases->WriteMessagePointer($db, $GLOBALS['USER']['userno'], 32760);
                }
            }
        }
    }
}

$topicDesc = htmlspecialchars(trim($topic['desc']));
if ($topicDesc == '') {
    $topicDesc = '(No Topic Description)';
}

$flag = 1;
$subInfo = array();
for ($i = 1; $flag <= $topic['dbno']; $i++) {
    // Retrieve the database information.
    $subInfo[$i-1] = $classDatabases->GetDbInfo($t, $i, $fileString);

    // Retrieve the last post information of the database.
    /*$last = $classDatabases->GetLastPostInfo($db);
    $dateTime = ConvertDateTime($last['creation']);*/

    if (strlen($subInfo[$i-1]['desc']) > 31) {
        $subInfo[$i-1]['desc'] = substr($subInfo[$i-1]['desc'], 0, 31) . '...';
    }

    // If there is a moderator, get the handle.
    if ($subInfo[$i-1]['moderator'] != 0) {
        $mod = $classUserfileDat->Get($subInfo[$i-1]['moderator']);
        $subInfo[$i-1]['moderator'] = htmlspecialchars(trim($mod['handle']));
    } else {
        $subInfo[$i-1]['moderator'] = '';
    }

    // Get the number of messages in the database.
    if (!$subInfo[$i-1]['msgno']) {
        $subInfo[$i-1]['msgno'] = 0;
    }

    if ($classDatabases->DbAccess($subInfo[$i-1])) {
        $flag++;

        $subInfo[$i-1]['desc'] = htmlspecialchars(trim($subInfo[$i-1]['desc']));
        if ($subInfo[$i-1]['desc'] == '') {
            $subInfo[$i-1]['desc'] = '(No Description)';
        }
    }
}

// Output header
include($themepath . '/templates/header.php');

// Output page
include($themepath . '/templates/subscribe.php');

// Output footer
include($themepath . '/templates/footer.php');

?>