<?php
/*
 * ----------------------------------------------------------------------------
 * ViewImage.php                                                     12/30/2008
 * This script will display a thumbnail of an attached image in a database.
 * The variable $t is passed to the script to set the topic number.
 * The variable $d is passed to the script to set the database number.
 * The variable $m is passed to the script to set the message number.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2008 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

$GLOBALS['VA_ACTION'] = 'Viewing a Thumbnail';

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');

$classDatabases = new vadvDatabases;
$classNetworks = new vadvNetworks;

// Set the passed variables.
// Topic.
if (isset($_GET['t'])) {
    $t = $_GET['t'];
} else {
    die('<br /><h4>Invalid message parameters.</h4>');
}

// Database.
if (isset($_GET['d'])) {
    $d = $_GET['d'];
} else {
    die('<br /><h4>Invalid message parameters.</h4>');
}

// Message.
if (isset($_GET['m'])) {
    $m = (integer) $_GET['m'];
} else {
    die('<br /><h4>Invalid message parameters.</h4>');
}

// Get the local network info.
$networks = $classNetworks->GetNetworkInfo();

if (($t == 'e') ||
    ($d == 'e')) {
    // Get the database information.
    $t = 'e';
    $d = 'e';
    $db = $classDatabases->SetEmailInfo($userno);

    // Get the message information.
    $msgInfo = $classDatabases->GetMessageInfo($db, $m);

    // Check to see if the user has access to this email message.
    if ($msgInfo['touserno'] != $userno) {
        die('<br /><h4>You do not have access to this message. Press the BACK button on your browser.</h4>');
    }
} else if (($t == 's') ||
           ($d == 's')) {
    $t = 's';
    $d = 's';
    $db = $classDatabases->SetSentEmailInfo($userno);

    // Get the message information.
    $msgInfo = $classDatabases->GetMessageInfo($db, $m);

    // Check to see if the user has access to this email message.
    if ($msgInfo['fromuserno'] != $userno) {
        die('<br /><h4>You do not have access to this message. Press the BACK button on your browser.</h4>');
    }
} else {
    $t = (integer) $t;
    $d = (integer) $d;
    $db = $classDatabases->GetDbInfo($t, $d);
    if (!$classDatabases->DbAccess($db)) {
        die('<br /><h4>You do not have access to this section.</h4>');
    }

    // Get the message information.
    $msgInfo = $classDatabases->GetMessageInfo($db, $m);
    if ($GLOBALS['USER']['securitylevel'] < $db['minreadsl']) {
        die('<br /><h4>You do not have access to this message. Press the BACK button on your browser.</h4>');
    }
}

if (trim($msgInfo['attfilename']) == '') {
    die('<br /><h4>No image to view.</h4>');
}

if (extension_loaded('gd')) {
    // If a local attachment.
    if ($msgInfo['attfilepath'] != '') {
        $filepath = str_replace('/', "\\", $msgInfo['attfilepath']);
        $pos = strrpos($filepath, "\\");
        $filepath = substr($filepath, 0, $pos);
    } else {
        $filepath = $db['filepath'];
    }
    if ($filepath != '') {
        if ($GLOBALS['CONFIG']['filehost']) {
            $file = ConvertDir($GLOBALS['CONFIG']['filehost'], $filepath) . '/' . $msgInfo['attfilename'];
        } else {
            $file = $filepath . '/' . $msgInfo['attfilename'];
        }
    } else {
        $file = $GLOBALS['VA_SYSPATHS']['sysop'] . '/' . $msgInfo['attfilename'];
    }
    $image = getimagesize($file);
    if (($image !== FALSE) &&
        (($image[2] == 1) ||
         ($image[2] == 2) ||
         ($image[2] == 3))) {
        if (($image[0] <= 320) && ($image[1] <= 240)) {
            $width = $image[0];
            $height = $image[1];
        } else {
            if ($image[0] > $image[1]) {
                $ratio = 320 / $image[0];
                $width = 320;
                $height = round($image[1] * $ratio, 0);
                if ($height > 240) {
                    $ratio = 240 / $height;
                    $width = round($width * $ratio, 0);
                    $height = 240;
                }
            } else {
                $ratio = 240 / $image[1];
                $width = round($image[0] * $ratio, 0);
                $height = 240;
                if ($width > 320) {
                    $ratio = 320 / $width;
                    $width = 320;
                    $height = round($height * $ratio, 0);
                }
            }
        }

        if ($image[2] == 1) {
            $source_image = imagecreatefromgif($file);
        } else if ($image[2] == 2) {
            $source_image = imagecreatefromjpeg($file);
        } else if ($image[2] == 3) {
            $source_image = imagecreatefrompng($file);
        } else {
            die('<br /><h4>Not a supported image file.</h4>');
        }

        $resize_image = imagecreatetruecolor($width, $height);
        imagecopyresampled($resize_image, $source_image, 0, 0, 0, 0, $width, $height, $image[0], $image[1]);

        // Let the browser know that it is an image..
        header("Content-Type: image/jpeg");

        // Display the image.
        imagejpeg($resize_image);

        imagedestroy($source_image);
        imagedestroy($resize_image);
    } else {
        die('<br /><h4>Not a supported image file.</h4>');
    }
} else {
    die('<br /><h4>This server does not have GD2 installed.</h4>');
}

?>