<?php
/*
 * ----------------------------------------------------------------------------
 * Index.php                                                         05/05/2013
 * This is the main menu and home page for your Virtual Advanced web bbs!
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2013 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */


$GLOBALS['VA_ACTION'] = 'Viewing Home Page';

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');

$classControlDat = new datControl;
$classDatabases = new vadvDatabases;
$classPostItConfig = new PostItConfig;
$classRandomCfg = new cfgRandom;
$classStatVBBSDat = new datStatVBBS;
$classSysNewsConfig = new SysNewsConfig;
$classTodaysCallers = new TodaysCallers;
$classVoteCfg = new cfgVote;
$classVoteDat = new datVote;

$stats = $classStatVBBSDat->Get();


define('USE_REFRESH', true);

// Output header
include($themepath . "/templates/header.php");



// -------- BEGIN PAGE PROPER --------

// Load some default control variables
$newemail = false;
$postitnt = false;
$sysnews = false;
$newsysnews = false;
$notices = false;
$newvalidate = false;
$newuploads = false;
$newoneliner = false;

// Check for System News support
if ($GLOBALS['CONFIG']['sysnews']) {
    $sysnews = $classSysNewsConfig->Get();
}

if (IsLoggedIn()) {
    // Get email information
    $msgcnt = $classDatabases->GetEmailCount($GLOBALS['USER']['userno']);
    if ($msgcnt['unread'] > 0) {
        $newemail = true;
        $notices = true;
    }

    // System News check...
    if ($sysnews) {
        // Get system news info from database.
        $db = $classDatabases->GetDbInfo($sysnews['topicno'], $sysnews['db']);

        // Get message pointer.
        $msgPointer = $classDatabases->GetMessagePointer($db, $GLOBALS['USER']['userno']);
        if ($msgPointer < $db['msgno']) {
            $newsysnews = true;
            $notices = true;
        }
    }

    // Validate messages...
    if (($GLOBALS['USER']['securitylevel'] >= 255) && (phpversion() != '4.3.7') && (phpversion() != '4.3.8')) {
        $file = $GLOBALS['VA_SYSPATHS']['data'] . '/VALIDATE.*';
        $files = glob($file);

        if ($files != FALSE) {
            foreach ($files as $filename) {
                if (filesize($filename) > 0) {
                    $newvalidate = true;
                    $notices = true;
                    break;
                }
            }
        }
    }

    // New uploads check...
    if ($GLOBALS['USER']['securitylevel'] >= 255) {
        $uploads = $classDatabases->SetUploadInfo();
        $msgcnt = $classDatabases->GetMessageCount($uploads, 0);

        if ($msgcnt > 0) {
            $newuploads = true;
            $notices = true;
        }
    }

    // Oneliners check...
    $db = $classDatabases->SetOnelinerInfo();
    $oneliners = $classDatabases->SearchMessagesTo($db, $GLOBALS['USER']['userno']);

    if ($oneliners[0] > 0) {
        $msgPointer = $classDatabases->GetMessagePointer($db, $GLOBALS['USER']['userno']);

        for ($i = 1; $i <= $oneliners[0]; $i++) {
            if ($msgPointer < $oneliners[$i]) {
                // Get message information.
                $msgInfo = $classDatabases->GetMessageInfo($db, $oneliners[$i]);
                $subject = trim(StripBBSCodes($msgInfo['subject']));

                if (strlen($subject) > 50) {
                    $subject = substr($subject, 0, 50);
                }

                //$subject = $subject . '&nbsp;&nbsp;(' . trim($msgInfo['date']) . ' ' . trim($msgInfo['time']) . ')';

                // Print message subject (oneliner).
                $newoneliner = true;
                $notices = true;

                // Mark the message for deletion.
                $msgInfo['deleted'] = 1;

                // Write the new information.
                $classDatabases->WriteMessageInfo($db, $oneliners[$i], $msgInfo);

                // Update the message pointer.
                $classDatabases->WriteMessagePointer($db, $GLOBALS['USER']['userno'], $oneliners[$i]);
            }
        }
    }

    // Retrieve the random quotes...
    $quotes = $classRandomCfg->Get();

    if ($quotes[0] > 0) {
        // Seed the random number generator.
        mt_srand((double) microtime() * 1000000);
        $rnd = mt_rand(1, $quotes[0]);
        $rndquote = StripBBSCodes($quotes[$rnd]) . "<br />\n";
    }
}


// Check for PostIt Network support
if ($GLOBALS['CONFIG']['postitnt']) {
    $postitnt = $classPostItConfig->Get();
}

// Check to see if any new polls for the user, except for guests.
$voteInf = $classVoteCfg->Get();
if ($voteInf[0] > 0) {
    $newPoll = 0;
    if (IsLoggedIn()) {
        for ($i = 1; $i <= $voteInf[0]; $i++) {
            if ($classVoteDat->Get($GLOBALS['USER']['userno'], $i) == 0) {
                $newPoll = 1;
                break;
            }
        }
    }
}


// Start processes for the login box
$loginerror = '';
$enc_script = '';
$status = false;

if ((isset($_SESSION['auth'])) && (!$_SESSION['auth'])) {

    if ((isset($_SESSION['error'])) && ($_SESSION['error'])) {

        if (isset($_SESSION['login'])) {
            // Destroy the session information.
            $_SESSION = array('');
            session_destroy();
            session_start();
        }

        $loginerror = 'Invalid username or password!' . "\n";
    }

    // User is NOT logged in...
    $status = false;

    // Get login id for this session...
    $loginId = '';
    for ($i = 1; $i <= $GLOBALS['VA_USERS'][0]; $i++) {
        if ($GLOBALS['VA_USERS'][$i]['session'] == session_id()) {
            $loginId = $GLOBALS['VA_USERS'][$i]['id'];
            break;
        }
    }

    // Get encryption method for JavaScript login
    switch ($GLOBALS['CONFIG']['encryption']) {
        case 'md5':
            $enc_script = '<script language="JavaScript" type="text/javascript" src="' . $includeDir . 'javascript/md5.js"></script>' . "\n";
            break;
        case 'sha1':
            $enc_script = '<script language="JavaScript" type="text/javascript" src="' . $includeDir . 'javascript/sha1.js"></script>' . "\n";
            break;
        case 'sha256':
            $enc_script = '<script language="JavaScript" type="text/javascript" src="' . $includeDir . 'javascript/sha256.js"></script>' . "\n";
            break;
        default:
            $enc_script = '';
            break;
    }
}else{
    $status = true;
}

// Load today's callers list
$callers = $classTodaysCallers->Get();

for ($i = 1; $i <= $callers[0]; $i++) {
    $time = $callers[$i]['time'] . ' ' . date("O");
    $callersTime[$i] = ConvertDateTime($time, '', 'H:ia');
}

// Load Who's Online list
$who = $classControlDat->Get();

$maxChannel = 10;    // Display only first 10 channels.
if ($GLOBALS['VA_MAIN']['maxchannelno'] < $maxChannel) {
    $maxChannel = $GLOBALS['VA_MAIN']['maxchannelno'];
}
if ($who['nodetotal'] < $maxChannel) {
    $maxChannel = $who['nodetotal'];
}

// Get number of guests...
$totalGuests = 0;
for ($i = 1; $i <= $GLOBALS['VA_USERS'][0]; $i++) {
    if (($GLOBALS['VA_USERS'][$i]['userno'] == 0) || ($GLOBALS['VA_USERS'][$i]['userno'] == $GLOBALS['CONFIG']['guestacct'])) {
        $totalGuests++;
    }
}

// -----------------------------------




// Output page
include($themepath . "/templates/mainindex.php");
// Output footer
include($themepath . "/templates/footer.php");
?>