<?php
/*
 * ----------------------------------------------------------------------------
 * Login.php                                                         05/18/2009
 * This script is called when a user trys to login. If successful, then the
 * user's session data is updated.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2009 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');

$classUserfileDat = new datUserfile;
$classVADVPHPDat = new datVADVPHP;
$classVadvUsers = new vadvUsers;

if (!isset($_POST['referer'])) {
    die('<br /><h4>An error occurred. Please press the BACK button on your browser.</h4>');
}

if (isset($_POST['url'])) {
    $redirectUrl = $_POST['referer'] . '?url=' . urlencode($_POST['url']);
} else {
    $redirectUrl = $_POST['referer'];
}

if (isset($_POST['logoff'])) {
    $_SESSION = array('');
    session_destroy();
    RedirectUser($redirectUrl);
}

// Save the default values.
$_SESSION['userno'] = base64_encode(0);
$_SESSION['username'] = base64_encode('');
$_SESSION['password'] = base64_encode('');
$_SESSION['login'] = FALSE;
$_SESSION['mobile'] = FALSE;

if ((isset($_POST['username'])) &&
    (trim($_POST['username']) != '')) {
    $username = trim(htmlspecialchars($_POST['username']));
    if (strlen($username) > 40) {
        $username = substr($username, 0, 40);
    }
} else {
    $username = '';
}

$userno = $classVadvUsers->FindUser($username);

if (((isset($_POST['password'])) &&
    (trim($_POST['password']) != '')) ||
    ((isset($_POST['enc'])) &&
     (trim($_POST['enc']) != ''))) {
    // Plain text authentication.
    if ((!$GLOBALS['CONFIG']['requiresecurelogin']) &&
        (isset($_POST['password'])) &&
        (trim($_POST['password']) != '')) {
        $password = trim(htmlspecialchars($_POST['password']));
        if (strlen($password) > 32) {
            $password = substr($password, 0, 32);
        }
        $password = hash($GLOBALS['CONFIG']['encryption'], strtoupper($password));
    } else {
        // Encryption authentication.
        // Remove identifier.
        $encryption = substr(trim($_POST['enc']), 5);
        $loginId = '';

        // Get user info.
        $user = $classUserfileDat->Get($userno);

        // Get user settings.
        $userdat = $classVADVPHPDat->Get($userno);

        // Get user id.
        for ($i = 1; $i <= $GLOBALS['VA_USERS'][0]; $i++) {
            if ($GLOBALS['VA_USERS'][$i]['session'] == session_id()) {
                $loginId = $GLOBALS['VA_USERS'][$i]['id'];
                break;
            }
        }

        // Reset the id.
        UpdateWhosOnline('Logging In...', 900, 1);

        if (trim($userdat['password']) == '') {
            $userpw = $user['password'];
        } else {
            $userpw = $userdat['password'];
        }

        if (hash_hmac($GLOBALS['CONFIG']['encryption'], $userpw, $loginId) === $encryption) {
            // Set password as correct.
            $password = $userpw;
        } else {
            $password = '';
        }
    }
} else {
    $password = '';
}

if ((isset($_POST['mobile'])) &&
    ($_POST['mobile'] == 1)) {
    $_SESSION['mobile'] = TRUE;
}

// Set the log temp variable.
$_SESSION['login'] = TRUE;

// Save the user's information.
$_SESSION['userno'] = base64_encode($userno);
$_SESSION['username'] = base64_encode($username);
$_SESSION['password'] = base64_encode($password);

// If the remember checkbox is enabled, then set cookie.
if ((isset($_POST['remember'])) &&
    ($_POST['remember'] == 1) &&
    ($GLOBALS['CONFIG']['cookielife'] > 0)) {
    $_SESSION['expire'] = time() + ($GLOBALS['CONFIG']['cookielife'] * 86400);
}

RedirectUser($redirectUrl);
?>