<?php
/*
 * ----------------------------------------------------------------------------
 * DispNet.php                                                       01/06/2022
 * This script will display the network listings.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2022 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

$GLOBALS['VA_ACTION'] = 'Viewing Network Listing';

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');

$classNetworks = new vadvNetworks;

define('NOINDEX', true);

// Set the passed variables.
// Network.
if (isset($_GET['net'])) {
    $netNo = $_GET['net'];
} else {
    $netNo = 0;
}

if (!is_numeric($netNo)) {
    $netNo = 0;
}

if (isset($_GET['l'])) {
    $startLine = $_GET['l'];
} else {
    $startLine = 0;
}

$networks = $classNetworks->GetNetworkinfo();



if ($netNo == 0) {
    // If no net number set, then display a list of available networks.

    // Output header
    $pagetitle = 'Network Listing';
    include($themepath . '/templates/header.php');



    // Output page
    include($themepath . '/templates/networklist.php');

    // Output footer
    include($themepath . '/templates/footer.php');

    exit;
}

// If net number set, then check it's existance and display that network's information

// If it doesn't exist, send error page, else continue
$bError = TRUE;
foreach($networks as $netInfo) {
    if (($netNo == $netInfo['netno']) &&
        (isset($netInfo['settings']['systemid'])) &&
        ($netInfo['settings']['systemid'] != '0')) {
        $bError = FALSE;
        break;
    }
}

        // Output error page
if ($bError) {
    $errortype = 'Invalid Network!';
    $message = '<br /><h4>Not a valid active network. Please press the back button on your browser.</h4><br />';
    include($themepath . '/templates/header.php');
    include($themepath . '/templates/errmsg.php');
    include($themepath . '/templates/footer.php');
    exit;
}


// Output header
$pagetitle = 'Network Node List';
include($themepath . '/templates/header.php');


// Set the filename.
$filename = $GLOBALS['VA_SYSPATHS']['data'] . '\NETLIST.' . $netNo;

$noNodes = 0;
$maxlines = 200;
$i = 0;
$showPrev = 0;
$showNext = 0;



// Output page
include($themepath . '/templates/nodelist.php');

// Output footer
include($themepath . '/templates/footer.php');

?>