<?php
/*
 * ----------------------------------------------------------------------------
 * EditUser.php                                                         12/22/2009
 * This script will allow users to edit thier personal information and
 * preferences.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2009 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

$GLOBALS['VA_ACTION'] = 'Editing User Profile';

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');

$classNetworks = new vadvNetworks;

if (($GLOBALS['USER']['userno'] == 0) ||
    ($GLOBALS['USER']['userno'] == $GLOBALS['CONFIG']['guestacct']) ||
    ($GLOBALS['USER']['securitylevel'] == 0)) {
    die(VADV_LoginError());
}

$VA_NETWORKS = $classNetworks->GetNetworkInfo();

// Get required info flags.
$required = GetAccFlags($GLOBALS['CONFIG']['newuserreq']);


// This will allow redirects for "Back to Previous Page" without the nesting problems with 'referer', etc..
// Just load your links to the UserInfo page with &ref=referring-page (and any other vars) and place
// that in the switches below
if (isset($_GET['ref'])) {
    switch($_GET['ref']) {
        case 'profile':
            // They came from their Profile page (The only other place they can edit their account is the main index, so we just need the profile ref here)
            $retURL = $rootDir . 'misc/userinfo.php?u='.$GLOBALS['USER']['userno'].(isset($_GET['prev']) ? '&ref='.$_GET['prev'] : '');
            $retTXT = 'Profile Page';
            break;
        default:
            break;
    }
}


// Include our javascript in header
$requireCheck = '';

if (is_int(strpos($required, 'A'))) { $requireCheck .= "(form.realname.value.length == 0) ||\n"; }
if (is_int(strpos($required, 'B'))) { $requireCheck .= "(form.address.value.length == 0) ||\n"; }
if (is_int(strpos($required, 'C'))) { $requireCheck .= "(form.city.value.length == 0) ||\n"; }
if (is_int(strpos($required, 'D'))) { $requireCheck .= "(form.state.value.length == 0) ||\n"; }
if (is_int(strpos($required, 'E'))) { $requireCheck .= "(form.zipcode.value.length == 0) ||\n"; }
if (is_int(strpos($required, 'F'))) { $requireCheck .= "(form.voice.value.length == 0) ||\n"; }
if (is_int(strpos($required, 'G'))) { $requireCheck .= "(form.data.value.length == 0) ||\n"; }

$hdr_include .= '<script language="JavaScript" type="text/javascript">' . "\n";
$hdr_include .= '<!--' . "\n";
$hdr_include .= '    function validate(form) {' . "\n";
$hdr_include .= '        if (' . $requireCheck;
$hdr_include .= '            (0 == 1)) {' . "\n";
$hdr_include .= '            alert("Please fill out all required fields.");' . "\n";
$hdr_include .= '            form.realname.focus();' . "\n";
$hdr_include .= '            return false;' . "\n";
$hdr_include .= '        }' . "\n";
$hdr_include .= '    }' . "\n";
$hdr_include .= '    function HelpWindow(hpath, bmark) {' . "\n";
$hdr_include .= '        var url = hpath + "#" + bmark;' . "\n";
$hdr_include .= '        var newwindow = window.open(url, "helpwindow", "toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=yes, resizable=no, width=350, height=450");' . "\n";
$hdr_include .= '        newwindow.focus();' . "\n";
$hdr_include .= '    }' . "\n";
$hdr_include .= '//-->' . "\n";
$hdr_include .= '</script>' . "\n";


// Output header
$pagetitle = 'Edit User';
include($themepath . '/templates/header.php');

$error = '';

if (isset($_GET['error'])) {
    switch ($_GET['error']) {
        case 'realname':
            $error = 'You must enter your real name.';
            break;
        case 'address':
            $error = 'You must enter your address.';
            break;
        case 'city':
            $error = 'You must enter your city.';
            break;
        case 'state':
            $error = 'You must enter your state.';
            break;
        case 'zipcode':
            $error = 'You must enter your zip code.';
            break;
        case 'voice':
            $error = 'You must enter your phone number, including area code.';
            break;
        case 'data':
            $error = 'You must enter your fax/data number, including area code.';
            break;
        default:
            $error = '';
    }
}

$phone1a = strtok($GLOBALS['USER']['phone1'], "-");
$phone1b = strtok("-");
$phone1c = strtok("-");

$phone2a = strtok($GLOBALS['USER']['phone2'], "-");
$phone2b = strtok("-");
$phone2c = strtok("-");


$fwdaddress = '';
if (($GLOBALS['USER']['mailfwdflag'] == 1) && ($GLOBALS['USER']['mailfwduserno'] != '')) {
    $fwdaddress = $GLOBALS['USER']['mailfwduserno'] . '@' . $GLOBALS['USER']['mailfwdnode'];
} else if (($GLOBALS['USER']['mailfwdflag'] == 1) && ($GLOBALS['USER']['mailfwdhandle'] != '')) {
    $fwdaddress =  $GLOBALS['USER']['mailfwdhandle'] . '@' . $GLOBALS['USER']['mailfwdnode'];
}




// Output page
include($themepath . '/templates/edituser.php');

// Output footer
include($themepath . '/templates/footer.php');

?>