<?php
/*
 * ----------------------------------------------------------------------------
 * EditUser_Process.php                                              12/22/2009
 * This script will process the edituser form.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2008 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

$GLOBALS['VA_ACTION'] = 'Editing User Profile';

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');

$classUserfileDat = new datUserfile;
$classUserfileIdx = new idxUserfile;
$classVADVPHPDat = new datVADVPHP;

if (($GLOBALS['USER']['userno'] == 0) ||
    ($GLOBALS['USER']['userno'] == $GLOBALS['CONFIG']['guestacct'])) {
    RedirectUser($rootDir . 'index.php');
}

if ((!isset($_SERVER['HTTP_REFERER'])) ||
    (strpos($_SERVER['HTTP_REFERER'], $_SERVER['HTTP_HOST']) === FALSE)) {
    die('<br /><h4>You are not allowed to access this script from an outside source.<br />Press the BACK button on your browser.</h4>');
}

if ((!isset($_POST['process'])) ||
    ($_POST['process'] != 1)) {
    die('<br /><h4>Invalid parameters. Please press the BACK button on your browser.</h4>');
}
if (!isset($_POST['submit'])) {
    die('<br /><h4>Invalid parameters. Please press the BACK button on your browser.</h4>');
}

if ((isset($_POST['userno'])) &&
    ($_POST['userno'] != $GLOBALS['USER']['userno'])) {
    die('<br /><h4>Invalid information. Please press the BACK button on your browser.</h4>');
}

// Format variables.
$_POST['realname'] = ucwords(trim(strtolower($_POST['realname'])));
$_POST['address'] = ucwords(trim(strtolower($_POST['address'])));
$_POST['city'] = ucwords(trim(strtolower($_POST['city'])));
$_POST['state'] = trim(strtoupper($_POST['state']));
$_POST['zipcode'] = trim($_POST['zipcode']);
$_POST['phone1a'] = trim($_POST['phone1a']);
$_POST['phone1b'] = trim($_POST['phone1b']);
$_POST['phone1c'] = trim($_POST['phone1c']);
$_POST['phone2a'] = trim($_POST['phone2a']);
$_POST['phone2b'] = trim($_POST['phone2b']);
$_POST['phone2c'] = trim($_POST['phone2c']);
$_POST['bbspassword'] = trim(strtoupper($_POST['bbspassword']));
$_POST['bbsverify'] = trim(strtoupper($_POST['bbsverify']));
$_POST['webpassword'] = trim(strtoupper($_POST['webpassword']));
$_POST['webverify'] = trim(strtoupper($_POST['webverify']));
$_POST['mailfwd'] = trim($_POST['mailfwd']);
$_POST['mailfwdnetno'] = (integer) $_POST['mailfwdnetno'];
$_POST['timezone'] = (integer) $_POST['timezone'];
$_POST['htmlencode'] = (integer) $_POST['htmlencode'];
$_POST['tagline'] = (integer) $_POST['tagline'];
$_POST['theme'] = (integer) $_POST['theme'];

// Fix the referer URL. Make sure there is no query string.
$url = parse_url($_POST['referer']);
$referer = $url['scheme'] . '://' . $url['host'] . $url['path'];

// Check for required information.
// Convert into a string.
$required = ' ' . GetAccFlags($GLOBALS['CONFIG']['newuserreq']);

if ((is_int(strpos($required, 'A'))) &&
    ($_POST['realname'] == '')) {
    RedirectUser($referer . '?error=realname');
}
if ((is_int(strpos($required, 'B'))) &&
    ($_POST['address'] == '')) {
    RedirectUser($referer . '?error=address');
}
if ((is_int(strpos($required, 'C'))) &&
    ($_POST['city'] == '')) {
    RedirectUser($referer . '?error=city');
}
if ((is_int(strpos($required, 'D'))) &&
    ($_POST['state'] == '')) {
    RedirectUser($referer . '?error=state');
}
if ((is_int(strpos($required, 'E'))) &&
    ($_POST['zipcode'] == '')) {
    RedirectUser($referer . '?error=zipcode');
}
if ((is_int(strpos($required, 'F'))) &&
    ($_POST['phone1a'] == '' || $_POST['phone1b'] == '' || $_POST['phone1c'] == '')) {
    RedirectUser($referer . '?error=voice');
}
if ((is_int(strpos($required, 'G'))) &&
    ($_POST['phone2'] == '' || $_POST['phone2b'] == '' || $_POST['phone2c'] == '')) {
    RedirectUser($referer . '?error=data');
}

$phone1 = $_POST['phone1a'] . "-" . $_POST['phone1b'] . "-" . $_POST['phone1c'];
$phone2 = $_POST['phone2a'] . "-" . $_POST['phone2b'] . "-" . $_POST['phone2c'];


if ($_POST['realname'] != $GLOBALS['USER']['realname']) {
    $edituser['realname'] = $_POST['realname'];
    $useridx['realname'] = $_POST['realname'];
}
if ($_POST['address'] != $GLOBALS['USER']['address']) {
    $edituser['address'] = $_POST['address'];
}
if ($_POST['city'] != $GLOBALS['USER']['city']) {
    $edituser['city'] = $_POST['city'];
}
if ($_POST['state'] != $GLOBALS['USER']['state']) {
    $edituser['state'] = $_POST['state'];
}
if ($_POST['zipcode'] != $GLOBALS['USER']['zipcode']) {
    $edituser['zipcode'] = $_POST['zipcode'];
}
if ($phone1 != $GLOBALS['USER']['phone1']) {
    $edituser['phone1'] = $phone1;
}
if ($phone2 != $GLOBALS['USER']['phone2']) {
    $edituser['phone2'] = $phone2;
}

// If password change...
if ((isset($_POST['bbspassword'])) && ($_POST['bbspassword'] != '') &&
    (isset($_POST['bbsverify'])) &&
    ($_POST['bbsverify'] != '')) {
    $password = $_POST['bbspassword'];
    $verify = $_POST['bbsverify'];
    if ($password === $verify) {
        $edituser['password'] = $password;
        $GLOBALS['USER']['password'] = hash($GLOBALS['CONFIG']['encryption'], $password);

        // Change session password.
        $_SESSION['password'] = base64_encode(hash($GLOBALS['CONFIG']['encryption'], $password));
    }
}

// Mail forwarding...
if ((isset($_POST['mailfwd'])) &&
    (trim($_POST['mailfwd']) != '')) {
    $pos = strpos($_POST['mailfwd'], '@');
    if ($pos !== FALSE) {
        $to = substr($_POST['mailfwd'], 0, $pos);
        $node = substr($_POST['mailfwd'], $pos + 1);
        if (intval($to) > 0) {
            $edituser['mailfwdhandle'] = '';
            $edituser['mailfwduserno'] = $to;
        } else {
            $edituser['mailfwdhandle'] = $to;
            $edituser['mailfwduserno'] = 0;
        }
        $edituser['mailfwdflag'] = 1;
        $edituser['mailfwdnode'] = $node;
        $edituser['mailfwdnetno'] = $_POST['mailfwdnetno'];
    }
} else {
    $edituser['mailfwdflag'] = 0;
    $edituser['mailfwdhandle'] = '';
    $edituser['mailfwduserno'] = 0;
    $edituser['mailfwdnode'] = '';
    $edituser['mailfwdnetno'] = 0;
}

$log = 'User Editor     "' . $GLOBALS['USER']['handle'] . '"';
WriteLog('VADV-PHP.LOG', $log);

// Write new DAT file.
if (isset($edituser)) {
    // Get the file string.
    $fileString = $classUserfileDat->Read();

    // Put the new information into the file string.
    $fileString = $classUserfileDat->Put($fileString, $GLOBALS['USER']['userno'], $edituser);

    // Write the new file.
    $classUserfileDat->Write($fileString);
}

// Write new IDX file.
if (isset($useridx)) {
    $fileString = $classUserfileIdx->Read();
    $fileString = $classUserfileIdx->Put($fileString, $GLOBALS['USER']['userno'], $useridx);
    $classUserfileIdx->Write($fileString);
}

if ((isset($_POST['timezone']) &&
    ($_POST['timezone'] != $GLOBALS['USER_SETTINGS']['timezone']))) {
    $newsettings['timezone'] = $_POST['timezone'];
}
if ((isset($_POST['htmlencode']) &&
    ($_POST['htmlencode'] != $GLOBALS['USER_SETTINGS']['htmlencode']))) {
    $newsettings['htmlencode'] = $_POST['htmlencode'];
}
if ((isset($_POST['tagline']) &&
    ($_POST['tagline'] != $GLOBALS['USER_SETTINGS']['tagline']))) {
    $newsettings['tagline'] = $_POST['tagline'];
}
if ((isset($_POST['theme']) &&
    ($_POST['theme'] != $GLOBALS['USER_SETTINGS']['theme']))) {
    $newsettings['theme'] = $_POST['theme'];

    // Let's add a cookie that will be used to keep the same theme if this user visits without being logged in
    setcookie('vadvtheme', $_POST['theme'], (time() + ($GLOBALS['CONFIG']['cookielife'] + 2592000)), '/', '', 0);
}

// If password change...
if ((isset($_POST['resetwebpassword'])) &&
    (intval($_POST['resetwebpassword']) == 1)) {
    $newsettings['password'] = '';
    $_SESSION['password'] = base64_encode($GLOBALS['USER']['password']);
} else {
    if ((isset($_POST['webpassword'])) &&
        ($_POST['webpassword'] != '') &&
        (isset($_POST['webverify'])) &&
        ($_POST['webverify'] != '')) {
        $password = $_POST['webpassword'];
        $verify = $_POST['webverify'];
        if ($password === $verify) {
            $newsettings['password'] = hash($GLOBALS['CONFIG']['encryption'], $password);

            // Change session password.
            $_SESSION['password'] = base64_encode(hash($GLOBALS['CONFIG']['encryption'], $password));
        }
    }
}

if (isset($newsettings)) {
    $fileString = $classVADVPHPDat->Read();
    $fileString = $classVADVPHPDat->Put($fileString, $GLOBALS['USER']['userno'], $newsettings);
    $classVADVPHPDat->Write($fileString);
}

RedirectUser($_POST['referer']);

?>