<?php
/*
 * ----------------------------------------------------------------------------
 * Post-It_Network.php                                               12/22/2009
 * This script will display the last five posts on the Post-It Network.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2009 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

$GLOBALS['VA_ACTION'] = 'Post-It! Network';

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');

$classDatabases = new vadvDatabases;
$classPostItConfig = new PostItConfig;

define('NOINDEX', true);

if (!$GLOBALS['CONFIG']['postitnt']) {
    die('<br /><h4>This script has been disabled. Press the BACK button on your browser.</h4>');
}

$postitCfg = $classPostItConfig->Get();

if (!$postitCfg) {
    die('<br /><h4>The Post-It! Network script is not installed. Press the BACK button on your browser.</h4>');
}

// Get the Post-It database information.
$db = $classDatabases->GetDbInfo($postitCfg['topicno'], $postitCfg['db']);


// Output header
$pagetitle = 'Post-It! Network';
include($themepath . '/templates/header.php');



// Read the Post-It! database file for faster searches.
$file = $GLOBALS['VA_SYSPATHS']['db'] . '/' . $db['filename'] . '.DAT';
if (!file_exists($file)) {
    die('<br /><h4>Requested database is missing. Please press the BACK button on your browser.</h4>');
}

// Read the file.
$fileString = ReadCfgFile($file);

// Get the messages to display and apply any filters.
$num = 0;
$msgNo = $db['msgno'];
$msg = array();

while (($num < 5) && ($msgNo > 0)) {
    $msgInfo = $classDatabases->GetMessageInfo($db, $msgNo, $fileString);
    if (!$msgInfo['deleted']) {
        if (strpos($msgInfo['subject'], 'Post-It! Network v') !== FALSE) {
            if ($postitCfg['filter']) {
                if (strpos($msgInfo['subject'], '*p') === FALSE) {
                    $msg[$num] = $msgNo;
                    $num++;
                }
            } else {
                $msg[$num] = $msgNo;
                $num++;
            }
        }
    }
    $msgNo--;
}

// Turn the array around to display in correct order.
$msg = array_reverse($msg);


$postIt = array();
$j = 0;

// Print out the array (messages).
for ($num = 0; ($num < 5) && (isset($msg[$num])); $num++) {
    $header = $classDatabases->GetMessageInfo($db, $msg[$num], $fileString);
    $message = StripRouting($classDatabases->GetMessage($db, $msg[$num], 0, '', $header));

    if (($header['fromnetid'] == 1) &&
        ($header['fromnetnode'] == $postitCfg['vnetnode'])) {
        $header['fromnetnode'] = $postitCfg['networknode'];
        $fromBbs = trim($GLOBALS['VA_MAIN']['bbsname']);
    } else {
        $fromBbs = '';
        $netFile = $GLOBALS['VA_SYSPATHS']['data'] . '/NETLIST.' . $header['fromnetid'];
        if (file_exists($netFile)) {
            $fileArray = file($netFile);
            for ($i = 0; $i < count($fileArray); $i++) {
                $node = trim(substr($fileArray[$i], 2, 9));
                if ($node == $header['fromnetnode']) {
                    $fromBbs = trim(substr($fileArray[$i], 19, 30));
                    break;
                }
            }
        } else {
            $fromBbs = "Unknown";
        }
    }
    $postIt[$j] = $header;
    $postIt[$j]['fromBbs'] = $fromBbs;
    $postIt[$j]['message'] = $message;

    $j++;
}



// Update message pointer if needed.
if ($classDatabases->GetMessagePointer($db, $GLOBALS['USER']['userno']) < $db['msgno']) {
    $classDatabases->WriteMessagePointer($db, $GLOBALS['USER']['userno'], $db['msgno']);
}


// Output page
include($themepath . '/templates/post-it.php');

// Output footer
include($themepath . '/templates/footer.php');

?>