<?php
/*
 * ----------------------------------------------------------------------------
 * SysInfo.inc.php                                                   12/22/2009
 * This script will display system statistics and information to the user.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2012 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

$GLOBALS['VA_ACTION'] = 'Viewing System Information';

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');

$classConnectDat = new datConnect;
$classDOWDat = new datDOW;
$classHoursDat = new datHours;
$classNetworks = new vadvNetworks;
$classStatVBBSDat = new datStatVBBS;

define('NOINDEX', true);

$connect = $classConnectDat->Get();
$hours = $classHoursDat->Get();
$dow = $classDOWDat->Get();
$stats = $classStatVBBSDat->Get();
$networks = $classNetworks->GetNetworkInfo();



// Output header
$pagetitle = 'System Information';
include($themepath . '/templates/header.php');



// Determine the hour with the most minutes used.
$pre = 'am';
$hour = 1;
$high = 0;

for ($i=0; $i<24; $i++) {
    if ($i == 0) {
        $hour = 12;
    }else if ($i > 12) {
        $hour = $i -12;
        $pre = 'pm';
    }else{
        $hour = $i;
    }
    if ($hours[$hour.$pre] > $high) {
        $high = $hours[$hour.$pre];
    }
}
$hours['high'] = $high;
if ($hours['high'] == 0) {
    $hours['high'] = 1;
}

// Determine which has most logins, BBS or Web.
$high = 0;
$totallogins['total'] = $stats['callstotal'] + $stats['webcallstotal'];
$totallogins['BBS'] = $stats['callstotal'];
$totallogins['Web'] = $stats['webcallstotal'];
if ($totallogins['BBS'] > $high) {
    $high = $totallogins['BBS'];
}
if ($totallogins['Web'] > $high) {
    $high = $totallogins['Web'];
}
$totallogins['high'] = $high;
if ($totallogins['high'] == 0) {
    $totallogins['high'] = 1;
}


// Determine the day of week with the most connections.
$high = 0;
if ($dow['sunday'] > $high) {
    $high = $dow['sunday'];
}
if ($dow['monday'] > $high) {
    $high = $dow['monday'];
}
if ($dow['tuesday'] > $high) {
    $high = $dow['tuesday'];
}
if ($dow['wednesday'] > $high) {
    $high = $dow['wednesday'];
}
if ($dow['thursday'] > $high) {
    $high = $dow['thursday'];
}
if ($dow['friday'] > $high) {
    $high = $dow['friday'];
}
if ($dow['saturday'] > $high) {
    $high = $dow['saturday'];
}
$dow['high'] = $high;
if ($dow['high'] == 0) {
    $dow['high'] = 1;
}

// Determine the connect type with the most minutes used.
$high = 0;
if ($connect['1200'] > $high) {
    $high = $connect['1200'];
}
if ($connect['2400'] > $high) {
    $high = $connect['2400'];
}
if ($connect['9600'] > $high) {
    $high = $connect['9600'];
}
if ($connect['14400'] > $high) {
    $high = $connect['14400'];
}
if ($connect['19200'] > $high) {
    $high = $connect['19200'];
}
if ($connect['24000'] > $high) {
    $high = $connect['24000'];
}
if ($connect['28800'] > $high) {
    $high = $connect['28800'];
}

$connect['other'] = $stats['callstotal'] - $connect['total'];
if ($connect['other'] < 1) {
    $connect['other'] = 0;
}
if ($connect['other'] > $high) {
    $high = $connect['other'];
}

$connect['high'] = $high;
if ($connect['high'] == 0) {
    $connect['high'] = 1;
}



$callstoday = $stats['callstoday'];
$callstotal = $stats['callstotal'];
$netcallstoday = $stats['netcallstoday'];
$netcallstotal = $stats['netcallstotal'];
$poststoday = $stats['poststoday'];
$poststotal = $stats['poststotal'];
$emailstoday = $stats['emailstoday'];
$emailstotal = $stats['emailstotal'];
$downloadstoday = $stats['downloadstoday'];
$downloadstotal = $stats['downloadstotal'];
$uploadstoday = $stats['uploadstoday'];
$uploadstotal = $stats['uploadstotal'];
$activemintoday = $stats['activemintoday'];
$activemintotal = $stats['activemintotal'];
$idlemintoday = $stats['idlemintoday'];
$idlemintotal = $stats['idlemintotal'];

$todaymin = $activemintoday + $idlemintoday;
if ($todaymin > 0) {
    $activepcttoday = round(($activemintoday / $todaymin) * 100);
    } else {
    $activepcttoday = 0;
}
$totalmin = $activemintotal + $idlemintotal;
if ($totalmin > 0) {
    $activepcttotal = round(($activemintotal / $totalmin) * 100);
    } else {
    $activepcttotal = 0;
}

$webcallstotal = $stats['webcallstotal'];
$webhitstotal = $stats['webhitstotal'];
$webmaxusers = $stats['webmaxusers'];





// Output page
include($themepath . '/templates/statistics.php');


// Output footer
include($themepath . '/templates/footer.php');


?>