<?php
/*
 * ----------------------------------------------------------------------------
 * System_News.php                                                     12/30/2009
 * This script contains functions that work with AT2k scripts and programs.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2009 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

$GLOBALS['VA_ACTION'] = 'Reading System News';

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');

$classDatabases = new vadvDatabases;
$classSysNewsConfig = new SysNewsConfig;

define('NOINDEX', true);

if (!$GLOBALS['CONFIG']['sysnews']) {
    die('<br /><h4>This script has been disabled. Press the BACK button on your browser.</h4>');
}

if (isset($_GET['m'])) {
    $m = (integer) $_GET['m'];
} else {
    $m = FALSE;
}

$sysnews = $classSysNewsConfig->Get();

if (!$sysnews) {
    die('<br /><h4>The System News script is not installed. Press the BACK button on your browser.</h4>');
}


$dbInfo = $classDatabases->GetDbInfo($sysnews['topicno'], $sysnews['db']);
$msgPointer = $classDatabases->GetMessagePointer($dbInfo, $GLOBALS['USER']['userno']);

$file = $GLOBALS['VA_SYSPATHS']['db'] . '/' . $dbInfo['filename'] . '.DAT';
$fileString = ReadCfgFile($file);


if (isset($_POST['submit']) || isset($_POST['postsysmsg'])) {
    if (($GLOBALS['USER']['userno'] == 0) ||
        ($GLOBALS['USER']['userno'] == $GLOBALS['CONFIG']['guestacct']) ||
        ($GLOBALS['USER']['securitylevel'] == 0)) {
        die(VADV_LoginError());
    }
    if ($GLOBALS['USER']['securitylevel'] < $dbInfo['minwritesl']) {
        $log = 'VConfig Error!  "' . $GLOBALS['USER']['handle'] . '" - Attempted Unauthorized VConfig Entry';
        WriteLog('VADV-PHP.LOG', $log);
        RedirectUser($rootDir . 'index.php');
    }

    // Check for system password.
    if ($GLOBALS['CONFIG']['syspass']) {
        if (isset($_SESSION['systempw'])) {
            if ($_SESSION['systempw'] !== $GLOBALS['VA_MAIN']['systempw']) {
                RedirectUser($rootDir . 'index.php');
            }
        } else {
            RedirectUser($rootDir . 'vconfig/systemlogin.php?url=' . urlencode(GetCurrentURL()));
        }
    }
    if ((!isset($_SERVER['HTTP_REFERER'])) ||
       (strpos($_SERVER['HTTP_REFERER'], $_SERVER['HTTP_HOST']) === FALSE)) {
        die('<br /><h4>You are not allowed to access this script from an outside source.<br />Press the BACK button on your browser.</h4>');
    }
}



// Output header
$pagetitle = 'System News';
include($themepath . '/templates/header.php');




if ($m != FALSE) {
    // Get message information.
    $msgInfo = $classDatabases->GetMessageInfo($dbInfo, $m, $fileString);

    // Get the message.
    $message = StripRouting(chr(3) . '0' . $classDatabases->GetMessage($dbInfo, $m, 0, '', $msgInfo));
    $dateTime = ConvertDateTime($msgInfo['creation'], 'F j, Y');

    // Update message pointer if needed.
    if ($msgPointer < $m) {
        $classDatabases->WriteMessagePointer($dbInfo, $GLOBALS['USER']['userno'], $m);
    }

    // Output page
    include($themepath . '/templates/viewsysnews.php');


} else if (isset($_POST['submit'])) {


    // Output page
    include($themepath . '/templates/postsysmsg.php');

} else if (isset($_POST['postsysmsg'])) {

    if (isset($_POST['subject'])) {
        $msgSubject = $_POST['subject'];
    } else {
        die('<br /><h4>Invalid message parameters. Please press the BACK button on your browser.</h4>');
    }

    if (isset($_POST['msgbody'])) {
        $msgBody = $_POST['msgbody'];
    } else {
        die('<br /><h4>Invalid message parameters. Please press the BACK button on your browser.</h4>');
    }

    // Log and write message to database.
    $log = 'Message Sent    "' . $GLOBALS['USER']['handle'] . '" --> "' . $dbInfo['desc'] . '" - ' . $msgSubject;
    WriteLog('VADV-PHP.LOG', $log);
    $classDatabases->WriteMessage($dbInfo, $GLOBALS['USER']['userno'], $msgSubject, $msgBody, 0);

    // Return to System News page
    $errortype = "Post System News";
    $message = "New System News posted!<br /><br />You will now be redirected to the System News page.";
    $redirectURL = $rootDir . 'misc/system_news.php';
    $delay = 3;
    include($themepath . '/templates/errmsg.php');
    include($themepath . '/templates/admin/admin_footer.php');
    exit;
} else {

    // Output page
    include($themepath . '/templates/dispsysnews.php');
}




// Output footer
include($themepath . '/templates/footer.php');

?>