<?php
/*
 * ----------------------------------------------------------------------------
 * ThemePicker.php                                                   09/02/2011
 * This script will process the themepicker dropdown choice.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2011 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

$GLOBALS['VA_ACTION'] = 'Browsing';

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');

$classUserfileDat = new datUserfile;
$classUserfileIdx = new idxUserfile;
$classVADVPHPDat = new datVADVPHP;

if (isset($_POST['theme'])) {

    // If logged in and not a guest, set $newsettings['theme'] to trigger an update of this user's information
    if ($GLOBALS['USER']['userno'] > 0) {
        $newsettings['theme'] = $_POST['theme'];
    }

    // No matter what, let's add a cookie that will be used to keep the same theme for guests or if a user
    // visits without being logged in
    setcookie('vadvtheme', $_POST['theme'], (time() + ($GLOBALS['CONFIG']['cookielife'] + 2592000)), '/', '', 0);
}

if (isset($newsettings)) {
    $fileString = $classVADVPHPDat->Read();
    $fileString = $classVADVPHPDat->Put($fileString, $GLOBALS['USER']['userno'], $newsettings);
    $classVADVPHPDat->Write($fileString);
}

if (!isset($_POST['referer'])) {
    RedirectUser($rootDir);
} else {
    RedirectUser($_POST['referer']);
}

?>