<?php
/*
 * ----------------------------------------------------------------------------
 * TopTen.php                                                        12/22/2009
 * This script will display the top ten users in a variety of categories.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2009 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

$GLOBALS['VA_ACTION'] = 'Viewing Top Ten List';

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');

$classUserStats = new UserStats;

define('NOINDEX', true);

// Get the user stats (not the sysops).
$topten = $classUserStats->Get(254);


if (isset($_GET['view']) && $_GET['view'] != '') {
    $view = $_GET['view'];
}else{
    $view = '';
}

// Set max places to list for each category
$max = 10;

$showIndex = false;


// Output header
$pagetitle = 'Top ' . $max . ' Lists';
include($themepath . '/templates/header.php');



switch ($view) {
    case 'tc':
        for ($i=1; $i<=$max; $i++) {
            if (!isset($topten['totalcalls'][$i]['userno'])) {
                $toplist[$i]['userno'] = '&nbsp;';
            }else{
                $toplist[$i]['userno'] = $topten['totalcalls'][$i]['userno'];
            }
            if (!isset($topten['totalcalls'][$i]['handle'])) {
                $toplist[$i]['handle'] = '&nbsp;';
            }else{
                $toplist[$i]['handle'] = $topten['totalcalls'][$i]['handle'];
            }
            if (!isset($topten['totalcalls'][$i]['value'])) {
                $toplist[$i]['value'] = '&nbsp;';
            }else{
                $toplist[$i]['value'] = $topten['totalcalls'][$i]['value'];
            }
        }
        $toptitle = 'Top ' . $max . ' Callers';
        $valueTitle = 'Calls';
        break;


    case 'tt':
        for ($i=1; $i<=$max; $i++) {
            if (!isset($topten['totaltime'][$i]['userno'])) {
                $toplist[$i]['userno'] = '&nbsp;';
            }else{
                $toplist[$i]['userno'] = $topten['totaltime'][$i]['userno'];
            }
            if (!isset($topten['totaltime'][$i]['handle'])) {
                $toplist[$i]['handle'] = '&nbsp;';
            }else{
                $toplist[$i]['handle'] = $topten['totaltime'][$i]['handle'];
            }
            if (!isset($topten['totaltime'][$i]['value'])) {
                $toplist[$i]['value'] = '&nbsp;';
            }else{
                $toplist[$i]['value'] = $topten['totaltime'][$i]['value'];
            }
        }
        $toptitle = 'Top ' . $max . ' Time Users';
        $valueTitle = 'Minutes';
        break;


    case 'tp':
        for ($i=1; $i<=$max; $i++) {
            if (!isset($topten['totalposts'][$i]['userno'])) {
                $toplist[$i]['userno'] = '&nbsp;';
            }else{
                $toplist[$i]['userno'] = $topten['totalposts'][$i]['userno'];
            }
            if (!isset($topten['totalposts'][$i]['handle'])) {
                $toplist[$i]['handle'] = '&nbsp;';
            }else{
                $toplist[$i]['handle'] = $topten['totalposts'][$i]['handle'];
            }
            if (!isset($topten['totalposts'][$i]['value'])) {
                $toplist[$i]['value'] = '&nbsp;';
            }else{
                $toplist[$i]['value'] = $topten['totalposts'][$i]['value'];
            }
        }
        $toptitle = 'Top ' . $max . ' Posters';
        $valueTitle = 'Messages';
        break;


    case 'te':
        for ($i=1; $i<=$max; $i++) {
            if (!isset($topten['totalemail'][$i]['userno'])) {
                $toplist[$i]['userno'] = '&nbsp;';
            }else{
                $toplist[$i]['userno'] = $topten['totalemail'][$i]['userno'];
            }
            if (!isset($topten['totalemail'][$i]['handle'])) {
                $toplist[$i]['handle'] = '&nbsp;';
            }else{
                $toplist[$i]['handle'] = $topten['totalemail'][$i]['handle'];
            }
            if (!isset($topten['totalemail'][$i]['value'])) {
                $toplist[$i]['value'] = '&nbsp;';
            }else{
                $toplist[$i]['value'] = $topten['totalemail'][$i]['value'];
            }
        }
        $toptitle = 'Top ' . $max . ' Emailers';
        $valueTitle = 'Emails';
        break;


    case 'td':
        for ($i=1; $i<=$max; $i++) {
            if (!isset($topten['dlfiles'][$i]['userno'])) {
                $toplist[$i]['userno'] = '&nbsp;';
            }else{
                $toplist[$i]['userno'] = $topten['dlfiles'][$i]['userno'];
            }
            if (!isset($topten['dlfiles'][$i]['handle'])) {
                $toplist[$i]['handle'] = '&nbsp;';
            }else{
                $toplist[$i]['handle'] = $topten['dlfiles'][$i]['handle'];
            }
            if (!isset($topten['dlfiles'][$i]['value'])) {
                $toplist[$i]['value'] = '&nbsp;';
            }else{
                $toplist[$i]['value'] = $topten['dlfiles'][$i]['value'];
            }
        }
        $toptitle = 'Top ' . $max . ' Downloaders';
        $valueTitle = 'Files';
        break;


    case 'tdk':
        for ($i=1; $i<=$max; $i++) {
            if (!isset($topten['dlkb'][$i]['userno'])) {
                $toplist[$i]['userno'] = '&nbsp;';
            }else{
                $toplist[$i]['userno'] = $topten['dlkb'][$i]['userno'];
            }
            if (!isset($topten['dlkb'][$i]['handle'])) {
                $toplist[$i]['handle'] = '&nbsp;';
            }else{
                $toplist[$i]['handle'] = $topten['dlkb'][$i]['handle'];
            }
            if (!isset($topten['dlkb'][$i]['value'])) {
                $toplist[$i]['value'] = '&nbsp;';
            }else{
                $toplist[$i]['value'] = $topten['dlkb'][$i]['value'];
            }
        }
        $toptitle = 'Top ' . $max . ' Downloaders by KB';
        $valueTitle = 'KB';
        break;


    case 'tu':
        for ($i=1; $i<=$max; $i++) {
            if (!isset($topten['uplfiles'][$i]['userno'])) {
                $toplist[$i]['userno'] = '&nbsp;';
            }else{
                $toplist[$i]['userno'] = $topten['uplfiles'][$i]['userno'];
            }
            if (!isset($topten['uplfiles'][$i]['handle'])) {
                $toplist[$i]['handle'] = '&nbsp;';
            }else{
                $toplist[$i]['handle'] = $topten['uplfiles'][$i]['handle'];
            }
            if (!isset($topten['uplfiles'][$i]['value'])) {
                $toplist[$i]['value'] = '&nbsp;';
            }else{
                $toplist[$i]['value'] = $topten['uplfiles'][$i]['value'];
            }
        }
        $toptitle = 'Top ' . $max . ' Uploaders';
        $valueTitle = 'Files';
        break;


    case 'tuk':
        for ($i=1; $i<=$max; $i++) {
            if (!isset($topten['uplkb'][$i]['userno'])) {
                $toplist[$i]['userno'] = '&nbsp;';
            }else{
                $toplist[$i]['userno'] = $topten['uplkb'][$i]['userno'];
            }
            if (!isset($topten['uplkb'][$i]['handle'])) {
                $toplist[$i]['handle'] = '&nbsp;';
            }else{
                $toplist[$i]['handle'] = $topten['uplkb'][$i]['handle'];
            }
            if (!isset($topten['uplkb'][$i]['value'])) {
                $toplist[$i]['value'] = '&nbsp;';
            }else{
                $toplist[$i]['value'] = $topten['uplkb'][$i]['value'];
            }
        }
        $toptitle = 'Top ' . $max . ' Uploaders by KB';
        $valueTitle = 'KB';
        break;


    default:
        $showIndex = true;
        $toptitle = 'Top ' . $max . ' User Rankings';
        break;
}



// Output page
include($themepath . '/templates/toptenlists.php');

// Output footer
include($themepath . '/templates/footer.php');

?>