<?php
/*
 * ----------------------------------------------------------------------------
 * UserEditor.php                                                    12/22/2009
 * This script will allow the sysop to edit all of the specified user's
 * information, preferences and statistics.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2009 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

$GLOBALS['VA_ACTION'] = 'SysOp Function';

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');

$classNetworks = new vadvNetworks;
$classUserfileDat = new datUserfile;
$classVadvUsers = new vadvUsers;

if (($GLOBALS['USER']['userno'] == 0) ||
    ($GLOBALS['USER']['userno'] == $GLOBALS['CONFIG']['guestacct']) ||
    ($GLOBALS['USER']['securitylevel'] == 0)) {
    die(VADV_LoginError());
}
if ($GLOBALS['USER']['securitylevel'] < 255) {
    die('<br /><h4>You do not have access to this page. Press the BACK button on your browser.</h4>');
}

if (isset($_GET['u'])) {
    $userno = (integer) $_GET['u'];
} else {
    $userno = 1;
}


// This will allow redirects for "Back to Previous Page" without the nesting problems with 'referer', etc..
// Just load your links to the UserInfo page with &ref=referring-page (and any other vars) and place
// that in the switches below
if (isset($_GET['ref'])) {
    switch($_GET['ref']) {
        case 'userlist':
            // They came from the User List page
            $retURL = $rootDir . 'misc/userlist.php';
            $retTXT = 'User Listing';
            break;
        case 'profile':
            // They came from the User's Info (Profile) page

            // Check to see if they came from VConfig
            if (isset($_GET['prev']) && $_GET['prev'] == 'whosonweb2') { $cfglink = 1; }

            $retURL = $rootDir . 'misc/userinfo.php?u='.$_GET['u'].(isset($_GET['prev']) ? '&ref='.$_GET['prev'] : '').(isset($cfglink) ? '&prev=vconfig' : '').(isset($_GET['results']) ? '&results='.$_GET['results'].'&show' : '').(isset($_GET['view']) ? '&view='.$_GET['view'] : '').(isset($_GET['cfg']) ? '&cfg='.$_GET['cfg'] : '');
            $retTXT = 'Profile Page';
            break;
        case 'voteresults':
            // They came from the Voting Show Responses page
            $retURL = $rootDir . 'misc/vote.php' . (isset($_GET['results']) ? '?results='.$_GET['results'].'&show' : '');
            $retTXT = 'View Results';
            break;
        case 'whosonweb':
            // They came from the View All Web-Users page
            $retURL = $rootDir . 'misc/webuserlist.php';
            $retTXT = 'View All Web Users';
            break;
        case 'whosonweb2':
            // They came from the View All Web-Users page (via VConfig)
            $retURL = $rootDir . 'misc/webuserlist.php?ref=vconfig' . (isset($_GET['cfg']) ? '&cfg='.$_GET['cfg'] : '');
            $retTXT = 'View All Web Users';
            break;
        case 'viewmsg':
            // They came from a View Message page
            $retURL = $rootDir . 'forums/forum-viewmsg.php?t='.$_GET['t'].'&d='.$_GET['d'].'&m='.$_GET['m'];
            $retTXT = 'View Message';
            break;
        case 'viewfile':
            // They came from a View File page
            $retURL = $rootDir . 'forums/files-viewmsg.php?t='.$_GET['t'].'&d='.$_GET['d'].'&m='.$_GET['m'];
            $retTXT = 'View File';
            break;
        case 'viewemail':
            // They came from a View Email Message page
            $retURL = $rootDir . 'forums/email-viewmsg.php?&m='.$_GET['m'];
            $retTXT = 'View Email';
            break;
        case 'sentemail':
            // They came from their View Sent Email Message page
            $retURL = $rootDir . 'forums/sentemail-viewmsg.php?&m='.$_GET['m'];
            $retTXT = 'Sent Email';
            break;
        default:
            break;
    }
}


if ((isset($_GET['delete'])) &&
    ($_GET['delete'] == 1)) {
    $classVadvUsers->Delete($userno);
    RedirectUser(GetCurrentURL(0) . '?u=' . $userno);
}

$user = $classUserfileDat->Get($userno);
$VA_NETWORKS = $classNetworks->GetNetworkInfo();


// Get required info flags.
$required = GetAccFlags($GLOBALS['CONFIG']['newuserreq']);



// Include our javascript in header
$requireCheck = '';

if (is_int(strpos($required, 'A'))) { $requireCheck .= "(form.realname.value.length == 0) ||\n"; }
if (is_int(strpos($required, 'B'))) { $requireCheck .= "(form.address.value.length == 0) ||\n"; }
if (is_int(strpos($required, 'C'))) { $requireCheck .= "(form.city.value.length == 0) ||\n"; }
if (is_int(strpos($required, 'D'))) { $requireCheck .= "(form.state.value.length == 0) ||\n"; }
if (is_int(strpos($required, 'E'))) { $requireCheck .= "(form.zipcode.value.length == 0) ||\n"; }
if (is_int(strpos($required, 'F'))) { $requireCheck .= "(form.voice.value.length == 0) ||\n"; }
if (is_int(strpos($required, 'G'))) { $requireCheck .= "(form.data.value.length == 0) ||\n"; }

$hdr_include .= '<script language="JavaScript" type="text/javascript">' . "\n";
$hdr_include .= '<!--' . "\n";
$hdr_include .= '    function validate(form) {' . "\n";
$hdr_include .= '        if (' . $requireCheck;
$hdr_include .= '            (0 == 1)) {' . "\n";
$hdr_include .= '            alert("Please fill out all required fields.");' . "\n";
$hdr_include .= '            form.realname.focus();' . "\n";
$hdr_include .= '            return false;' . "\n";
$hdr_include .= '        }' . "\n";
$hdr_include .= '        if (form.bdayyear.value.length < 4) {' . "\n";
$hdr_include .= '            alert("The birthday year must be in a four-digit format.");' . "\n";
$hdr_include .= '            form.bdayyear.focus();' . "\n";
$hdr_include .= '            return false;' . "\n";
$hdr_include .= '        }' . "\n";
$hdr_include .= '    }' . "\n";
$hdr_include .= '    function HelpWindow(hpath, bmark) {' . "\n";
$hdr_include .= '        var url = hpath + "#" + bmark;' . "\n";
$hdr_include .= '        var newwindow = window.open(url, "helpwindow", "toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=yes, resizable=no, width=350, height=450");' . "\n";
$hdr_include .= '        newwindow.focus();' . "\n";
$hdr_include .= '    }' . "\n";
$hdr_include .= '//-->' . "\n";
$hdr_include .= '</script>' . "\n";




// Output header
include($themepath . "/templates/header.php");

$error = '';

if (isset($_GET['error'])) {
    switch ($_GET['error']) {
        case 'realname':
            $error = 'You must enter your real name.';
            break;
        case 'address':
            $error = 'You must enter your address.';
            break;
        case 'city':
            $error = 'You must enter your city.';
            break;
        case 'state':
            $error = 'You must enter your state.';
            break;
        case 'zipcode':
            $error = 'You must enter your zip code.';
            break;
        case 'voice':
            $error = 'You must enter your phone number, including area code.';
            break;
        case 'data':
            $error = 'You must enter your fax/data number, including area code.';
            break;
        default:
            $error = '';
    }
}

// Break apart phone number for form use variables
$phone1a = strtok($user['phone1'], "-");
$phone1b = strtok("-");
$phone1c = strtok("-");

$phone2a = strtok($user['phone2'], "-");
$phone2b = strtok("-");
$phone2c = strtok("-");

// Parse and format user's last logon date info
$last = substr($user['laston'], 2, 2) . '/' . substr($user['laston'], 4, 2) . '/' . substr($user['laston'], 0, 2);
$last = strtotime($last);
$laston = date("m/d/Y", $last);
$days = CalcDayNumber(date("m"), date("d"), date("Y")) - CalcDayNumber(date("m", $last), date("d", $last), date("Y", $last));
$lastOn = $laston . ' (' . $days . ' day' . ($days > 1 || $days == 0 ? 's' : '') . ' ago)';

// Calculate user's time left today
if ($user['laston'] != date("ymd")) {
    $timeleft = $user['maxtime'];
} else {
    $timeleft = $user['maxtime'] - $user['timecounter'];
}

// Set up video mode form select elements as an array
$vmodeOption = array(
                0 => array('name'=>'ASCII', 'selected'=>((int)$user['videomode'] == 0 ? 'selected' : '')),
                1 => array('name'=>'ANSI', 'selected'=>((int)$user['videomode'] == 1 ? 'selected' : '')),
                2 => array('name'=>'Enhanced ANSI', 'selected'=>((int)$user['videomode'] == 2 ? 'selected' : '')),
                3 => array('name'=>'RIP Graphics', 'selected'=>((int)$user['videomode'] == 3 ? 'selected' : '')),
                4 => array('name'=>'Virtual Windows Client', 'selected'=>((int)$user['videomode'] == 4 ? 'selected' : ''))
                );


// Set up mail forwarding options
$mailFwdValue = '';
$localSelect = '';

if (($user['mailfwdflag'] == 1) && ($user['mailfwduserno'] != '')) {
    $mailFwdValue = $user['mailfwduserno'] . '@' . $user['mailfwdnode'];
} else if (($user['mailfwdflag'] == 1) && ($user['mailfwdhandle'] != '')) {
    $mailFwdValue = $user['mailfwdhandle'] . '@' . $user['mailfwdnode'];
}

if (($user['mailfwdflag'] == 1) &&
    ($user['mailfwdnetno'] == 1) &&
    ($user['mailfwdnetnode'] == $VA_NEWORKS[1]['settings']['systemid'])) {
    $localSelect = ' selected';
}

$cnt = 0;
$net = array();
foreach($VA_NETWORKS as $netInfo) {

    if ((isset($netInfo['nettype'])) &&
        ($netInfo['nettype'] != 2) &&   // If not a VLive network
        ($netInfo['nettype'] != 5)) {   // If not a QWK network

        if ((isset($netInfo['settings']['systemid'])) && ($netInfo['settings']['systemid'] != '0')) {

            if (($GLOBALS['USER']['securitylevel'] >= 255) ||
                ($netInfo['accflag'] == '') ||  // If a access flag is set..
                (strpos($GLOBALS['USER']['flags'], $netInfo['accflag']) !== FALSE)) {   // If the user has the flag

                    switch ($netInfo['nettype']) {
                        case 1:
                            $type = 'VirtualNET';
                            break;
                        case 3:
                            $type = 'Internet';
                            break;
                        case 4:
                            $type = 'FIDOnet';
                            break;
                        case 9:
                            $type = 'WWIVnet';
                            break;
                        default:
                            $type = 'Unknown';
                            break;
                    }

                    $net[$cnt]['netno'] = $netInfo['netno'];
                    $net[$cnt]['desc'] = $netInfo['desc'];
                    $net[$cnt]['sortdesc'] = strtolower($netInfo['desc']);
                    $net[$cnt]['type'] = $type;
                    $cnt++;
                }
            }
        }
    }

    // Organize the array alphabetically by description.
    $sortarr = array();
    foreach ($net as $row) {
    $sortarr[] = $row['sortdesc'];
}
array_multisort($sortarr, $net);

// Set up Prev/Next User links
$prevUser = 'u='.($user['userno'] - 1).(isset($_GET['ref']) ? '&ref='.$_GET['ref'] : '').(isset($_GET['prev']) ? '&prev='.$_GET['prev'] : '').(isset($_GET['results']) ? '&results='.$_GET['results'].'&show' : '').(isset($_GET['view']) ? '&view='.$_GET['view'] : '').(isset($_GET['t']) ? '&t='.$_GET['t'] : '').(isset($_GET['d']) ? '&d='.$_GET['d'] : '').(isset($_GET['m']) ? '&m='.$_GET['m'] : '').(isset($_GET['cfg']) ? '&cfg='.$_GET['cfg'] : '');

$nextUser = 'u='.($user['userno'] + 1).(isset($_GET['ref']) ? '&ref='.$_GET['ref'] : '').(isset($_GET['prev']) ? '&prev='.$_GET['prev'] : '').(isset($_GET['results']) ? '&results='.$_GET['results'].'&show' : '').(isset($_GET['view']) ? '&view='.$_GET['view'] : '').(isset($_GET['t']) ? '&t='.$_GET['t'] : '').(isset($_GET['d']) ? '&d='.$_GET['d'] : '').(isset($_GET['m']) ? '&m='.$_GET['m'] : '').(isset($_GET['cfg']) ? '&cfg='.$_GET['cfg'] : '');

// Output page
include($themepath . "/templates/admin/admin_usereditor.php");

// Output footer
include($themepath . "/templates/footer.php");


?>