<?php
/*
 * ----------------------------------------------------------------------------
 * EditUser_Process.php                                              12/22/2009
 * This script will process the usereditor form.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2008 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

$GLOBALS['VA_ACTION'] = 'SysOp Function';

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');

$classUserfileDat = new datUserfile;
$classUserfileIdx = new idxUserfile;
$classVADVPHPDat = new datVADVPHP;

if (($GLOBALS['USER']['securitylevel'] < 255) ||
    (($GLOBALS['USER']['userno'] == 0) ||
     ($GLOBALS['USER']['userno'] == $GLOBALS['CONFIG']['guestacct']))) {
    RedirectUser($rootDir . 'index.php');
}

if ((!isset($_SERVER['HTTP_REFERER'])) ||
    (strpos($_SERVER['HTTP_REFERER'], $_SERVER['HTTP_HOST']) === FALSE)) {
    die('<br /><h4>You are not allowed to access this script from an outside source.<br />Press the BACK button on your browser.</h4>');
}

if ((!isset($_POST['process'])) ||
    ($_POST['process'] != 1)) {
    die('<br /><h4>Invalid parameters. Please press the BACK button on your browser.</h4>');
}
if (!isset($_POST['submit'])) {
    die('<br /><h4>Invalid parameters. Please press the BACK button on your browser.</h4>');
}

if (!isset($_POST['userno'])) {
    die('<br /><h4>Invalid information. Please press the BACK button on your browser.</h4>');
} else {
    $user = $classUserfileDat->Get($_POST['userno']);
    $edituser = $user;
}


// Format variables.
$_POST['handle'] = trim($_POST['handle']);
$_POST['realname'] = ucwords(trim(strtolower($_POST['realname'])));
$_POST['address'] = ucwords(trim(strtolower($_POST['address'])));
$_POST['city'] = ucwords(trim(strtolower($_POST['city'])));
$_POST['state'] = trim(strtoupper($_POST['state']));
$_POST['zipcode'] = trim($_POST['zipcode']);
$_POST['phone1a'] = trim($_POST['phone1a']);
$_POST['phone1b'] = trim($_POST['phone1b']);
$_POST['phone1c'] = trim($_POST['phone1c']);
$_POST['phone2a'] = trim($_POST['phone2a']);
$_POST['phone2b'] = trim($_POST['phone2b']);
$_POST['phone2c'] = trim($_POST['phone2c']);
$_POST['bdaymonth'] = (integer) $_POST['bdaymonth'];
$_POST['bdayday'] = (integer) $_POST['bdayday'];
$_POST['bdayyear'] = (integer) $_POST['bdayyear'];
$_POST['bbspassword'] = trim(strtoupper($_POST['bbspassword']));
$_POST['bbsverify'] = trim(strtoupper($_POST['bbsverify']));
$_POST['webpassword'] = trim(strtoupper($_POST['webpassword']));
$_POST['webverify'] = trim(strtoupper($_POST['webverify']));
$_POST['securitylevel'] = (integer) $_POST['securitylevel'];
$_POST['maxtime'] = (integer) $_POST['maxtime'];
$_POST['timebank'] = (integer) $_POST['timebank'];
$_POST['credits'] = (integer) $_POST['credits'];
$_POST['flags'] = trim($_POST['flags']);
$_POST['accflags'] = trim($_POST['accflags']);
$_POST['pagebreak'] = (integer) $_POST['pagebreak'];
$_POST['videomode'] = (integer) $_POST['videomode'];
$_POST['protocol'] = trim(strtoupper($_POST['protocol']));
$_POST['liststyle'] = (integer) $_POST['liststyle'];
if (isset($_POST['sortfilelst'])) {
    $_POST['sortfilelst'] = 1;
} else {
    $_POST['sortfilelst'] = 0;
}
if (isset($_POST['ratioexempt'])) {
    $_POST['ratioexempt'] = 0;
} else {
    $_POST['ratioexempt'] = 1;
}
if (isset($_POST['verifybday'])) {
    $_POST['verifybday'] = 1;
} else {
    $_POST['verifybday'] = 0;
}
$_POST['mailfwd'] = trim($_POST['mailfwd']);
$_POST['mailfwdnetno'] = (integer) $_POST['mailfwdnetno'];
$_POST['extra1'] = trim($_POST['extra1']);
$_POST['extra2'] = trim($_POST['extra2']);
$_POST['extra3'] = trim($_POST['extra3']);
$_POST['extra4'] = trim($_POST['extra4']);
$_POST['extra5'] = trim($_POST['extra5']);
$_POST['extra6'] = trim($_POST['extra6']);
$_POST['extra7'] = trim($_POST['extra7']);
$_POST['extra8'] = trim($_POST['extra8']);
$_POST['comment'] = trim($_POST['comment']);
$_POST['totalcalls'] = (integer) $_POST['totalcalls'];
$_POST['totaltime'] = (integer) $_POST['totaltime'];
$_POST['uplfiles'] = (integer) $_POST['uplfiles'];
$_POST['uplkb'] = (integer) $_POST['uplkb'];
$_POST['dlfiles'] = (integer) $_POST['dlfiles'];
$_POST['dlkb'] = (integer) $_POST['dlkb'];
$_POST['totalposts'] = (integer) $_POST['totalposts'];
$_POST['totalemail'] = (integer) $_POST['totalemail'];

// Check the birthday field.
if (strlen($_POST['bdayyear']) == 2) {
    $_POST['bdayyear'] == '19' . $_POST['bdayyear'];
}

// Fix the referer URL. Make sure there is no query string.
$url = parse_url($_POST['referer']);
$referer = $url['scheme'] . '://' . $url['host'] . $url['path'];


// Check for required information.
// Convert into a string.
$required = ' ' . GetAccFlags($GLOBALS['CONFIG']['newuserreq']);

if ((is_int(strpos($required, 'A'))) &&
    ($_POST['realname'] == '')) {
    RedirectUser($referer . '?' . $_POST['userno'] . '&error=realname');
}
if ((is_int(strpos($required, 'B'))) &&
    ($_POST['address'] == '')) {
    RedirectUser($referer . '?' . $_POST['userno'] . '&error=address');
}
if ((is_int(strpos($required, 'C'))) &&
    ($_POST['city'] == '')) {
    RedirectUser($referer . '?' . $_POST['userno'] . '&error=city');
}
if ((is_int(strpos($required, 'D'))) &&
    ($_POST['state'] == '')) {
    RedirectUser($referer . '?' . $_POST['userno'] . '&error=state');
}
if ((is_int(strpos($required, 'E'))) &&
    ($_POST['zipcode'] == '')) {
    RedirectUser($referer . '?' . $_POST['userno'] . '&error=zipcode');
}
if ((is_int(strpos($required, 'F'))) &&
    ($_POST['phone1a'] == '' || $_POST['phone1b'] == '' || $_POST['phone1c'] == '')) {
    RedirectUser($referer . '?' . $_POST['userno'] . '&error=voice');
}
if ((is_int(strpos($required, 'G'))) &&
    ($_POST['phone2'] == '' || $_POST['phone2b'] == '' || $_POST['phone2c'] == '')) {
    RedirectUser($referer . '?' . $_POST['userno'] . '&error=data');
}

$phone1 = $_POST['phone1a'] . "-" . $_POST['phone1b'] . "-" . $_POST['phone1c'];
$phone2 = $_POST['phone2a'] . "-" . $_POST['phone2b'] . "-" . $_POST['phone2c'];



if ($_POST['handle'] != $user['handle'])   {
    $edituser['handle'] = $_POST['handle'];
    $useridx['handle'] = $_POST['handle'];
}
if ($_POST['realname'] != $user['realname']) {
    $edituser['realname'] = $_POST['realname'];
    $useridx['realname'] = $_POST['realname'];
}
if ($_POST['address'] != $user['address']) {
    $edituser['address'] = $_POST['address'];
}
if ($_POST['city'] != $user['city']) {
    $edituser['city'] = $_POST['city'];
}
if ($_POST['state'] != $user['state']) {
    $edituser['state'] = $_POST['state'];
}
if ($_POST['zipcode'] != $user['zipcode']) {
    $edituser['zipcode'] = $_POST['zipcode'];
}
if ($phone1 != $user['phone1']) {
    $edituser['phone1'] = $phone1;
}
if ($phone2 != $user['phone2']) {
    $edituser['phone2'] = $phone2;
}
if ($_POST['bdaymonth'] != $user['bdaymonth']) {
    $edituser['bdaymonth'] = $_POST['bdaymonth'];
}
if ($_POST['bdayday'] != $user['bdayday']) {
    $edituser['bdayday'] = $_POST['bdayday'];
}
if ($_POST['bdayyear'] != $user['bdayyear']) {
    $edituser['bdayyear'] = $_POST['bdayyear'];
}
if ($_POST['securitylevel'] != $user['securitylevel']) {
    $edituser['securitylevel'] = $_POST['securitylevel'];
}
if ($_POST['maxtime'] != $user['maxtime']) {
    $edituser['maxtime'] = $_POST['maxtime'];
}
if ($_POST['timebank'] != $user['timebank']) {
    $edituser['timebank'] = $_POST['timebank'];
}
if ($_POST['credits'] != $user['credits']) {
    $edituser['credits'] = $_POST['credits'];
}
if ($_POST['flags'] != $user['flags']) {
    $edituser['flags'] = $_POST['flags'];
}
if ($_POST['accflags'] != $user['accflags']) {
    $edituser['accflags'] = $_POST['accflags'];
}
if ($_POST['pagebreak'] != $user['pagebreak']) {
    $edituser['pagebreak'] = $_POST['pagebreak'];
}
if ($_POST['videomode'] != $user['videomode']) {
    $edituser['videomode'] = $_POST['videomode'];
}
if ($_POST['protocol'] != $user['protocol']) {
    $edituser['protocol'] = $_POST['protocol'];
}
if ($_POST['liststyle'] != $user['liststyle']) {
    $edituser['liststyle'] = $_POST['liststyle'];
}
if ($_POST['sortfilelst'] != $user['sortfilelst']) {
    $edituser['sortfilelst'] = $_POST['sortfilelst'];
}
if ($_POST['ratioexempt'] != $user['ratioexempt']) {
    $edituser['ratioexempt'] = $_POST['ratioexempt'];
}
if ($_POST['verifybday'] != $user['verifybday']) {
    $edituser['verifybday'] = $_POST['verifybday'];
}
if ($_POST['extra1'] != $user['extra1']) {
    $edituser['extra1'] = $_POST['extra1'];
}
if ($_POST['extra2'] != $user['extra2']) {
    $edituser['extra2'] = $_POST['extra2'];
}
if ($_POST['extra3'] != $user['extra3']) {
    $edituser['extra3'] = $_POST['extra3'];
}
if ($_POST['extra4'] != $user['extra4']) {
    $edituser['extra4'] = $_POST['extra4'];
}
if ($_POST['extra5'] != $user['extra5']) {
    $edituser['extra5'] = $_POST['extra5'];
}
if ($_POST['extra6'] != $user['extra6']) {
    $edituser['extra6'] = $_POST['extra6'];
}
if ($_POST['extra7'] != $user['extra7']) {
    $edituser['extra7'] = $_POST['extra7'];
}
if ($_POST['extra8'] != $user['extra8']) {
    $edituser['extra8'] = $_POST['extra8'];
}
if ($_POST['comment'] != $user['comment']) {
    $edituser['comment'] = $_POST['comment'];
}
if ($_POST['totalcalls'] != $user['totalcalls']) {
    $edituser['totalcalls'] = $_POST['totalcalls'];
}
if ($_POST['totaltime'] != $user['totaltime']) {
    $edituser['totaltime'] = $_POST['totaltime'];
}
if ($_POST['uplfiles'] != $user['uplfiles']) {
    $edituser['uplfiles'] = $_POST['uplfiles'];
}
if ($_POST['uplkb'] != $user['uplkb']) {
    $edituser['uplkb'] = $_POST['uplkb'];
}
if ($_POST['dlfiles'] != $user['dlfiles']) {
    $edituser['dlfiles'] = $_POST['dlfiles'];
}
if ($_POST['dlkb'] != $user['dlkb']) {
    $edituser['dlkb'] = $_POST['dlkb'];
}
if ($_POST['totalposts'] != $user['totalposts']) {
    $edituser['totalposts'] = $_POST['totalposts'];
}
if ($_POST['totalemail'] != $user['totalemail']) {
    $edituser['totalemail'] = $_POST['totalemail'];
}

if ($_POST['timeleft'] != $user['maxtime'] - $user['timecounter']) {
    $edituser['timecounter'] = $edituser['maxtime'] - $_POST['timeleft'];
}

// If password change...
if ($_POST['bbspassword'] != '' && $_POST['bbsverify'] != '') {
    $password = $_POST['bbspassword'];
    $verify = $_POST['bbsverify'];
    if ($password === $verify) {
        $edituser['password'] = $password;
        if ($_POST['userno'] == $GLOBALS['USER']['userno']) {
            $GLOBALS['USER']['password'] = hash($GLOBALS['CONFIG']['encryption'], $password);

            // Change session password.
            $_SESSION['password'] = base64_encode(hash($GLOBALS['CONFIG']['encryption'], $password));
        }
    }
}

// Mail forwarding...
if (trim($_POST['mailfwd']) != '') {
    $pos = strpos($_POST['mailfwd'], '@');
    if ($pos !== FALSE) {
        $to = substr($_POST['mailfwd'], 0, $pos);
        $node = substr($_POST['mailfwd'], $pos + 1);
        if (intval($to) > 0) {
            $edituser['mailfwdhandle'] = '';
            $edituser['mailfwduserno'] = $to;
        } else {
            $edituser['mailfwdhandle'] = $to;
            $edituser['mailfwduserno'] = 0;
        }
        $edituser['mailfwdflag'] = 1;
        $edituser['mailfwdnode'] = $node;
        $edituser['mailfwdnetno'] = $_POST['mailfwdnetno'];
    }
} else {
    $edituser['mailfwdflag'] = 0;
    $edituser['mailfwdhandle'] = '';
    $edituser['mailfwduserno'] = 0;
    $edituser['mailfwdnode'] = '';
    $edituser['mailfwdnetno'] = 0;
}

// Write new DAT file.
if (isset($edituser)) {
    // Get the file string.
    $fileString = $classUserfileDat->Read();

    // Put the new information into the file string.
    $fileString = $classUserfileDat->Put($fileString, $user['userno'], $edituser);

    // Write the new file.
    $classUserfileDat->Write($fileString);
}

// Write new IDX file.
if (isset($useridx)) {
    $fileString = $classUserfileIdx->Read();
    $fileString = $classUserfileIdx->Put($fileString, $user['userno'], $useridx);
    $classUserfileIdx->Write($fileString);
}

// If vadv-php password change...
if ((isset($_POST['resetwebpassword'])) &&
    (intval($_POST['resetwebpassword']) == 1)) {
    $newsettings['password'] = '';
    if ($_POST['userno'] == $GLOBALS['USER']['userno']) {
        $_SESSION['password'] = base64_encode($GLOBALS['USER']['password']);
    }
} else {
    if ((isset($_POST['webpassword'])) &&
        ($_POST['webpassword'] != '') &&
        (isset($_POST['webverify'])) &&
        ($_POST['webverify'] != '')) {
        $password = $_POST['webpassword'];
        $verify = $_POST['webverify'];

        if ($password === $verify) {
            $newsettings['password'] = hash($GLOBALS['CONFIG']['encryption'], $password);
            if ($_POST['userno'] == $GLOBALS['USER']['userno']) {

                // Change session password.
                $_SESSION['password'] = base64_encode(hash($GLOBALS['CONFIG']['encryption'], $password));
            }
        }
    }
}

if (isset($newsettings)) {
    $fileString = $classVADVPHPDat->Read();
    $fileString = $classVADVPHPDat->Put($fileString, $_POST['userno'], $newsettings);
    $classVADVPHPDat->Write($fileString);
}

$errortype = "Edit User Information";
$message = '<br />User\'s Information Saved.<br /><br />';
$message .= 'You will now be redirected to the previous page.<br /><br />';
$redirectURL = $_POST['referer'];
$delay = 3;
include($themepath . '/templates/header.php');
include($themepath . '/templates/errmsg.php');
include($themepath . '/templates/footer.php');
?>