<?php
/*
 * ----------------------------------------------------------------------------
 * UserInfo.php                                                      12/22/2009
 * This script will display information about selected users.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2008 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

$GLOBALS['VA_ACTION'] = 'Viewing User Profile';

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');

$classUserfileDat = new datUserfile;

// Set the passed variables.
// Usernumber.
if (isset($_GET['u'])) {
    $userno = (integer) $_GET['u'];
} else {
    RedirectUser($rootDir . 'index.php');
}

// Get the user's information.
$user = $classUserfileDat->Get($userno);


// This will allow redirects for "Back to Previous Page" without the nesting problems with 'referer', etc..
// Just load your links to the UserInfo page with &ref=referring-page (and any other vars) and place
// that in the switches below
if (isset($_GET['ref'])) {
    switch($_GET['ref']) {
        case 'userlist':
            // They came from the User Listing page
            $retURL = $rootDir . 'misc/userlist.php';
            $retTXT = 'User Listing';
            break;
        case 'whosonweb':
            // They came from the View All Web-Users page (Index link)
            $retURL = $rootDir . 'misc/webuserlist.php' . (isset($_GET['prev']) ? '?ref='.$_GET['prev'] : '');
            $retTXT = 'View All Web Users';
            break;
        case 'whosonweb2':
            // They came from the View All Web-Users page (VConfig link)
            $retURL = $rootDir . 'misc/webuserlist.php' . (isset($_GET['prev']) ? '?ref='.$_GET['prev'] : '').(isset($_GET['cfg']) ? '&cfg='.$_GET['cfg'] : '');
            $retTXT = 'View All Web Users';
            break;
        case 'whosonline':
            // They came from the Who's Online page
            $retURL = $rootDir . 'misc/who.php';
            $retTXT = 'Who\'s Online';
            break;
        case 'toplist':
            // They came from a Top List Ranking page
            $retURL = $rootDir . 'misc/topten.php' . (isset($_GET['view']) ? '?view='.$_GET['view'] : '');
            $retTXT = 'Top Lists';
            break;
        case 'voteresults':
            // They came from the Voting Show Responses page (SysOp link)
            $retURL = $rootDir . 'misc/vote.php' . (isset($_GET['results']) ? '?results='.$_GET['results'].'&show' : '');
            $retTXT = 'View Results';
            break;
        case 'vconfig':
            // They came from the Voting Show Responses page (SysOp link)
            $retURL = $rootDir . 'vconfig/vconfig.php' . (isset($_GET['cfg']) ? '?cfg='.$_GET['cfg'] : '');
            $retTXT = 'VADV-PHP VConfig';
            break;
        default:
            break;
    }
}


// Output header
$pagetitle = 'User Information';
include($themepath . '/templates/header.php');



if (intval($user['laston']) == 0) {
    $user['laston'] = '000000';
}
$laston = substr($user['laston'], 2, 2) . '/' . substr($user['laston'], 4, 2) . '/' . substr($user['laston'], 0, 2);

$bmonth = '';
for ($i=1; $i<13; $i++) {
    if ($user['bdaymonth'] == '1') { $bmonth = 'Jan'; }
    if ($user['bdaymonth'] == '2') { $bmonth = 'Feb'; }
    if ($user['bdaymonth'] == '3') { $bmonth = 'Mar'; }
    if ($user['bdaymonth'] == '4') { $bmonth = 'Apr'; }
    if ($user['bdaymonth'] == '5') { $bmonth = 'May'; }
    if ($user['bdaymonth'] == '6') { $bmonth = 'Jun'; }
    if ($user['bdaymonth'] == '7') { $bmonth = 'Jul'; }
    if ($user['bdaymonth'] == '8') { $bmonth = 'Aug'; }
    if ($user['bdaymonth'] == '9') { $bmonth = 'Sep'; }
    if ($user['bdaymonth'] == '10') { $bmonth = 'Oct'; }
    if ($user['bdaymonth'] == '11') { $bmonth = 'Nov'; }
    if ($user['bdaymonth'] == '12') { $bmonth = 'Dec'; }
}

$tagline = $GLOBALS['USER_SETTINGS']['tagline'] != '0' ? $GLOBALS['USER_SETTINGS']['tagline'] == '1' ? $user['macro1'] : $user['macro2'] : '';


$edLink = '?u='.$user['userno'].'&ref=profile'.(isset($_GET['ref']) ? '&prev='.$_GET['ref'] : '').(isset($_GET['results']) ? '&results='.$_GET['results'].'&show' : '').(isset($_GET['view']) ? '&view='.$_GET['view'] : '').(isset($_GET['cfg']) ? '&cfg='.$_GET['cfg'] : '');

// Output page
include($themepath . '/templates/profile.php');

// Output footer
include($themepath . '/templates/footer.php');

?>