<?php
/*
 * ----------------------------------------------------------------------------
 * UserList.php                                                      12/22/2009
 * This script will print out a listing of all users.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2009 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

$GLOBALS['VA_ACTION'] = 'Viewing User List';

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');

$classUserfileDat = new datUserfile;

define('NOINDEX', true);

// Output header
$pagetitle = 'User List';
include($themepath . '/templates/header.php');




if (isset($_GET['compress'])) {
    $_GET['compress'] = (boolean) $_GET['compress'];
    if (($_GET['compress']) &&
        ($GLOBALS['USER']['securitylevel'] >= 255)) {
        $classUserfileDat->Compress();
    }
}

if ((isset($_GET['sort'])) &&
    (((trim(strtolower($_GET['sort'])) == 'userno') ||
      (trim(strtolower($_GET['sort'])) == 'handle') ||
      (trim(strtolower($_GET['sort'])) == 'realname') ||
      (trim(strtolower($_GET['sort'])) == 'city') ||
      (trim(strtolower($_GET['sort'])) == 'state') ||
      (trim(strtolower($_GET['sort'])) == 'laston')) ||
      (($GLOBALS['USER']['securitylevel'] >= 255) &&
       (trim(strtolower($_GET['sort'] == 'securitylevel')))))) {
    $sort = trim(strtolower($_GET['sort']));
} else {
    $sort = 'userno';
}
if (isset($_GET['order'])) {
    $order = (boolean) $_GET['order'];
} else {
    // Default = ascending
    $order = FALSE;
}


// Set up sorting toggles
$usort = $hsort = $rnsort = $csort = $ssort = $lsort = $secsort = '';
if (($sort == 'userno') && (!$order)) {
    $usort = '&order=1';
}
if (($sort == 'handle') && (!$order)) {
    $hsort = '&order=1';
}
if (($sort == 'realname') && (!$order)) {
    $rnsort = '&order=1';
}
if (($sort == 'city') && (!$order)) {
    $csort = '&order=1';
}
if (($sort == 'state') && (!$order)) {
    $ssort = '&order=1';
}
if (($sort != 'laston') || ($sort == 'laston') && (!$order)) {
    $lsort = '&order=1';
}
if ($GLOBALS['USER']['securitylevel'] >= 255) {
    if (($sort != 'securitylevel') || ($sort == 'securitylevel') && (!$order)) {
        $secsort = '&order=1';
    }
}


// Read the userfile.
$fileString = $classUserfileDat->Read();

// Determine the length of the file string.
$length = strlen($fileString);

// Set the file offset.
$offset = 1048;

// Set the starting position.
$position = 0;

// Create array used for sorting.
$userlist = array();

for ($i = 1; $position < $length; $i++) {
    $handle = GetString($fileString, 1 + $position, 40);
    $name = GetString($fileString, 41 + $position, 40);
    $city = GetString($fileString, 121 + $position, 32);
    $state = GetString($fileString, 153 + $position, 3);
    $laston = GetString($fileString, 376 + $position, 6);
    $lastcall = GetLongInt($fileString, 915 + $position);

    if (intval($laston) == 0) {
        $laston = '000000';
    }

    $seclevel = GetInteger($fileString, 374 + $position);

    if (($GLOBALS['USER']['securitylevel'] >= 255) ||
        ($seclevel > 0)) {
        $userlist[$i-1]['userno'] = $i;
        $userlist[$i-1]['handle'] = $handle;
        $userlist[$i-1]['realname'] = $name;
        $userlist[$i-1]['city'] = $city;
        $userlist[$i-1]['state'] = $state;
        $userlist[$i-1]['laston'] = $laston;
        $userlist[$i-1]['securitylevel'] = $seclevel;
        $userlist[$i-1]['sort'] = strtolower($userlist[$i-1][$sort]);
    }
    $position = $position + $offset;
}

// Sort the array.
$sortarr = array();
foreach ($userlist as $row) {
    $sortarr[] = $row['sort'];
}
if ($order) {
    array_multisort($sortarr, SORT_DESC, $userlist);
} else {
    array_multisort($sortarr, SORT_ASC, $userlist);
}
unset($sortarr);





// Output page
include($themepath . '/templates/userlisting.php');

// Output footer
include($themepath . '/templates/footer.php');

?>