<?php
/*
 * ----------------------------------------------------------------------------
 * Vote.inc.php                                                      12/22/2009
 * This script allows users to vote on questions setup by the SysOp. This uses
 * the internal voting booth from VADV. Questions and possible answers are
 * configured using VConfig.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2009 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

$GLOBALS['VA_ACTION'] = 'Voting Booth';

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');

$classUserfileDat = new datUserfile;
$classVadvUsers = new vadvUsers;
$classVoteCfg = new cfgVote;
$classVoteDat = new datVote;

$voteInf = $classVoteCfg->Get();


// Output header
$pagetitle = 'Voting Booth';
include($themepath . '/templates/header.php');



$vote = FALSE;
$results = FALSE;
$show = FALSE;

for ($i=0; $i<$voteInf[0]; $i++) {
    if (isset($_POST['dovote'.($i+1)])) {
        $_GET['vote'] = $i+1;
        break;
    }
    if (isset($_POST['doresult'.($i+1)])) {
        $_GET['results'] = $i+1;
        break;
    }
}


if (isset($_GET['vote'])) {
    $vote = TRUE;
    $results = FALSE;
    $question = (integer) $_GET['vote'];
}

if (isset($_GET['results'])) {
    $vote = FALSE;
    $results = TRUE;
    $question = (integer) $_GET['results'];
}

if (isset($_GET['show'])) {
    $show = TRUE;
}

if (isset($_POST['submit'])) {
    if ($_POST['submit'] == 'Cancel') {
        RedirectUser('vote.php');
    }
}




// Process votes.
if (($vote) && (isset($_POST['answer'])) && (IsLoggedIn())) {
    $answer = (integer) $_POST['answer'];
    $userVote = $classVoteDat->Get($GLOBALS['USER']['userno'], $question);
    if ($userVote == 0) {
        $log = 'Voting Booth    "' . $GLOBALS['USER']['handle'] . '" - "' . $voteInf[$question]['question'] . '" --> ' . $voteInf[$question]['resp' . $answer];

        // Log the vote.
        WriteLog('VADV-PHP.LOG', $log);
        $classVoteDat->Put($GLOBALS['USER']['userno'], $question, $answer);
        RedirectUser('vote.php?results=' . $question);
    } else {
        RedirectUser('vote.php');
    }
}

// Little var for the status line
$voted = 0;

// And one to allow public to view results (those that aren't logged in)
// (Change this to 0 to only allow logged in users to view results)
$allowPublicView = 1;

// Let the user vote on the passed question number.
if ($vote && IsLoggedIn()) {
    if ($classVoteDat->Get($GLOBALS['USER']['userno'], $question) > 0) {
        RedirectUser('vote.php');
    }

    // Output page
    include($themepath . '/templates/votequestion.php');
}

else

// Let the user view the results of the passed question number.
// TODO: Make the sysop "Show Responses" section split over multiple pages ******************************
//       if list gets long because of many users voting... -D-
if ($results && $allowPublicView) {

    // Output page
    include($themepath . '/templates/voteresults.php');
}

else

// Default to viewing the questions:
if (!$vote && !$results) {

    // Output page
    include($themepath . '/templates/votemain.php');
}




// Output footer
include($themepath . '/templates/footer.php');

?>