<?php
/*
 * ----------------------------------------------------------------------------
 * WebUserList.php                                                   12/22/2009
 * This script displays to the sysop the current web-users.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2009 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

$GLOBALS['VA_ACTION'] = 'SysOp Function';

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');

if (($GLOBALS['USER']['userno'] == 0) ||
    ($GLOBALS['USER']['userno'] == $GLOBALS['CONFIG']['guestacct'])) {
    RedirectUser($rootDir . 'bbslogin.php?url=' . urlencode(GetCurrentURL()));
}
if ($GLOBALS['USER']['securitylevel'] < 255) {
    $log = 'ERROR! "' . $GLOBALS['USER']['handle'] . '" - Attempted Unauthorized WebUserList Entry';
    WriteLog('VADV-PHP.LOG', $log);
    RedirectUser($rootDir . 'index.php');
}

if (isset($_GET['h'])) {
    $h = (integer) $_GET['h'];
} else {
    $h = 0;
}


// This will allow redirects for "Back to Previous Page" without the nesting problems with 'referer', etc..
// Just load your links to the UserInfo page with &ref=referring-page (and any other vars) and place
// that in the switches below
if (isset($_GET['ref'])) {
    switch($_GET['ref']) {
        case 'vconfig':
            // They came from their Profile page (The only other place they can edit their account is the main index, so we just need the profile ref here)
            $retURL = $rootDir . 'vconfig/vconfig.php' . (isset($_GET['cfg']) ? '?cfg='.$_GET['cfg'] : '');
            $retTXT = 'VADV-PHP VConfig';
            break;
        default:
            break;
    }
}


// Include tooltip javascript
$hdr_include .= '<script language="JavaScript" type="text/javascript" src="'.$includeDir.'javascript/tooltip.js"></script>' . "\n";


// Output header
include($themepath . '/templates/header.php');




// Set number of guests.
$guestno = 0;
$VAusers = array();

for ($i = 1; $i <= $GLOBALS['VA_USERS'][0]; $i++) {
    $VAusers[$i] = $GLOBALS['VA_USERS'][$i];

    // Count the guests.
    if ($VAusers[$i]['userno'] == 0) {
        $guestno++;
    }

    // Get user's hostname.
    if ($h == 1) {
        $VAusers[$i]['hostname'] = gethostbyaddr($VAusers[$i]['ip']);
    } else {
        $VAusers[$i]['hostname'] = '';
    }

    // Get user's time.
    $VAusers[$i]['lastTime'] = date("H:i:s", $VAusers[$i]['time']);
    $leftTime = 900 - (time() - $VAusers[$i]['time']);
    $VAusers[$i]['leftTime'] = date("H:i:s", mktime(0, 0, $leftTime));

    $VAusers[$i]['linkRef'] = '?u='.$VAusers[$i]['userno'].'&ref=whosonweb'.(isset($_GET['ref']) ? ($_GET['ref'] == 'vconfig' ? '2' : '').'&prev='.$_GET['ref'] : '').(isset($_GET['cfg']) ? '&cfg='.$_GET['cfg'] : '');
}





// Output page
include($themepath . '/templates/whosonlineweb.php');

// Output footer
include($themepath . '/templates/footer.php');

?>