<?php
/*
 * ----------------------------------------------------------------------------
 * Register.php                                                       12/22/2009
 * This is a new user registration screen for the BBS's VADV-PHP page.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2009 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

$GLOBALS['VA_ACTION'] = 'New User Registration';

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');

$classDatabases = new vadvDatabases;
$classNetworks = new vadvNetworks;
$classUserfileDat = new datUserfile;
$classUserfileIdx = new idxUserfile;
$classVadvUsers = new vadvUsers;



if ($GLOBALS['VA_MAIN']['newuserpw'] != hash($GLOBALS['CONFIG']['encryption'], strtoupper(''))) {
    die('<br /><h4>This BBS requires a new user password. Please connect to the BBS to create a new account. Press the BACK button on your browser.</h4>');
}
if (IsLoggedIn()) {
    die('<br /><h4>You already have an account and are logged in! Press the BACK button on your browser.</h4>');
}


// Get required info flags.
$required = GetAccFlags($GLOBALS['CONFIG']['newuserreq']);



// Include our javascript in header
$requireCheck = '';

if (is_int(strpos($required, 'A'))) { $requireCheck .= "(form.realname.value.length == 0) ||\n"; }
if (is_int(strpos($required, 'B'))) { $requireCheck .= "(form.address.value.length == 0) ||\n"; }
if (is_int(strpos($required, 'C'))) { $requireCheck .= "(form.city.value.length == 0) ||\n"; }
if (is_int(strpos($required, 'D'))) { $requireCheck .= "(form.state.value.length == 0) ||\n"; }
if (is_int(strpos($required, 'E'))) { $requireCheck .= "(form.zipcode.value.length == 0) ||\n"; }
if (is_int(strpos($required, 'F'))) { $requireCheck .= "(form.voice.value.length == 0) ||\n"; }
if (is_int(strpos($required, 'G'))) { $requireCheck .= "(form.data.value.length == 0) ||\n"; }
if (is_int(strpos($required, 'H'))) { $requireCheck .= "(form.bdaymonth.value.length == 0) || \n(form.bdayday.value.length == 0) || \n(form.bdayyear.value.length == 0) ||\n"; }

$hdr_include .= '<script language="JavaScript" type="text/javascript">' . "\n";
$hdr_include .= '<!--' . "\n";
$hdr_include .= '    function validate(form) {' . "\n";
$hdr_include .= '        if (' . $requireCheck;
$hdr_include .= '            (0 == 1)) {' . "\n";
$hdr_include .= '            alert("Please fill out all required fields.");' . "\n";
$hdr_include .= '            form.realname.focus();' . "\n";
$hdr_include .= '            return false;' . "\n";
$hdr_include .= '        }' . "\n";
$hdr_include .= '        if ((form.password.value.length > 8) ||' . "\n";
$hdr_include .= '            (form.verify.value.length > 8)) {' . "\n";
$hdr_include .= '            alert("The password cannot be longer than 8 characters.");' . "\n";
$hdr_include .= '            form.password.focus();' . "\n";
$hdr_include .= '            return false;' . "\n";
$hdr_include .= '        }' . "\n";
$hdr_include .= '        if (form.bdayyear.value.length < 4) {' . "\n";
$hdr_include .= '            alert("The birthday year must be in a four-digit format.");' . "\n";
$hdr_include .= '            form.bdayyear.focus();' . "\n";
$hdr_include .= '            return false;' . "\n";
$hdr_include .= '        }' . "\n";
$hdr_include .= '    }' . "\n";
$hdr_include .= '    function HelpWindow(hpath, bmark) {' . "\n";
$hdr_include .= '        var url = hpath + "#" + bmark;' . "\n";
$hdr_include .= '        var newwindow = window.open(url, "helpwindow", "toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=yes, resizable=no, width=350, height=450");' . "\n";
$hdr_include .= '        newwindow.focus();' . "\n";
$hdr_include .= '    }' . "\n";
$hdr_include .= '//-->' . "\n";
$hdr_include .= '</script>' . "\n";


// Output header
include($themepath . '/templates/header.php');




// Format the information.
$handle = isset($_POST['username']) ? trim($_POST['username']) : '';
$password = isset($_POST['password']) ? trim(strtoupper($_POST['password'])) : '';
$verify = isset($_POST['verify']) ? trim(strtoupper($_POST['verify'])) : '';
$realname = isset($_POST['realname']) ? ucwords(trim(strtolower($_POST['realname']))) : '';
$address = isset($_POST['address']) ? ucwords(trim(strtolower($_POST['address']))) : '';
$city = isset($_POST['city']) ? ucwords(trim(strtolower($_POST['city']))) : '';
$state = isset($_POST['state']) ? trim(strtoupper($_POST['state'])) : '';
$zipcode = isset($_POST['zipcode']) ? trim($_POST['zipcode']) : '';
$phone1a = isset($_POST['phone1a']) ? trim($_POST['phone1a']) : '';
$phone1b = isset($_POST['phone1b']) ? trim($_POST['phone1b']) : '';
$phone1c = isset($_POST['phone1c']) ? trim($_POST['phone1c']) : '';
$phone2a = isset($_POST['phone2a']) ? trim($_POST['phone2a']) : '';
$phone2b = isset($_POST['phone2b']) ? trim($_POST['phone2b']) : '';
$phone2c = isset($_POST['phone2c']) ? trim($_POST['phone2c']) : '';
$bdaymonth = isset($_POST['bdaymonth']) ? $_POST['bdaymonth'] : '';
$bdayday = isset($_POST['bdayday']) ? $_POST['bdayday'] : '';
$bdayyear = isset($_POST['bdayyear']) ? $_POST['bdayyear'] : '';

$error = '';
$create = false;


while (isset($_POST['submit'])) {
    // Check password length.
    if ((strlen($password) > 8) ||
        (strlen($verify) > 8)) {
        $error = 'Password cannot be longer than 8 characters.';
        break;
    }

    // Check the password.
    if (($password == '') || ($password != $verify)) {
        $error = 'Please verify your password again!';
        $password = '';
        break;
    }

    // Check the username.
    if (($handle == '') ||
        (is_numeric($handle)) ||                        // If it is a number.
        ($classVadvUsers->FindHandle($handle) > 0) ||   // Check if it already exists.
        (strtolower($handle) == 'new') ||               // Handles not allowed.
        (strtolower($handle) == '!-*<deleted>*-!') ||
        (strtolower($handle) == 'guest') ||
        (strtolower($handle) == 'sysop') ||
        (strtolower($handle) == 'postmaster') ||
        (strtolower($handle) == 'webmaster') ||
        (strtolower($handle) == 'all') ||
        (strtolower($handle) == 'allusers') ||
        (strtolower($handle) == 'all users') ||
        (strtolower($handle) == 'info') ||
        (strtolower($handle) == 'help') ||
        (strtolower($handle) == 'support') ||
        (strtolower($handle) == 'bbs')) {
        $error = 'That username/handle is not valid or is already being used. Please choose another.';
        break;
    }

    // Search for invalid words.
    $file = $GLOBALS['VA_SYSPATHS']['text'] . '/TRASHCAN.TXT';
    if (file_exists($file)) {
        // Read the file.
        $file = file($file);
        for ($i = 0; $i < count($file); $i++) {
            if (strpos(strtoupper($handle), trim(strtoupper($file[$i]))) !== FALSE) {
                $error = 'That username/handle is not allowed! Please choose another.';
                break;
            }
        }
        if ($error != '') {
            $handle = '';
            break;
        }
    }


    // Check for required information.
    // Convert into a string.
    $required = ' ' . GetAccFlags($GLOBALS['CONFIG']['newuserreq']);

    if ((is_int(strpos($required, 'A'))) && ($_POST['realname'] == '')) {
        $error = 'You must enter your real name.';
        break;
    }
    if ((is_int(strpos($required, 'B'))) && ($_POST['address'] == '')) {
        $error = 'You must enter your address.';
        break;
    }
    if ((is_int(strpos($required, 'C'))) && ($_POST['city'] == '')) {
        $error = 'You must enter your city.';
        break;
    }
    if ((is_int(strpos($required, 'D'))) && ($_POST['state'] == '')) {
        $error = 'You must enter your state.';
        break;
    }
    if ((is_int(strpos($required, 'E'))) && ($_POST['zipcode'] == '')) {
        $error = 'You must enter your ZIP code.';
        break;
    }
    if ((is_int(strpos($required, 'F'))) && ($_POST['phone1a'] == '' || $_POST['phone1b'] == '' || $_POST['phone1c'] == '')) {
        $error = 'You must enter your phone number, including area code.';
        break;
    }
    if ((is_int(strpos($required, 'G'))) && ($_POST['phone2'] == '' || $_POST['phone2b'] == '' || $_POST['phone2c'] == '')) {
        $error = 'You must enter your fax/data number, including area code.';
        break;
    }
    if ((is_int(strpos($required, 'H'))) && (($bdaymonth == '') || ($bdayday == '') || ($bdayyear == ''))) {
        $error = 'You must enter your birthday.';
        break;
    }

    // Check phone and data/fax numbers
    if ($phone1a != '' || $phone1b != '' || $phone1c != '') {
        if (!is_numeric($phone1a) || !is_numeric($phone1b) || !is_numeric($phone1c)) {
            $error = 'Phone number can only contain numbers.';
            break;
        }
    }
    if ($phone2a != '' || $phone2b != '' || $phone2c != '') {
        if (!is_numeric($phone2a) || !is_numeric($phone2b) || !is_numeric($phone2c)) {
            $error = 'Data/Fax number can only contain numbers.';
            break;
        }
    }
    $phone1 = $_POST['phone1a'] . "-" . $_POST['phone1b'] . "-" . $_POST['phone1c'];
    $phone2 = $_POST['phone2a'] . "-" . $_POST['phone2b'] . "-" . $_POST['phone2c'];


    // Check ZIP code
    if ($zipcode != '') {
        if (!is_numeric($zipcode)) {
            $error = 'ZIP Code must only contain numbers.';
            break;
        }
        if (strlen($zipcode) < 5) {
            $error = 'ZIP Code must be at least 5 numbers.';
        }
    }


    // Check the birthday date.
    if ($bdaymonth == '') {
        // If nothing is supplied,
        $bdaymonth = date("n");
    }
    if ($bdayday == '') {
        // the user will be just born :)
        $bdayday = date("j");
    }
    if ($bdayyear == '') {
        // So access maybe limited.
        $bdayyear = date("Y");
    }
    if (strlen($bdayyear) == 2) {
        $bdayyear = '19' . $bdayyear;
    }
    if ((((int)$bdaymonth < 1) || ((int)$bdaymonth > 12)) ||
        (((int)$bdayday   < 1) || ((int)$bdayday   > 31)) ||
        (((int)$bdayyear  < 1900) || ((int)$bdayyear > date("Y")))) {
        $error = 'The birthday date is invalid.';
        break;
    }

    $create = true;
    break;
}


if ($create) {
    // Setup user defaults.
    $newUser['userno'] = $classVadvUsers->FindNewAcct();

    // Check allow handle setting.
    if ($GLOBALS['VA_MAIN']['allowhandle'] == 1) {
        $newUser['handle'] = $handle;
    } else {
        $newUser['handle'] = $realname;
    }
    $newUser['realname'] = $realname;
    $newUser['address'] = $address;
    $newUser['city'] = $city;
    $newUser['state'] = $state;
    $newUser['zipcode'] = $zipcode;
    $newUser['phone1'] = $phone1;
    $newUser['phone2'] = $phone2;
    $newUser['password'] = $password;
    $newUser['mailfwdflag'] = 0;
    $newUser['mailfwdhandle'] = '';
    $newUser['mailfwduserno'] = 0;
    $newUser['mailfwdnode'] = 0;
    $newUser['mailfwdnetno'] = 0;
    $newUser['lngdistcost'] = 0;
    $newUser['lngdistacc'] = 0;
    $newUser['sortfilelst'] = 0;
    $newUser['pagebreak'] = 24;
    $newUser['bdaymonth'] = $bdaymonth;
    $newUser['bdayday'] = $bdayday;
    $newUser['bdayyear'] = $bdayyear;
    $newUser['accflags'] = '';
    $newUser['flags'] = 'F';
    $newUser['securitylevel'] = $GLOBALS['VA_MAIN']['newusersl'];
    $newUser['laston'] = date("ymd");
    $newUser['maxtime'] = $GLOBALS['VA_MAIN']['newusertime'];
    $newUser['timecounter'] = 0;
    $newUser['totalcalls'] = 0;
    $newUser['totaltime'] = 0;
    $newUser['videomode'] = 1;
    $newUser['ratioexempt'] = 1;
    $newUser['verifybday'] = 0;
    $newUser['textcolor'] = 7;
    $newUser['basecolor'] = 0;
    $newUser['promptcolor'] = 2;
    $newUser['inputcolor'] = 5;
    $newUser['boxcolor'] = 5;
    $newUser['mnuselcolor'] = 1;
    $newUser['headercolor'] = 2;
    $newUser['extra1'] = '';
    $newUser['extra2'] = '';
    $newUser['extra3'] = '';
    $newUser['extra4'] = '';
    $newUser['extra5'] = '';
    $newUser['extra6'] = '';
    $newUser['extra7'] = '';
    $newUser['extra8'] = '';
    $newUser['macro1'] = '';
    $newUser['macro2'] = '';
    $newUser['uplfiles'] = 0;
    $newUser['uplkb'] = 0;
    $newUser['dlfiles'] = 0;
    $newUser['dlkb'] = 0;
    $newUser['totalposts'] = 0;
    $newUser['totalemail'] = 0;
    $newUser['postsread'] = 0;
    $newUser['timebank'] = 0;
    $newUser['credits'] = $GLOBALS['VA_MAIN']['nucredits'];
    $newUser['comment'] = 'VADV-PHP';
    $newUser['protocol'] = 'Z';
    $newUser['testid1'] = '';
    $newUser['testid2'] = '';
    $newUser['offsym'] = '';
    $newUser['expdate'] = '';
    $newUser['reserved'] = '';
    $newUser['lastcalltime'] = lTime();
    $newUser['liststyle'] = 2;
    $newUser['extra'] = '';

    // Delete any mail addressed to this account.
    $db = $classDatabases->SetEmailInfo($newUser['userno']);
    $msgcnt = $db['msgcnt']['msgno'];
    $file = $GLOBALS['VA_SYSPATHS']['db'] . '/' . $db['filename'] . '.DAT';
    $fileString = ReadCfgFile($file);
    $pos = 0;
    for ($i = 1; (($i <= $db['msgno']) && ($msgcnt > 0)); $i++) {
        $db = $classDatabases->SetEmailInfo($newUser['userno']);
        $msgInfo = $classDatabases->GetMessageInfo($db, $i, $fileString);
        if ($msgInfo['touserno'] == $newUser['userno']) {
            $classDatabases->DeleteMessage($db, $i - $pos);
            $pos++;
        }
    }

    // Delete any sent email from this account.
    $db = $classDatabases->SetSentEmailInfo($newUser['userno']);
    $msgcnt = $db['msgcnt']['msgno'];
    $file = $GLOBALS['VA_SYSPATHS']['db'] . '/' . $db['filename'] . '.DAT';
    $fileString = ReadCfgFile($file);
    $pos = 0;
    for ($i = 1; (($i <= $db['msgno']) && ($msgcnt > 0)); $i++) {
        $db = $classDatabases->SetSentEmailInfo($newUser['userno']);
        $msgInfo = $classDatabases->GetMessageInfo($db, $i, $fileString);
        if ($msgInfo['fromuserno'] == $newUser['userno']) {
            $classDatabases->DeleteMessage($db, $i - $pos);
            $pos++;
        }
    }

    // Delete any oneliners addressed to this account.
    $db = $classDatabases->SetOnelinerInfo($newUser['userno']);
    $msgcnt = $db['msgcnt']['msgno'];
    $file = $GLOBALS['VA_SYSPATHS']['db'] . '/' . $db['filename'] . '.DAT';
    $fileString = ReadCfgFile($file);
    $pos = 0;
    for ($i = 1; (($i <= $db['msgno']) && ($msgcnt > 0)); $i++) {
        $db = $classDatabases->SetOnelinerInfo($newUser['userno']);
        $msgInfo = $classDatabases->GetMessageInfo($db, $i, $fileString);
        if ($msgInfo['touserno'] == $newUser['userno']) {
            $classDatabases->DeleteMessage($db, $i - $pos);
            $pos++;
        }
    }

    // Log the new user.
    $log = 'New User Entry  "' . $newUser['handle'] . '" #' . $newUser['userno'];
    WriteLog('VADV-PHP.LOG', $log);

    // Write to userfile.dat.
    $fileString = $classUserfileDat->Read();
    $fileString = $classUserfileDat->Put($fileString, $newUser['userno'], $newUser);
    $classUserfileDat->Write($fileString);

    // Write to userfile.idx.
    $fileString = $classUserfileIdx->Read();
    $fileString = $classUserfileIdx->Put($fileString, $newUser['userno'], $newUser);
    $classUserfileIdx->Write($fileString);

    // Write to handles.uip.
    $netinfo = $classNetworks->GetVnetInfo();
    $handleuip['handle'] = str_replace(' ', '.', $newUser['handle']);
    $handleuip['userno'] = $newUser['userno'];
    $handleuip['netnode'] = $netinfo['systemid'];
    $handleuip['netno'] = 1;
    $classVadvUsers->AddUserEmailInfo($newUser['userno'], $handleuip);

    // Send the new user email if it exists.
    $file = $GLOBALS['VA_SYSPATHS']['text'] . '/NEWUMAIL.TXT';
    if (file_exists($file)) {
        $from = 1;
        $to = $newUser['userno'] . '@' . $netinfo['systemid'] . '*1';
        $subject = 'Welcome New User!';
        $body = ReadCfgFile($file);
        $classDatabases->WriteEmail($from, $to, $subject, $body, 0, '', 0);
    }

    // Send an email to the sysop informing of a new user.
    $from = $newUser['userno'];
    $to = '1@' . $netinfo['systemid'] . '*1';
    $subject = 'New User Alert!';
    $body = 'New BBS user: ' . $newUser['handle'] . ' (#' . $newUser['userno'] . ")\r\n"
            . 'IP Address:   ' . $_SERVER['REMOTE_ADDR'] . "\r\n"
            . 'Time & Date:  ' . date("F j, Y, g:i a") . "\r\n\r\n"
            . 'Real Name:    ' . $newUser['realname'] . "\r\n"
            . 'City, State:  ' . $newUser['city'] . ', ' . $newUser['state'] . "\r\n"
            . 'Birthday:     ' . $newUser['bdaymonth'] . '/' . $newUser['bdayday'] . '/' . $newUser['bdayyear'] . "\r\n";
    $classDatabases->WriteEmail($from, $to, $subject, $body, 0, '', 0);

    // If SysOp Oneliner on New User is enabled, send a Oneliner to the SysOp
    if ($GLOBALS['CONFIG']['newuseroneliner'] === 1) {
        $classDatabases->WriteOneliner(1, 'New User Alert: ' . $newUser['handle'] . ' (#' . $newUser['userno'] . ')');
    }

    // Update all new message pointers.
    $classDatabases->UpdateMessagePointers($newUser['userno'], 0);

    // Now display a welcome screen and redirect to login.
    $errortype = 'Welcome New User!';
    $message = '<span style="color: green;">You are now a registered user of ' . HtmlSpace($GLOBALS['VA_MAIN']['bbsname']) . '.</span><br /><br />';
    $message .= 'User #: <b>' . $newUser['userno'] . '<br />';
    $message .= 'Handle: <b>' . $newUser['handle'] . '<br />';
    $message .= 'Password: <b>' . $newUser['password'] . '<br /><br />';
    $message .= 'You will now be redirected to our main page where you may log into the site with your Handle & Password.';
    $redirectURL = $rootDir . 'index.php';
    $delay = 7;
    include($themepath . '/templates/errmsg.php');
    include($themepath . '/templates/footer.php');
    exit;
}



// Output page
include($themepath . '/templates/register.php');

// Output footer
include($themepath . '/templates/footer.php');

?>