<?php
/*
 * ----------------------------------------------------------------------------
 * VConfig.php                                                       12/22/2009
 * This is the web-based version of the vconfig configuration utility.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2008 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

$GLOBALS['VA_ACTION'] = 'SysOp Function';

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');

$classControlDat = new datControl;


if (($GLOBALS['USER']['userno'] == 0) ||
    ($GLOBALS['USER']['userno'] == $GLOBALS['CONFIG']['guestacct']) ||
    ($GLOBALS['USER']['securitylevel'] == 0)) {
    die(VADV_LoginError());
}
if ($GLOBALS['USER']['securitylevel'] < 255) {
    $log = 'VConfig Error!  "' . $GLOBALS['USER']['handle'] . '" - Attempted Unauthorized VConfig Entry';
    WriteLog('VADV-PHP.LOG', $log);
    RedirectUser($rootDir . 'index.php');
}

// Check for system password.
if ($GLOBALS['CONFIG']['syspass']) {
    if (isset($_SESSION['systempw'])) {
        if ($_SESSION['systempw'] !== $GLOBALS['VA_MAIN']['systempw']) {
            RedirectUser($rootDir . 'index.php');
        }
    } else {
        RedirectUser('systemlogin.php?url=' . urlencode(GetCurrentURL()));
    }
}


// Check for config section
$cfg = isset($_GET['cfg']) ? trim(strtolower($_GET['cfg'])) : '';


// If we're on the main config page, let it use refresh if it's enabled
// for the online lists
if ($cfg == '') {
    define('USE_REFRESH', true);
}


// Load Who's Online list
$who = $classControlDat->Get();

$maxChannel = 10;    // Display only first 10 channels.
if ($GLOBALS['VA_MAIN']['maxchannelno'] < $maxChannel) {
    $maxChannel = $GLOBALS['VA_MAIN']['maxchannelno'];
}
if ($who['nodetotal'] < $maxChannel) {
    $maxChannel = $who['nodetotal'];
}

// Get number of guests...
$totalGuests = 0;
for ($i = 1; $i <= $GLOBALS['VA_USERS'][0]; $i++) {
    if (($GLOBALS['VA_USERS'][$i]['userno'] == 0) || ($GLOBALS['VA_USERS'][$i]['userno'] == $GLOBALS['CONFIG']['guestacct'])) {
        $totalGuests++;
    }
}
$totalUsers = $GLOBALS['VA_USERS'][0] - $totalGuests;


// Output header
$pagetitle = 'VADV-PHP Config';
include($themepath . '/templates/admin/admin_header.php');



switch ($cfg) {
    case 'vadvphp_gen':
        // Output page
        include($themepath . '/templates/admin/admin_vadvphp_gen.php');
        break;

    case 'vadvphp_path':
        // Output page
        include($themepath . '/templates/admin/admin_vadvphp_path.php');
        break;

    case 'vadvphp_user':
        // Output page
        include($themepath . '/templates/admin/admin_vadvphp_user.php');
        break;

    case 'vadvphp_other':
        // Output page
        include($themepath . '/templates/admin/admin_vadvphp_other.php');
        break;

    case 'vadvphp_at2k':
        // Output page
        include($themepath . '/templates/admin/admin_vadvphp_at2k.php');
        break;

    case 'vadvphp_theme':
        $cfgMisMatch = false;
        $mode = '';

        for ($i=0; $i<$themecount; $i++) {
            if (themeDeleted($i+1)) {
                continue;
            }
            $themeinfo[$i]['cfgMatch'] = checkThemeCfg($i+1);

            if (!$themeinfo[$i]['cfgMatch']) {
                $cfgMisMatch = true;
            }
        }

        if (isset($_POST['view'])) {
            $mode = 'view';
        }
        if (isset($_POST['update'])) {
            $mode = 'update';
        }
        if (isset($_POST['create'])) {
            $mode = 'create';
        }

        //$mode = isset($_GET['mode']) ? trim(strtolower($_GET['mode'])) : '';

        switch ($mode) {

            case 'view':

                if (!isset($_POST['t']) || $_POST['t'] == '') {
                    die('<br /><h4>Invalid parameters. Please press the BACK button on your browser.(1)</h4>');
                }
                $tNo = $_POST['t']-1;

                if (!$themeinfo[$tNo]['cfgMatch']) {
                    die('<br /><h4>You can\'t edit this theme until you UPDATE it! Please press the BACK button on your browser.(1)</h4>');
                }

                if (themeDeleted($themeinfo[$tNo]['themeID'])) {
                    die('<br /><h4>Invalid theme! Please press the BACK button on your browser.</h4>');
                }


                $Tmajver = trim(strtok($themeinfo[$tNo]['themeVer'], "."));
                $Tminver = trim(strtok("."));
                $Tsite = $themeinfo[$tNo]['themeSite'] == '' ? 'http://' : $themeinfo[$tNo]['themeSite'];


                // Output page
                include($themepath . '/templates/admin/admin_view_theme.php');
                break;

            case 'update':

                if (!isset($_POST['upID']) || $_POST['upID'] == '') {
                    die('<br /><h4>Invalid Theme ID! Please press the BACK button on your browser.</h4>');
                }

                // Get info from this theme's vadvtheme.cfg
                $themeID = (int)$_POST['upID'];
                $themeCFG = getThemeCfg(getThemeName($themeID));

                // Load this theme's current info
                $thisTheme = $themeinfo[$themeID-1];

                //  If theme actually needs updating, write new info to database
                if (!$thisTheme['cfgMatch']) {

                    $thisTheme['themeVer'] = $themeCFG['themeVer'];
                    $thisTheme['themeDate'] = $themeCFG['themeDate'];
                    $thisTheme['themeAuthor'] = $themeCFG['themeAuthor'];
                    $thisTheme['themeEmail'] = $themeCFG['themeEmail'];
                    $thisTheme['themeSite'] = $themeCFG['themeSite'];

                    $fileString = $classThemeDat->Read();
                    $fileString = $classThemeDat->Put($fileString, $themeID, $thisTheme);
                    $classThemeDat->Write($fileString);

                    // Update vadvtheme.cfg file in case the mismatch was theme name
                    // (in which case, it needs to be changed via the website Edit page so it can change directory name also)
                    if ($thisTheme['themeName'] != $themeCFG['themeName']) {
                        writeThemeCfg($thisTheme, $rootDir.'themes/'.$thisTheme['themeName'].'/');
                    }

                    $errortype = "Theme Update";
                    $message = "Theme was updated successfully!<br />You will now be redirected to the Theme Settings page.";
                    $redirectURL = $rootDir . 'vconfig/vconfig.php?cfg=vadvphp_theme';
                    include($themepath . '/templates/errmsg.php');
                    include($themepath . '/templates/admin/admin_footer.php');
                    exit;
                }


                // Output page
                include($themepath . '/templates/admin/admin_vadvphp_theme.php');
                break;

            case 'create':



                // Output page
                include($themepath . '/templates/admin/admin_create_theme.php');
                break;

            default:

                if (isset($_POST['makeDefault'])) {
                    if (!isset($_POST['t']) || $_POST['t'] == '') {
                        die('<br /><h4>Invalid parameters. Please press the BACK button on your browser.(1)</h4>');
                    }

                    $tNo = (int)$_POST['t']-1;
                    if ($themeinfo[$tNo]['themeDisabled']) {
                        $errortype = "Assign Default Theme Error";
                        $message = "This theme is disabled and cannot be made the default theme!<br /><br />Please Edit the theme and enable it first.<br /><br />";
                        $message .= "You will now be redirected to the Theme Settings page.";
                        $redirectURL = $rootDir . 'vconfig/vconfig.php?cfg=vadvphp_theme';
                        $delay = 3;
                        include($themepath . '/templates/errmsg.php');
                        include($themepath . '/templates/admin/admin_footer.php');
                        exit;
                    }

                    if ($themeinfo[$tNo]['themeSecLevel'] > 0) {
                        $errortype = "Assign Default Theme Error";
                        $message = "This theme's security level is higher than 0 and cannot be made the default theme!<br /><br />Please Edit the theme and set it's S/L to 0.<br /><br />";
                        $message .= "You will now be redirected to the Theme Settings page.";
                        $redirectURL = $rootDir . 'vconfig/vconfig.php?cfg=vadvphp_theme';
                        $delay = 3;
                        include($themepath . '/templates/errmsg.php');
                        include($themepath . '/templates/admin/admin_footer.php');
                        exit;
                    }

                    // Change our Global Config to save the change
                    $newConfig = $GLOBALS['CONFIG'];

                    $newConfig['defaulttheme'] = (int)$_POST['t'];

                    $classVADVPHPCfg->Write($newConfig);

                    $errortype = "Assign Default Theme";
                    $message = "Default theme has been changed!<br /><br />";
                    $message .= "You will now be redirected to the Theme Settings page.";
                    $redirectURL = $rootDir . 'vconfig/vconfig.php?cfg=vadvphp_theme';
                    $delay = 3;
                    include($themepath . '/templates/errmsg.php');
                    include($themepath . '/templates/admin/admin_footer.php');
                    exit;
                }




                // Check for and display any new themes in the themes directory that need to be installed
                $foundNewThemes = searchForThemes();

                $isNew = count($foundNewThemes);

                $NewThemes = array();

                for ($i=0; $i<count($foundNewThemes); $i++) {
                    $NewThemes[$i] = getThemeCfg($foundNewThemes[$i]);
                }

                if (isset($_POST['install'])) {
                    $newThemeNo = $_POST['installID'];

                    // Load new theme array with defaults
                    $newInfo = $classThemeDat->Get(0);

                    // Populate new theme data
                    $newInfo['themeName'] = $NewThemes[$newThemeNo]['themeName'];
                    $newInfo['themeVer'] = $NewThemes[$newThemeNo]['themeVer'];
                    $newInfo['themeDate'] = $NewThemes[$newThemeNo]['themeDate'];
                    $newInfo['themeAuthor'] = $NewThemes[$newThemeNo]['themeAuthor'];
                    $newInfo['themeEmail'] = $NewThemes[$newThemeNo]['themeEmail'];
                    $newInfo['themeSite'] = $NewThemes[$newThemeNo]['themeSite'];
                    $newInfo['themeSecLevel'] = 255;

                    // Determine ID for new theme (Use a deleted theme's slot or add new one)
                    $emptyslot = 0;
                    for ($i=0; $i<$themecount; $i++) {
                        if (themeDeleted($i+1)) {
                            $emptyslot = $i+1;
                            break;
                        }
                    }
                    $emptyslot = $i+1;

                    $fileString = $classThemeDat->Read();
                    $fileString = $classThemeDat->Put($fileString, $emptyslot, $newInfo);
                    $classThemeDat->Write($fileString);

                    $errortype = "Install New Theme";
                    $message = "New theme was installed!<br /><br />You will now be redirected to the Theme Settings page.";
                    $redirectURL = $rootDir . 'vconfig/vconfig.php?cfg=vadvphp_theme';
                    $delay = 3;
                    include($themepath . '/templates/errmsg.php');
                    include($themepath . '/templates/admin/admin_footer.php');
                    exit;
                }

                $activeTheme = array();
                for ($i=0; $i<$themecount; $i++) {
                    if (themeDeleted($i+1)) {
                        continue;
                    }
                    $activeTheme[$i] = $themeinfo[$i];
                }


                // Output page
                include($themepath . '/templates/admin/admin_vadvphp_theme.php');
                break;
        }
        break;

    case 'vadv_gen':
        // Output page
        include($themepath . '/templates/admin/admin_vadv_gen.php');
        break;

    case 'vadv_feature':
        // Output page
        include($themepath . '/templates/admin/admin_vadv_feature.php');
        break;

    case 'vadv_sec':
        // Output page
        include($themepath . '/templates/admin/admin_vadv_sec.php');
        break;

    case 'vadv_newuser':
        // Output page
        include($themepath . '/templates/admin/admin_vadv_newuser.php');
        break;

    case 'vadv_credit':
        // Output page
        include($themepath . '/templates/admin/admin_vadv_credit.php');
        break;

    case 'vadv_validate':
        // Output page
        include($themepath . '/templates/admin/admin_vadv_validate.php');
        break;

    case 'vadv_misc':
        // Output page
        include($themepath . '/templates/admin/admin_vadv_misc.php');
        break;

    default:
        include('sysinfo.php');
        include($themepath . '/templates/admin/admin_index.php');
        break;
}



// Output footer
include($themepath . '/templates/admin/admin_footer.php');


?>