<?php
/*
 * ----------------------------------------------------------------------------
 * VConfig_Main_Process.php                                            12/22/2009
 * This script processes info from the vconfig.php script.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2009 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

$GLOBALS['VA_ACTION'] = 'SysOp Function';

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');

$classMainCfg = new cfgMain;

if (($GLOBALS['USER']['userno'] == 0) ||
    ($GLOBALS['USER']['userno'] == $GLOBALS['CONFIG']['guestacct']) ||
    ($GLOBALS['USER']['securitylevel'] == 0)) {
    RedirectUser($rootDir . 'index.php');
}
if ($GLOBALS['USER']['securitylevel'] < 255) {
    $log = 'VConfig Error!  "' . $GLOBALS['USER']['handle'] . '" - Attempted Unauthorized VConfig Entry';
    WriteLog('VADV-PHP.LOG', $log);
    RedirectUser($rootDir . 'index.php');
}

// Check for system password.
if ($GLOBALS['CONFIG']['syspass']) {
    if (isset($_SESSION['systempw'])) {
        if ($_SESSION['systempw'] !== $GLOBALS['VA_MAIN']['systempw']) {
            RedirectUser($rootDir . 'index.php');
        }
    } else {
        RedirectUser($rootDir . 'index.php');
    }
}


// Load Who's Online list
$classControlDat = new datControl;
$who = $classControlDat->Get();

$maxChannel = 10;    // Display only first 10 channels.
if ($GLOBALS['VA_MAIN']['maxchannelno'] < $maxChannel) {
    $maxChannel = $GLOBALS['VA_MAIN']['maxchannelno'];
}
if ($who['nodetotal'] < $maxChannel) {
    $maxChannel = $who['nodetotal'];
}

// Get number of guests...

$totalGuests = 0;
for ($i = 1; $i <= $GLOBALS['VA_USERS'][0]; $i++) {
    if (($GLOBALS['VA_USERS'][$i]['userno'] == 0) || ($GLOBALS['VA_USERS'][$i]['userno'] == $GLOBALS['CONFIG']['guestacct'])) {
        $totalGuests++;
    }
}
$totalUsers = $GLOBALS['VA_USERS'][0] - $totalGuests;


if ((!isset($_SERVER['HTTP_REFERER'])) ||
    (strpos($_SERVER['HTTP_REFERER'], $_SERVER['HTTP_HOST']) === FALSE)) {
    die('<br /><h4>You are not allowed to access this script from an outside source.<br />Press the BACK button on your browser.</h4>');
}

if ((!isset($_POST['process'])) ||
    ($_POST['process'] != 1)) {
    die('<br /><h4>Invalid parameters. Please press the BACK button on your browser.</h4>');
}
if (!isset($_POST['submit'])) {
    die('<br /><h4>Invalid parameters. Please press the BACK button on your browser.</h4>');
}

if ($_POST['submit'] == 'Reset') {
    RedirectUser($_POST['referer']);
}
if ($_POST['submit'] == 'Cancel') {
    RedirectUser('vconfig.php');
}



if ((isset($_POST['bbsname']) && $_POST['bbsname'] != '') &&
    ($_POST['bbsname'] != $GLOBALS['VA_MAIN']['bbsname'])) {
    $main['bbsname'] = $_POST['bbsname'];
} else if ((!isset($_POST['bbsname']) || $_POST['bbsname'] == '') &&
    ($_GET['page'] == 'gen')) {
    $main['bbsname'] = 'Virtual Advanced BBS';
}
if ((isset($_POST['sysopname']) && $_POST['sysopname'] != '') &&
    ($_POST['sysopname'] != $GLOBALS['VA_MAIN']['sysopname'])) {
    $main['sysopname'] = $_POST['sysopname'];
} else if ((!isset($_POST['sysopname']) || $_POST['sysopname'] == '') &&
    ($_GET['page'] == 'gen')) {
    $main['sysopname'] == 'SysOp';
}
if ((isset($_POST['timeout']) && $_POST['timeout'] != '') &&
    ($_POST['timeout'] != $GLOBALS['VA_MAIN']['timeout'])) {
    $main['timeout'] = $_POST['timeout'];
} else if ((!isset($_POST['timeout']) || $_POST['timeout'] == '') &&
   ($_GET['page'] == 'misc')) {
    $main['timeout'] = 300;
}
if ((isset($_POST['phoneformat']) && $_POST['phoneformat'] != '') &&
    ($_POST['phoneformat'] != $GLOBALS['VA_MAIN']['phoneformat'])) {
    $main['phoneformat'] = $_POST['phoneformat'];
} else if ((!isset($_POST['phoneformat']) || $_POST['phoneformat'] == '') &&
    ($_GET['page'] == 'gen')) {
    $main['phoneformat'] = '###-###-####';
}
if ((isset($_POST['sblank']) && $_POST['sblank'] != '') &&
    ($_POST['sblank'] != $GLOBALS['VA_MAIN']['sblank'])) {
    $main['sblank'] = $_POST['sblank'];
} else if ((!isset($_POST['sblank']) || $_POST['sblank'] == '') &&
   ($_GET['page'] == 'misc')) {
    $main['sblank'] = 0;
}
if ((isset($_POST['reservekb']) && $_POST['reservekb'] != '') &&
    ($_POST['reservekb'] != $GLOBALS['VA_MAIN']['reservekb'])) {
    $main['reservekb'] = $_POST['reservekb'];
} else if ((!isset($_POST['reservekb']) || $_POST['reservekb'] == '') &&
   ($_GET['page'] == 'misc')) {
    $main['reservekb'] = 0;
}
if ((isset($_POST['timezone']) && $_POST['timezone'] != '') &&
    ($_POST['timezone'] != $GLOBALS['VA_MAIN']['timezone'])) {
    $main['timezone'] = $_POST['timezone'];
} else if ((!isset($_POST['timezone']) || $_POST['timezone'] == '') &&
    ($_GET['page'] == 'gen')) {
    $main['timezone'] = '-0500';
}
if ((isset($_POST['creditcost']) && $_POST['creditcost'] != '') &&
    ($_POST['creditcost'] != $GLOBALS['VA_MAIN']['creditcost'])) {
    $main['creditcost'] = $_POST['creditcost'];
} else if ((!isset($_POST['creditcost']) || $_POST['creditcost'] == '') &&
   ($_GET['page'] == 'credit')) {
    $main['creditcost'] = 0;
}
if ((isset($_POST['allowhandle']) && $_POST['allowhandle'] != '') &&
    ($_POST['allowhandle'] != $GLOBALS['VA_MAIN']['allowhandle'])) {
    $main['allowhandle'] = $_POST['allowhandle'];
} else if (!isset($_POST['allowhandle']) &&
    ($_GET['page'] == 'feature')) {
    $main['allowhandle'] = 0;
}
if ((isset($_POST['allowremote']) && $_POST['allowremote'] != '') &&
    ($_POST['allowremote'] != $GLOBALS['VA_MAIN']['allowremote'])) {
    $main['allowremote'] = $_POST['allowremote'];
} else if (!isset($_POST['allowremote']) &&
    ($_GET['page'] == 'feature')) {
    $main['allowremote'] = 0;
}
//if ((isset($_POST['newuserpw'])) &&
//    ($_POST['newuserpw'] != $GLOBALS['VA_MAIN']['newuserpw'])) {
//    $main['newuserpw'] = $_POST['newuserpw'];
//}
//if ((isset($_POST['systempw'])) &&
//    ($_POST['systempw'] != $GLOBALS['VA_MAIN']['systempw'])) {
//    $main['systempw'] = $_POST['systempw'];
//}
if ((isset($_POST['nucredits']) && $_POST['nucredits'] != '') &&
    ($_POST['nucredits'] != $GLOBALS['VA_MAIN']['nucredits'])) {
    $main['nucredits'] = $_POST['nucredits'];
} else if ((!isset($_POST['nucredits']) || $_POST['nucredits'] == '') &&
   ($_GET['page'] == 'newuser')) {
    $main['nucredits'] = 0;
}
if ((isset($_POST['wfcdrives'])) &&
    ($_POST['wfcdrives'] != $GLOBALS['VA_MAIN']['wfcdrives'])) {
    $main['wfcdrives'] = $_POST['wfcdrives'];
}
if ((isset($_POST['maxchannelno']) && $_POST['maxchannelno'] != '') &&
    ($_POST['maxchannelno'] != $GLOBALS['VA_MAIN']['maxchannelno'])) {
    $main['maxchannelno'] = $_POST['maxchannelno'];
} else if ((!isset($_POST['maxchannelno']) || $_POST['maxchannelno'] == '') &&
   ($_GET['page'] == 'misc')) {
    $main['maxchannelno'] = 1;
}
if ((isset($_POST['netlowtime']) && $_POST['netlowtime'] != '') &&
    ($_POST['netlowtime'] != $GLOBALS['VA_MAIN']['netlowtime'])) {
    $main['netlowtime'] = $_POST['netlowtime'];
} else if ((!isset($_POST['netlowtime']) || $_POST['netlowtime'] == '') &&
    ($_GET['page'] == 'gen')) {
    $main['netlowtime'] = '00:00';
}
if ((isset($_POST['nethightime']) && $_POST['nethightime'] != '') &&
    ($_POST['nethightime'] != $GLOBALS['VA_MAIN']['nethightime'])) {
    $main['nethightime'] = $_POST['nethightime'];
} else if ((!isset($_POST['nethightime']) || $_POST['nethightime'] == '') &&
    ($_GET['page'] == 'gen')) {
    $main['nethightime'] = '00:00';
}
if ((isset($_POST['redials']) && $_POST['redials'] != '') &&
    ($_POST['redials'] != $GLOBALS['VA_MAIN']['redials'])) {
    $main['redials'] = $_POST['redials'];
} else if ((!isset($_POST['redials']) || $_POST['redials'] == '') &&
   ($_GET['page'] == 'misc')) {
    $main['redials'] = 1;
}
if ((isset($_POST['polldelay']) && $_POST['polldelay'] != '') &&
    ($_POST['polldelay'] != $GLOBALS['VA_MAIN']['polldelay'])) {
    $main['polldelay'] = $_POST['polldelay'];
} else if ((!isset($_POST['polldelay']) || $_POST['polldelay'] == '') &&
   ($_GET['page'] == 'misc')) {
    $main['polldelay'] = 300;
}
// *********************** This one isn't in any config page?? ******************************
if ((isset($_POST['dialstring'])) &&
    ($_POST['dialstring'] != $GLOBALS['VA_MAIN']['dialstring']) &&
    ($_POST['dialstring'] != '')) {
    $main['dialstring'] = $_POST['dialstring'];
}
// ******************************************************************************************
if ((isset($_POST['autopostsl']) && $_POST['autopostsl'] != '') &&
    ($_POST['autopostsl'] != $GLOBALS['VA_MAIN']['autopostsl'])) {
    $main['autopostsl'] = $_POST['autopostsl'];
} else if ((!isset($_POST['autopostsl']) || $_POST['autopostsl'] == '') &&
   ($_GET['page'] == 'sec')) {
    $main['autopostsl'] = 10;
}
if ((isset($_POST['emlothers']) && $_POST['emlothers'] != '') &&
    ($_POST['emlothers'] != $GLOBALS['VA_MAIN']['emlothers'])) {
    $main['emlothers'] = $_POST['emlothers'];
} else if ((!isset($_POST['emlothers']) || $_POST['emlothers'] == '') &&
   ($_GET['page'] == 'sec')) {
    $main['emlothers'] = 10;
}
if ((isset($_POST['emlsysfile']) && $_POST['emlsysfile'] != '') &&
    ($_POST['emlsysfile'] != $GLOBALS['VA_MAIN']['emlsysfile'])) {
    $main['emlsysfile'] = $_POST['emlsysfile'];
} else if ((!isset($_POST['emlsysfile']) || $_POST['emlsysfile'] == '') &&
   ($_GET['page'] == 'sec')) {
    $main['emlsysfile'] = 10;
}
if ((isset($_POST['emlotherfile']) && $_POST['emlotherfile'] != '') &&
    ($_POST['emlotherfile'] != $GLOBALS['VA_MAIN']['emlotherfile'])) {
    $main['emlotherfile'] = $_POST['emlotherfile'];
} else if ((!isset($_POST['emlotherfile']) || $_POST['emlotherfile'] == '') &&
   ($_GET['page'] == 'sec')) {
    $main['emlotherfile'] = 50;
}
if ((isset($_POST['multimail']) && $_POST['multimail'] != '') &&
    ($_POST['multimail'] != $GLOBALS['VA_MAIN']['multimail'])) {
    $main['multimail'] = $_POST['multimail'];
} else if ((!isset($_POST['multimail']) || $_POST['multimail'] == '') &&
   ($_GET['page'] == 'sec')) {
    $main['multimail'] = 255;
}
if ((isset($_POST['carboncopy']) && $_POST['carboncopy'] != '') &&
    ($_POST['carboncopy'] != $GLOBALS['VA_MAIN']['carboncopy'])) {
    $main['carboncopy'] = $_POST['carboncopy'];
} else if ((!isset($_POST['carboncopy']) || $_POST['carboncopy'] == '') &&
   ($_GET['page'] == 'sec')) {
    $main['carboncopy'] = 255;
}
// *********************** This one isn't in any config page?? ******************************
if ((isset($_POST['uplev'])) &&
    ($_POST['uplev'] != $GLOBALS['VA_MAIN']['uplev']) &&
    ($_POST['uplev'] != '')) {
    $main['uplev'] = $_POST['uplev'];
}
// ******************************************************************************************
if ((isset($_POST['autosysopsl']) && $_POST['autosysopsl'] != '') &&
    ($_POST['autosysopsl'] != $GLOBALS['VA_MAIN']['autosysopsl'])) {
    $main['autosysopsl'] = $_POST['autosysopsl'];
} else if ((!isset($_POST['autosysopsl']) || $_POST['autosysopsl'] == '') &&
   ($_GET['page'] == 'validate')) {
    $main['autosysopsl'] = 0;
}
if ((isset($_POST['autosysoptime']) && $_POST['autosysoptime'] != '') &&
    ($_POST['autosysoptime'] != $GLOBALS['VA_MAIN']['autosysoptime'])) {
    $main['autosysoptime'] = $_POST['autosysoptime'];
} else if ((!isset($_POST['autosysoptime']) || $_POST['autosysoptime'] == '') &&
   ($_GET['page'] == 'validate')) {
    $main['autosysoptime'] = 0;
}
if ((isset($_POST['qwklimit']) && $_POST['qwklimit'] != '') &&
    ($_POST['qwklimit'] != $GLOBALS['VA_MAIN']['qwklimit'])) {
    $main['qwklimit'] = $_POST['qwklimit'];
} else if ((!isset($_POST['qwklimit']) || $_POST['qwklimit'] == '') &&
   ($_GET['page'] == 'misc')) {
    $main['qwklimit'] = 500;
}
if ((isset($_POST['needwfcpw']) && $_POST['needwfcpw'] != '') &&
    ($_POST['needwfcpw'] != $GLOBALS['VA_MAIN']['needwfcpw'])) {
    $main['needwfcpw'] = $_POST['needwfcpw'];
} else if (!isset($_POST['needwfcpw']) &&
    ($_GET['page'] == 'feature')) {
    $main['needwfcpw'] = 0;
}
if ((isset($_POST['mailholdtime']) && $_POST['mailholdtime'] != '') &&
    ($_POST['mailholdtime'] != $GLOBALS['VA_MAIN']['mailholdtime'])) {
    $main['mailholdtime'] = $_POST['mailholdtime'];
} else if ((!isset($_POST['mailholdtime']) || $_POST['mailholdtime'] == '') &&
   ($_GET['page'] == 'misc')) {
    $main['mailholdtime'] = 90;
}
if ((isset($_POST['newusersl']) && $_POST['newusersl'] != '') &&
    ($_POST['newusersl'] != $GLOBALS['VA_MAIN']['newusersl'])) {
    $main['newusersl'] = $_POST['newusersl'];
} else if ((!isset($_POST['newusersl']) || $_POST['newusersl'] == '') &&
   ($_GET['page'] == 'newuser')) {
    $main['newusersl'] = 1;
}
if ((isset($_POST['newusertime']) && $_POST['newusertime'] != '') &&
    ($_POST['newusertime'] != $GLOBALS['VA_MAIN']['newusertime'])) {
    $main['newusertime'] = $_POST['newusertime'];
} else if ((!isset($_POST['newusertime']) || $_POST['newusertime'] == '') &&
   ($_GET['page'] == 'newuser')) {
    $main['newusertime'] = 10;
}
if ((isset($_POST['maxtimebank']) && $_POST['maxtimebank'] != '') &&
    ($_POST['maxtimebank'] != $GLOBALS['VA_MAIN']['maxtimebank'])) {
    $main['maxtimebank'] = $_POST['maxtimebank'];
} else if ((!isset($_POST['maxtimebank']) || $_POST['maxtimebank'] == '') &&
   ($_GET['page'] == 'misc')) {
    $main['maxtimebank'] = 90;
}
if ((isset($_POST['logdetail']) && $_POST['logdetail'] != '') &&
    ($_POST['logdetail'] != $GLOBALS['VA_MAIN']['logdetail'])) {
    $main['logdetail'] = $_POST['logdetail'];
}
if ((isset($_POST['qwkfilename']) && $_POST['qwkfilename'] != '') &&
    ($_POST['qwkfilename'] != $GLOBALS['VA_MAIN']['qwkfilename'])) {
    $main['qwkfilename'] = $_POST['qwkfilename'];
} else if ((!isset($_POST['qwkfilename']) || $_POST['qwkfilename'] == '') &&
    ($_GET['page'] == 'gen')) {
    $main['qwkfilename'] = 'VA1QWK';
}
if ((isset($_POST['forcefilename']) && $_POST['forcefilename'] != '') &&
    ($_POST['forcefilename'] != $GLOBALS['VA_MAIN']['forcefilename'])) {
    $main['forcefilename'] = $_POST['forcefilename'];
} else if (!isset($_POST['forcefilename']) &&
    ($_GET['page'] == 'feature')) {
    $main['forcefilename'] = 0;
}
if ((isset($_POST['inversebar']) && $_POST['inversebar'] != '') &&
    ($_POST['inversebar'] != $GLOBALS['VA_MAIN']['inversebar'])) {
    $main['inversebar'] = $_POST['inversebar'];
} else if (!isset($_POST['inversebar']) &&
    ($_GET['page'] == 'feature')) {
    $main['inversebar'] = 0;
}
if ((isset($_POST['displaynet']) && $_POST['displaynet'] != '') &&
    ($_POST['displaynet'] != $GLOBALS['VA_MAIN']['displaynet'])) {
    $main['displaynet'] = $_POST['displaynet'];
} else if (!isset($_POST['displaynet']) &&
    ($_GET['page'] == 'feature')) {
    $main['displaynet'] = 0;
}
if ((isset($_POST['logoffbat']) && $_POST['logoffbat'] != '') &&
    ($_POST['logoffbat'] != $GLOBALS['VA_MAIN']['logoffbat'])) {
    $main['logoffbat'] = $_POST['logoffbat'];
}
if ((isset($_POST['ringtoanswer']) && $_POST['ringtoanswer'] != '') &&
    ($_POST['ringtoanswer'] != $GLOBALS['VA_MAIN']['ringtoanswer'])) {
    $main['ringtoanswer'] = $_POST['ringtoanswer'];
} else if ((!isset($_POST['ringtoanswer']) || $_POST['ringtoanswer'] == '') &&
   ($_GET['page'] == 'misc')) {
    $main['ringtoanswer'] = 1;
}
if ((isset($_POST['forcefeedback']) && $_POST['forcefeedback'] != '') &&
    ($_POST['forcefeedback'] != $GLOBALS['VA_MAIN']['forcefeedback'])) {
    $main['forcefeedback'] = $_POST['forcefeedback'];
} else if (!isset($_POST['forcefeedback']) &&
    ($_GET['page'] == 'feature')) {
    $main['forcefeedback'] = 0;
}
if ((isset($_POST['uploadscan']) && $_POST['uploadscan'] != '') &&
    ($_POST['uploadscan'] != $GLOBALS['VA_MAIN']['uploadscan'])) {
    $main['uploadscan'] = $_POST['uploadscan'];
}
if ((isset($_POST['cbvsl']) && $_POST['cbvsl'] != '') &&
    ($_POST['cbvsl'] != $GLOBALS['VA_MAIN']['cbvsl'])) {
    $main['cbvsl'] = $_POST['cbvsl'];
} else if ((!isset($_POST['cbvsl']) || $_POST['cbvsl'] == '') &&
   ($_GET['page'] == 'validate')) {
    $main['cbvsl'] = 0;
}
if ((isset($_POST['cbvtime']) && $_POST['cbvtime'] != '') &&
    ($_POST['cbvtime'] != $GLOBALS['VA_MAIN']['cbvtime'])) {
    $main['cbvtime'] = $_POST['cbvtime'];
} else if ((!isset($_POST['cbvtime']) || $_POST['cbvtime'] == '') &&
   ($_GET['page'] == 'validate')) {
    $main['cbvtime'] = 0;
}
if ((isset($_POST['checkpolls']) && $_POST['checkpolls'] != '') &&
    ($_POST['checkpolls'] != $GLOBALS['VA_MAIN']['checkpolls'])) {
    $main['checkpolls'] = $_POST['checkpolls'];
} else if (!isset($_POST['checkpolls']) &&
    ($_GET['page'] == 'feature')) {
    $main['checkpolls'] = 0;
}
if ((isset($_POST['directmail']) && $_POST['directmail'] != '') &&
    ($_POST['directmail'] != $GLOBALS['VA_MAIN']['directmail'])) {
    $main['directmail'] = $_POST['directmail'];
} else if (!isset($_POST['directmail']) &&
    ($_GET['page'] == 'feature')) {
    $main['directmail'] = 0;
}
if ((isset($_POST['credperpost']) && $_POST['credperpost'] != '') &&
    ($_POST['credperpost'] != $GLOBALS['VA_MAIN']['credperpost'])) {
    $main['credperpost'] = $_POST['credperpost'];
} else if ((!isset($_POST['credperpost']) || $_POST['credperpost'] == '') &&
   ($_GET['page'] == 'credit')) {
    $main['credperpost'] = 0;
}
if ((isset($_POST['credperuplk']) && $_POST['credperuplk'] != '') &&
    ($_POST['credperuplk'] != $GLOBALS['VA_MAIN']['credperuplk'])) {
    $main['credperuplk'] = $_POST['credperuplk'];
} else if ((!isset($_POST['credperuplk']) || $_POST['credperuplk'] == '') &&
   ($_GET['page'] == 'credit')) {
    $main['credperuplk'] = 0;
}
if ((isset($_POST['credperdlk']) && $_POST['credperdlk'] != '') &&
    ($_POST['credperdlk'] != $GLOBALS['VA_MAIN']['credperdlk'])) {
    $main['credperdlk'] = $_POST['credperdlk'];
} else if ((!isset($_POST['credperdlk']) || $_POST['credperdlk'] == '') &&
   ($_GET['page'] == 'credit')) {
    $main['credperdlk'] = 0;
}
if ((isset($_POST['multitasker']) && $_POST['multitasker'] != '') &&
    ($_POST['multitasker'] != $GLOBALS['VA_MAIN']['multitasker'])) {
    $main['multitasker'] = $_POST['multitasker'];
}
if ((isset($_POST['secuploads']) && $_POST['secuploads'] != '') &&
    ($_POST['secuploads'] != $GLOBALS['VA_MAIN']['secuploads'])) {
    $main['secuploads'] = $_POST['secuploads'];
} else if (!isset($_POST['secuploads']) &&
    ($_GET['page'] == 'feature')) {
    $main['secuploads'] = 0;
}
if ((isset($_POST['detectfido']) && $_POST['detectfido'] != '') &&
    ($_POST['detectfido'] != $GLOBALS['VA_MAIN']['detectfido'])) {
    $main['detectfido'] = $_POST['detectfido'];
} else if (!isset($_POST['detectfido']) &&
    ($_GET['page'] == 'feature')) {
    $main['detectfido'] = 0;
}
if ((isset($_POST['ignoreext']) && $_POST['ignoreext'] != '') &&
    ($_POST['ignoreext'] != $GLOBALS['VA_MAIN']['ignoreext'])) {
    $main['ignoreext'] = $_POST['ignoreext'];
} else if (!isset($_POST['ignoreext']) &&
    ($_GET['page'] == 'feature')) {
    $main['ignoreext'] = 0;
}
if ((isset($_POST['tossopt']) && $_POST['tossopt'] != '') &&
    ($_POST['tossopt'] != $GLOBALS['VA_MAIN']['tossopt'])) {
    $main['tossopt'] = $_POST['tossopt'];
}
if ((isset($_POST['sysfkey']) && $_POST['sysfkey'] != '') &&
    ($_POST['sysfkey'] != $GLOBALS['VA_MAIN']['sysfkey'])) {
    $main['sysfkey'] = $_POST['sysfkey'];
} else if (!isset($_POST['sysfkey']) &&
    ($_GET['page'] == 'feature')) {
    $main['sysfkey'] = 0;
}

if (isset($main)) {
    // Get the file string.
    $fileString = $classMainCfg->Read();

    // Put the new information into the file string.
    $fileString = $classMainCfg->Put($fileString, $main);

    // Write the new file.
    $classMainCfg->Write($fileString);
}



// Show a successful save message and redirect back to page
$errortype = 'VADV-PHP Configuration';
$message = '<br /><b style="color: green;">Configuration Saved!</b><br /><br />';
$delay = 2;
$redirectURL = $_POST['referer'];
include($themepath . '/templates/admin/admin_header.php');
include($themepath . '/templates/errmsg.php');
include($themepath . '/templates/admin/admin_footer.php');
exit;

?>