<?php
/*
 * ----------------------------------------------------------------------------
 * VConfig_Paths_Process.php                                         12/22/2009
 * This script processes info from the vconfig.php script.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2008 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

$GLOBALS['VA_ACTION'] = 'SysOp Function';

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');

$classSysPathsCfg = new cfgSysPaths;

if (($GLOBALS['USER']['userno'] == 0) ||
    ($GLOBALS['USER']['userno'] == $GLOBALS['CONFIG']['guestacct']) ||
    ($GLOBALS['USER']['securitylevel'] == 0)) {
    RedirectUser($rootDir . 'index.php');
}
if ($GLOBALS['USER']['securitylevel'] < 255) {
    $log = 'VConfig Error!  "' . $GLOBALS['USER']['handle'] . '" - Attempted Unauthorized VConfig Entry';
    WriteLog('VADV-PHP.LOG', $log);
    RedirectUser($rootDir . 'index.php');
}

// Check for system password.
if ($GLOBALS['CONFIG']['syspass']) {
    if (isset($_SESSION['systempw'])) {
        if ($_SESSION['systempw'] !== $GLOBALS['VA_MAIN']['systempw']) {
            RedirectUser($rootDir . 'index.php');
        }
    } else {
        RedirectUser($rootDir . 'index.php');
    }
}


// Load Who's Online list
$classControlDat = new datControl;
$who = $classControlDat->Get();

$maxChannel = 10;    // Display only first 10 channels.
if ($GLOBALS['VA_MAIN']['maxchannelno'] < $maxChannel) {
    $maxChannel = $GLOBALS['VA_MAIN']['maxchannelno'];
}
if ($who['nodetotal'] < $maxChannel) {
    $maxChannel = $who['nodetotal'];
}

// Get number of guests...

$totalGuests = 0;
for ($i = 1; $i <= $GLOBALS['VA_USERS'][0]; $i++) {
    if (($GLOBALS['VA_USERS'][$i]['userno'] == 0) || ($GLOBALS['VA_USERS'][$i]['userno'] == $GLOBALS['CONFIG']['guestacct'])) {
        $totalGuests++;
    }
}
$totalUsers = $GLOBALS['VA_USERS'][0] - $totalGuests;


if ((!isset($_SERVER['HTTP_REFERER'])) ||
    (strpos($_SERVER['HTTP_REFERER'], $_SERVER['HTTP_HOST']) === FALSE)) {
    die('<br /><h4>You are not allowed to access this script from an outside source.<br />Press the BACK button on your browser.</h4>');
}

if ((!isset($_POST['process'])) ||
    ($_POST['process'] != 1)) {
    die('<br /><h4>Invalid parameters. Please press the BACK button on your browser.</h4>');
}
if (!isset($_POST['submit'])) {
    die('<br /><h4>Invalid parameters. Please press the BACK button on your browser.</h4>');
}

if ($_POST['submit'] == 'Reset') {
    RedirectUser($_POST['referer']);
}
if ($_POST['submit'] == 'Cancel') {
    RedirectUser('vconfig.php');
}



// Process incoming form data
if ((isset($_POST['main']) && $_POST['main'] != '') &&
    ($_POST['main'] != $GLOBALS['VA_SYSPATHS']['main'])) {
    $syspaths['main'] = trim($_POST['main']);
} else if ((!isset($_POST['main']) || $_POST['main'] == '') &&
    ($_GET['page'] == 'path')) {
    // This directory can NOT be blank and must be valid or system will freak!
    $errortype = 'VADV-PHP Configuration';
    $message = '<br /><span style="color: red;">Main Directory can <b>NOT</b> be blank!</span><br /><br />';
    $message .= 'And it <b>MUST BE VALID</b>!<br /><br />Please press the BACK button on your browser.<br /><br />';
    include($themepath . '/templates/admin/admin_header.php');
    include($themepath . '/templates/errmsg.php');
    include($themepath . '/templates/admin/admin_footer.php');
    exit;
}
if ((isset($_POST['script']) && $_POST['script'] != '') &&
    ($_POST['script'] != $GLOBALS['VA_SYSPATHS']['script'])) {
    $syspaths['script'] = trim($_POST['script']);
} else if ((!isset($_POST['script']) || $_POST['script'] == '') &&
    ($_GET['page'] == 'path')) {
    // This directory can NOT be blank and must be valid or system will freak!
    $errortype = 'VADV-PHP Configuration';
    $message = '<br /><span style="color: red;">Scripts Directory can <b>NOT</b> be blank!</span><br /><br />';
    $message .= 'And it <b>MUST BE VALID</b>!<br /><br />Please press the BACK button on your browser.<br /><br />';
    include($themepath . '/templates/admin/admin_header.php');
    include($themepath . '/templates/errmsg.php');
    include($themepath . '/templates/admin/admin_footer.php');
    exit;
}
if ((isset($_POST['data']) && $_POST['data'] != '') &&
    ($_POST['data'] != $GLOBALS['VA_SYSPATHS']['data'])) {
    $syspaths['data'] = trim($_POST['data']);
} else if ((!isset($_POST['data']) || $_POST['data'] == '') &&
    ($_GET['page'] == 'path')) {
    // This directory can NOT be blank and must be valid or system will freak!
    $errortype = 'VADV-PHP Configuration';
    $message = '<br /><span style="color: red;">Data Directory can <b>NOT</b> be blank!</span><br /><br />';
    $message .= 'And it <b>MUST BE VALID</b>!<br /><br />Please press the BACK button on your browser.<br /><br />';
    include($themepath . '/templates/admin/admin_header.php');
    include($themepath . '/templates/errmsg.php');
    include($themepath . '/templates/admin/admin_footer.php');
    exit;
}
if ((isset($_POST['network']) && $_POST['network'] != '') &&
    ($_POST['network'] != $GLOBALS['VA_SYSPATHS']['network'])) {
    $syspaths['network'] = trim($_POST['network']);
}/* else if ((!isset($_POST['network']) || $_POST['network'] == '') &&
    ($_GET['page'] == 'path')) {
    // This directory can NOT be blank and must be valid or system will freak!
    $errortype = 'VADV-PHP Configuration';
    $message = '<br /><span style="color: red;">Network Directory can <b>NOT</b> be blank!</span><br /><br />';
    $message .= 'And it <b>MUST BE VALID</b>!<br /><br />Please press the BACK button on your browser.<br /><br />';
    include($themepath . '/templates/admin/admin_header.php');
    include($themepath . '/templates/errmsg.php');
    include($themepath . '/templates/admin/admin_footer.php');
    exit;
}*/
if ((isset($_POST['text']) && $_POST['text'] != '') &&
    ($_POST['text'] != $GLOBALS['VA_SYSPATHS']['text'])) {
    $syspaths['text'] = trim($_POST['text']);
} else if ((!isset($_POST['text']) || $_POST['text'] == '') &&
    ($_GET['page'] == 'path')) {
    // This directory can NOT be blank and must be valid or system will freak!
    $errortype = 'VADV-PHP Configuration';
    $message = '<br /><span style="color: red;">System Text Directory can <b>NOT</b> be blank!</span><br /><br />';
    $message .= 'And it <b>MUST BE VALID</b>!<br /><br />Please press the BACK button on your browser.<br /><br />';
    include($themepath . '/templates/admin/admin_header.php');
    include($themepath . '/templates/errmsg.php');
    include($themepath . '/templates/admin/admin_footer.php');
    exit;
}
if ((isset($_POST['control']) && $_POST['control'] != '') &&
    ($_POST['control'] != $GLOBALS['VA_SYSPATHS']['control'])) {
    $syspaths['control'] = trim($_POST['control']);
} else if ((!isset($_POST['control']) || $_POST['control'] == '') &&
    ($_GET['page'] == 'path')) {
    // This directory can NOT be blank and must be valid or system will freak!
    $errortype = 'VADV-PHP Configuration';
    $message = '<br /><span style="color: red;">CONTROL.DAT Directory can <b>NOT</b> be blank!</span><br /><br />';
    $message .= 'And it <b>MUST BE VALID</b>!<br /><br />Please press the BACK button on your browser.<br /><br />';
    include($themepath . '/templates/admin/admin_header.php');
    include($themepath . '/templates/errmsg.php');
    include($themepath . '/templates/admin/admin_footer.php');
    exit;
}
if ((isset($_POST['temp']) && $_POST['temp'] != '') &&
    ($_POST['temp'] != $GLOBALS['VA_SYSPATHS']['temp'])) {
    $syspaths['temp'] = trim($_POST['temp']);
} else if ((!isset($_POST['temp']) || $_POST['temp'] == '') &&
    ($_GET['page'] == 'path')) {
    // This directory can NOT be blank and must be valid or system will freak!
    $errortype = 'VADV-PHP Configuration';
    $message = '<br /><span style="color: red;">Temporary Directory can <b>NOT</b> be blank!</span><br /><br />';
    $message .= 'And it <b>MUST BE VALID</b>!<br /><br />Please press the BACK button on your browser.<br /><br />';
    include($themepath . '/templates/admin/admin_header.php');
    include($themepath . '/templates/errmsg.php');
    include($themepath . '/templates/admin/admin_footer.php');
    exit;
}
if ((isset($_POST['db']) && $_POST['db'] != '') &&
    ($_POST['db'] != $GLOBALS['VA_SYSPATHS']['db'])) {
    $syspaths['db'] = trim($_POST['db']);
} else if ((!isset($_POST['db']) || $_POST['db'] == '') &&
    ($_GET['page'] == 'path')) {
    // This directory can NOT be blank and must be valid or system will freak!
    $errortype = 'VADV-PHP Configuration';
    $message = '<br /><span style="color: red;">Database Directory can <b>NOT</b> be blank!</span><br /><br />';
    $message .= 'And it <b>MUST BE VALID</b>!<br /><br />Please press the BACK button on your browser.<br /><br />';
    include($themepath . '/templates/admin/admin_header.php');
    include($themepath . '/templates/errmsg.php');
    include($themepath . '/templates/admin/admin_footer.php');
    exit;
}
if ((isset($_POST['sysop']) && $_POST['sysop'] != '') &&
    ($_POST['sysop'] != $GLOBALS['VA_SYSPATHS']['sysop'])) {
    $syspaths['sysop'] = trim($_POST['sysop']);
} else if ((!isset($_POST['sysop']) || $_POST['sysop'] == '') &&
    ($_GET['page'] == 'path')) {
    // This directory can NOT be blank and must be valid or system will freak!
    $errortype = 'VADV-PHP Configuration';
    $message = '<br /><span style="color: red;">Upload/Email Directory can <b>NOT</b> be blank!</span><br /><br />';
    $message .= 'And it <b>MUST BE VALID</b>!<br /><br />Please press the BACK button on your browser.<br /><br />';
    include($themepath . '/templates/admin/admin_header.php');
    include($themepath . '/templates/errmsg.php');
    include($themepath . '/templates/admin/admin_footer.php');
    exit;
}
if ((isset($_POST['fdx']) && $_POST['fdx'] != '') &&
    ($_POST['fdx'] != $GLOBALS['VA_SYSPATHS']['fdx'])) {
    $syspaths['fdx'] = trim($_POST['fdx']);
} else if ((!isset($_POST['fdx']) || $_POST['fdx'] == '') &&
    ($_GET['page'] == 'path')) {
    // This directory can NOT be blank and must be valid or system will freak!
    $errortype = 'VADV-PHP Configuration';
    $message = '<br /><span style="color: red;">FDX Database Directory can <b>NOT</b> be blank!</span><br /><br />';
    $message .= 'And it <b>MUST BE VALID</b>!<br /><br />Please press the BACK button on your browser.<br /><br />';
    include($themepath . '/templates/admin/admin_header.php');
    include($themepath . '/templates/errmsg.php');
    include($themepath . '/templates/admin/admin_footer.php');
    exit;
}

if (isset($syspaths)) {
    // Get the file string.
    $fileString = $classSysPathsCfg->Read();

    // Put the new information into the file string.
    $fileString = $classSysPathsCfg->Put($fileString, $syspaths);

    // Write the new file.
    $classSysPathsCfg->Write($fileString);
}

RedirectUser($_POST['referer']);

?>