<?php
/*
 * ----------------------------------------------------------------------------
 * VConfig_Theme_Process.php                                         12/22/2009
 * This script processes the theme info from the vconfig.php script.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2008 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

$GLOBALS['VA_ACTION'] = 'SysOp Function';

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');


if (($GLOBALS['USER']['userno'] == 0) ||
    ($GLOBALS['USER']['userno'] == $GLOBALS['CONFIG']['guestacct']) ||
    ($GLOBALS['USER']['securitylevel'] == 0)) {
    RedirectUser($rootDir . 'index.php');
}
if ($GLOBALS['USER']['securitylevel'] < 255) {
    $log = 'VConfig Error!  "' . $GLOBALS['USER']['handle'] . '" - Attempted Unauthorized VConfig Entry';
    WriteLog('VADV-PHP.LOG', $log);
    RedirectUser($rootDir . 'index.php');
}

// Check for system password.
if ($GLOBALS['CONFIG']['syspass']) {
    if (isset($_SESSION['systempw'])) {
        if ($_SESSION['systempw'] !== $GLOBALS['VA_MAIN']['systempw']) {
            RedirectUser($rootDir . 'index.php');
        }
    } else {
        RedirectUser($rootDir . 'index.php');
    }
}


// Load Who's Online list
$classControlDat = new datControl;
$who = $classControlDat->Get();

$maxChannel = 10;    // Display only first 10 channels.
if ($GLOBALS['VA_MAIN']['maxchannelno'] < $maxChannel) {
    $maxChannel = $GLOBALS['VA_MAIN']['maxchannelno'];
}
if ($who['nodetotal'] < $maxChannel) {
    $maxChannel = $who['nodetotal'];
}

// Get number of guests...

$totalGuests = 0;
for ($i = 1; $i <= $GLOBALS['VA_USERS'][0]; $i++) {
    if (($GLOBALS['VA_USERS'][$i]['userno'] == 0) || ($GLOBALS['VA_USERS'][$i]['userno'] == $GLOBALS['CONFIG']['guestacct'])) {
        $totalGuests++;
    }
}
$totalUsers = $GLOBALS['VA_USERS'][0] - $totalGuests;


if ((!isset($_SERVER['HTTP_REFERER'])) ||
    (strpos($_SERVER['HTTP_REFERER'], $_SERVER['HTTP_HOST']) === FALSE)) {
    die('<br /><h4>You are not allowed to access this script from an outside source.<br />Press the BACK button on your browser.</h4>');
}

if ((!isset($_POST['process'])) ||
    (($_POST['process'] != 1) && ($_POST['process'] != 2) && ($_POST['process'] != 3))) {
    die('<br /><h4>Invalid parameters. Please press the BACK button on your browser.(1)</h4>');
}

if (isset($_POST['delete_x']) && isset($_POST['delete_y'])) {
    // If this is the default theme, it can't be deleted
    if ($themeinfo[($_POST['tid']-1)]['themeID'] == $GLOBALS['CONFIG']['defaulttheme']) {
        $errortext = 'Delete Theme Error';
        $message = '<br /><h4><span style="color: red;">Default theme name cannot be deleted!</span></h4><br /><br />';
        $message .= 'You will need to make another theme the default before deleting this one.<br />';
        $redirectURL = $rootDir . 'vconfig/vconfig.php?cfg=vadvphp_theme';
        $delay = 3;
        include($themepath . '/templates/admin/admin_header.php');
        include($themepath . '/templates/errmsg.php');
        include($themepath . '/templates/admin/admin_footer.php');
        exit;
    }
    // Otherwise, delete away ;)
    $errortype = 'Delete Theme?';
    $message = '<br /><b style="color: red;">This action cannot be undone!</b><br />This will remove ALL of this themes database info and physical files and theme directory!<br /><br />';
    $message .= 'Are you sure you wish to delete this theme?<br /><br />';
    $message .= '<form method="post" action="vconfig_theme_process.php">' . "\n";
    $message .= '<input type="hidden" name="process" value="1"/>' . "\n" . '<input type="hidden" name="tid" value="' . $_POST['tid'] . '"/>' . "\n";
    $message .= '<input type="submit" class="submit" value="Delete" name="confirmDelete"/>&nbsp;&nbsp;<input type="submit" class="submit" value="Cancel" name="submit"/>' . "\n";
    $message .= '</form>' . "\n";
    include($themepath . '/templates/admin/admin_header.php');
    include($themepath . '/templates/errmsg.php');
    include($themepath . '/templates/admin/admin_footer.php');
    exit;
}

if (!isset($_POST['submit']) && !isset($_POST['confirmDelete'])) {
    die('<br /><h4>Invalid parameters. Please press the BACK button on your browser.(2)</h4>');
}

if (isset($_POST['confirmDelete'])) {
    $_POST['submit'] = 'Delete';
}

if ($_POST['submit'] == 'Reset') {
    RedirectUser('vconfig.php?cfg=vadvphp_theme');
}
if ($_POST['submit'] == 'Cancel') {
    RedirectUser('vconfig.php?cfg=vadvphp_theme');
}



switch ($_POST['process']) {
    case '1':    // View/Edit Theme

        if (!isset($_POST['tid'])) {
            die('<br /><h4>Invalid parameters. Please press the BACK button on your browser.(3)</h4>');
        }

        $defaultTheme = false;
        $theme = $classThemeDat->Get($_POST['tid']);

        if ($_POST['tid'] == $GLOBALS['CONFIG']['defaulttheme']) {
            $defaultTheme = true;
        }

        $oldThemeName = $theme['themeName'];


        if (isset($_POST['confirmDelete'])) {
            // If this is the default theme, it can't be deleted
            if ($themeinfo[($_POST['tid']-1)]['themeID'] == $GLOBALS['CONFIG']['defaulttheme']) {
                $errortext = 'Delete Theme Error';
                $message = '<br /><h4><span style="color: red;">Default theme name cannot be deleted!</span></h4><br /><br />';
                $message .= 'You will need to make another theme the default before deleting this one.<br />';
                $redirectURL = $rootDir . 'vconfig/vconfig.php?cfg=vadvphp_theme';
                $delay = 3;
                include($themepath . '/templates/admin/admin_header.php');
                include($themepath . '/templates/errmsg.php');
                include($themepath . '/templates/admin/admin_footer.php');
                exit;
            }

            // Let's mark the database entry as DELETED
            $delData = $classThemeDat->Get(0);
            $delData['themeName'] = "-=DELETED=-";

            $fileString = $classThemeDat->Read();
            $fileString = $classThemeDat->Put($fileString, $_POST['tid'], $delData);
            $classThemeDat->Write($fileString);

            // Now let's remove the theme's directory and files
            unlinkRecursive($rootDir . 'themes/' . $theme['themeName'], true);
            break;

        }


        // Check theme name (it is used for the theme directory name also)
        if (!isset($_POST['themename']) || $_POST['themename'] == '') {

            // Output error page
            $errortype = 'Invalid Theme Name!';
            $message = '<br /><h4><span style="color: red;">Theme name cannot be blank!</span><br />Please press the back button on your browser.</h4><br />';
            include($themepath . '/templates/admin/admin_header.php');
            include($themepath . '/templates/errmsg.php');
            include($themepath . '/templates/admin/admin_footer.php');
            exit;
        }else if (!isAlphaNumeric($_POST['themename'], "_-")) {

            // Output error page
            $errortype = 'Invalid Theme Name!';
            $message = '<br /><h4><span style="color: red;">Theme name can only contain alphanumeric characters (a-z, A-Z, 0-9, _ and -) and may not contain spaces!</span><br />';
            $message .= 'Please press the back button on your browser.</h4><br />';
            include($themepath . '/templates/admin/admin_header.php');
            include($themepath . '/templates/errmsg.php');
            include($themepath . '/templates/admin/admin_footer.php');
            exit;
        }else{
            if ($_POST['themename'] != $theme['themeName']) {
                for ($i=0; $i<$themecount; $i++) {
                    if (trim(strtolower($_POST['themename'])) == strtolower(getThemeName($i+1))) {

                        // Output error page
                        $errortype = 'Invalid Theme Name!';
                        $message = '<br /><h4><span style="color: red;">There is already an installed theme by that name!</span><br />Please press the back button on your browser.</h4><br />';
                        include($themepath . '/templates/admin/admin_header.php');
                        include($themepath . '/templates/errmsg.php');
                        include($themepath . '/templates/admin/admin_footer.php');
                        exit;
                    }
                }
            }
        }
        // Everything's good, store the new theme name
        $theme['themeName'] = trim($_POST['themename']);

        // Check for new version
        if (isset($_POST['majorver']) && isset($_POST['minorver'])) {
            if ($_POST['majorver'] != '' && is_numeric($_POST['majorver']) &&
                $_POST['minorver'] != '' && is_numeric($_POST['minorver'])) {
                $theme['themeVer'] = trim($_POST['majorver']) . '.' . trim($_POST['minorver']);
            }else{
                // Output error page
                $errortype = 'Invalid Version Number!';
                $message = '<br /><h4><span style="color: red;">Version numbers cannot be blank or anything but numbers!</span><br />';
                $message .= 'Please press the back button on your browser.</h4><br />';
                include($themepath . '/templates/admin/admin_header.php');
                include($themepath . '/templates/errmsg.php');
                include($themepath . '/templates/admin/admin_footer.php');
                exit;
            }
        }

        // Check author's name
        if (isset($_POST['author']) && strtolower($_POST['author']) != strtolower($theme['themeAuthor'])) {
            if ($_POST['author'] != '') {
                $theme['themeAuthor'] = trim($_POST['author']);
            }else{

                // Output error page
                $errortype = 'Invalid Author Name!';
                $message = '<br /><h4><span style="color: red;">Author\'s name cannot be blank!</span><br />Please press the back button on your browser.</h4><br />';
                include($themepath . '/templates/admin/admin_header.php');
                include($themepath . '/templates/errmsg.php');
                include($themepath . '/templates/admin/admin_footer.php');
                exit;
            }
        }

        // Check author email entry
        if (isset($_POST['authoremail']) && $_POST['authoremail'] != '') {
            if (!preg_match("/^([a-z0-9\+_\-]+)(\.[a-z0-9\+_\-]+)*@([a-z0-9\-]+\.)+[a-z]{2,6}$/ix", $_POST['authoremail'])) {

                // Output error page
                $errortype = 'Invalid Author Email Format';
                $message = '<br /><h4><span style="color: red;">Email address contains invalid characters - UNUSABLE!</span><br />Please press the back button on your browser.</h4><br />';
                include($themepath . '/templates/admin/admin_header.php');
                include($themepath . '/templates/errmsg.php');
                include($themepath . '/templates/admin/admin_footer.php');
                exit;
            }
        }
        // Everything's good, store the author's email
        $theme['themeEmail'] = trim($_POST['authoremail']);

        // Check author website entry
        if (isset($_POST['authorsite']) && $_POST['authorsite'] != '' && $_POST['authorsite'] != 'http://') {
            if (!preg_match("/^(http(s?):\/\/|ftp:\/\/{1})((\w+\.){1,})\w{2,}$/i", $_POST['authorsite'])) {

                // Output error page
                $errortype = 'Invalid Author Website Format';
                $message = '<br /><h4><span style="color: red;">Website address contains invalid characters - UNUSABLE!</span><br />Please press the back button on your browser.</h4><br />';
                include($themepath . '/templates/admin/admin_header.php');
                include($themepath . '/templates/errmsg.php');
                include($themepath . '/templates/admin/admin_footer.php');
                exit;
            }
        }
        // Everything's good, store the author's website
        $theme['themeSite'] = trim($_POST['authorsite']);

        // Check disabled state
        if (isset($_POST['disable']) && !$defaultTheme) {
            $theme['themeDisabled'] = 1;
        }else{
            $theme['themeDisabled'] = 0;
        }

        if (isset($_POST['seclvl']) && ($_POST['seclvl'] != $theme['themeSecLevel'])) {
            if ($_POST['seclvl'] == '' || $_POST['seclvl'] < 0 ||
                $_POST['seclvl'] > 255 || !is_numeric($_POST['seclvl'])) {

                // Output error page
                $errortype = 'Invalid Access Level!';
                $message = '<br /><h4><span style="color: red;">Access Level cannot be blank or anything but numbers above 0 and 255 and below!</span><br />';
                $message .= 'Please press the back button on your browser.</h4><br />';
                include($themepath . '/templates/admin/admin_header.php');
                include($themepath . '/templates/errmsg.php');
                include($themepath . '/templates/admin/admin_footer.php');
                exit;
            }else{
                if ($_POST['seclvl'] > 0 && $defaultTheme) {

                    // Output error page
                    $errortype = 'Invalid Access Level!';
                    $message = '<br /><h4><span style="color: red;">Access Level cannot be above 0 on default theme!</span><br />';
                    $message .= 'Please press the back button on your browser.</h4><br />';
                    include($themepath . '/templates/admin/admin_header.php');
                    include($themepath . '/templates/errmsg.php');
                    include($themepath . '/templates/admin/admin_footer.php');
                    exit;
                }else{
                    $theme['themeSecLevel'] = $_POST['seclvl'];
                }
            }
        }

        // Everything looks good, so let's write our updated theme data

        // Get the file string.
        $fileString = $classThemeDat->Read();

        // Put the new information into the file string.
        $editTheme['themeDate'] = strtotime(date("m", time()) . '/' . date("d", time()) . '/' . date("Y", time()));
        $fileString = $classThemeDat->Put($fileString, $_POST['tid'], $theme);

        // Update the database file.
        $classThemeDat->Write($fileString);

        // If theme name has changed, we must rename the theme's directory
        if ($theme['themeName'] != $oldThemeName) {
            rename($rootDir . 'themes/' . $oldThemeName, $rootDir . 'themes/' . $theme['themeName']);
        }

        // Update vadvtheme.cfg file
        $themeDir = $rootDir.'themes/'.$theme['themeName'].'/';
        writeThemeCfg($theme, $themeDir);

        break;

    case '2':    // Create Theme

        $newThemeInfo = array();

        // Check theme name (it is used for the theme directory name also)
        if (!isset($_POST['newName']) || $_POST['newName'] == '') {

            // Output error page
            $errortype = 'Invalid Theme Name!';
            $message = '<br /><h4><span style="color: red;">Your new theme name cannot be blank!</span><br />Please press the back button on your browser.</h4><br />';
            include($themepath . '/templates/admin/admin_header.php');
            include($themepath . '/templates/errmsg.php');
            include($themepath . '/templates/admin/admin_footer.php');
            exit;
        }else if (!isAlphaNumeric($_POST['newName'], "_-")) {

            // Output error page
            $errortype = 'Invalid Theme Name!';
            $message = '<br /><h4><span style="color: red;">Your new theme name can only contain alphanumeric characters (a-z, A-Z, 0-9, _ and -) and may not contain spaces!</span><br />';
            $message .= 'Please press the back button on your browser.</h4><br />';
            include($themepath . '/templates/admin/admin_header.php');
            include($themepath . '/templates/errmsg.php');
            include($themepath . '/templates/admin/admin_footer.php');
            exit;
        }else if (strcasecmp($_POST['newName'], "NewTheme") == 0) {

            // Output error page
            $errortype = 'Invalid Theme Name!';
            $message = '<br /><h4><span style="color: red;">You must create a new name for your theme! (&quot;'.$_POST['newName'].'&quot; is not allowed)</span><br />';
            $message .= 'Please press the back button on your browser.</h4><br />';
            include($themepath . '/templates/admin/admin_header.php');
            include($themepath . '/templates/errmsg.php');
            include($themepath . '/templates/admin/admin_footer.php');
            exit;
        }else{
            for ($i=0; $i<$themecount; $i++) {
                if (trim(strtolower($_POST['newName'])) == strtolower(getThemeName($i+1))) {

                    // Output error page
                    $errortype = 'Invalid Theme Name!';
                    $message = '<br /><h4><span style="color: red;">There is already an installed theme by that name!</span><br />Please press the back button on your browser.</h4><br />';
                    include($themepath . '/templates/admin/admin_header.php');
                    include($themepath . '/templates/errmsg.php');
                    include($themepath . '/templates/admin/admin_footer.php');
                    exit;
                }
            }
        }
        // Everything's good, store the new theme name
        $newThemeInfo['themeName'] = trim($_POST['newName']);


        // Check author entry
        if (!isset($_POST['newAuthor']) || $_POST['newAuthor'] == '') {

            // Output error page
            $errortype = 'Invalid Author Name!';
            $message = '<br /><h4><span style="color: red;">You must specify an author of your theme!</span><br />Please press the back button on your browser.</h4><br />';
            include($themepath . '/templates/admin/admin_header.php');
            include($themepath . '/templates/errmsg.php');
            include($themepath . '/templates/admin/admin_footer.php');
            exit;
        }
        // Everything's good, store the author's name
        $newThemeInfo['themeAuthor'] = trim($_POST['newAuthor']);


        // Check author email entry
        if (isset($_POST['newEmail']) || $_POST['newEmail'] != '') {
            if (!preg_match("/^([a-z0-9\+_\-]+)(\.[a-z0-9\+_\-]+)*@([a-z0-9\-]+\.)+[a-z]{2,6}$/ix", $_POST['newEmail'])) {

                // Output error page
                $errortype = 'Invalid Author Email Format';
                $message = '<br /><h4><span style="color: red;">Email address contains invalid characters - UNUSABLE!</span><br />Please press the back button on your browser.</h4><br />';
                include($themepath . '/templates/admin/admin_header.php');
                include($themepath . '/templates/errmsg.php');
                include($themepath . '/templates/admin/admin_footer.php');
                exit;
            }else{
                // Everything's good, store the author's email
                $newThemeInfo['themeEmail'] = trim($_POST['newEmail']);
            }
        }


        // Check author website address
        if (isset($_POST['newSite']) && $_POST['newSite'] != '') {
            if (!preg_match("/^(http(s?):\/\/|ftp:\/\/{1})((\w+\.){1,})\w{2,}$/i", $_POST['newSite'])) {
                // Output error page
                $errortype = 'Invalid Author Website Format';
                $message = '<br /><h4><span style="color: red;">Author\'s website contains invalid characters - UNUSABLE!<br />(Make sure to include \'http://\' before it...)</span><br />';
                $message .= 'Please press the back button on your browser.</h4><br />';
                include($themepath . '/templates/admin/admin_header.php');
                include($themepath . '/templates/errmsg.php');
                include($themepath . '/templates/admin/admin_footer.php');
                exit;
            }else{
                // Everythings's good, store the author's website
                $newThemeInfo['themeSite'] = trim($_POST['newSite']);
            }
        }


        // Now that we've made it this far, let's set up some more info and create a new theme!
        $cloneID = $_POST['cloneID'];

        // Copy the chosen theme and write the theme's data file
        $result = createNewTheme($cloneID, $newThemeInfo);

        if ($result) {
            $errortype = 'Theme Creation Successful!';
            $message = '<br /><h4><span style="color: green;">Theme "'.$newThemeInfo['themeName'].'" has been created and is ready to install and/or edit to your liking.</span></h4><br />';
            $message .= 'You will now be returned to Theme Settings...';
            $redirectURL = $rootDir . 'vconfig/vconfig.php?cfg=vadvphp_theme';
            include($themepath . '/templates/admin/admin_header.php');
            include($themepath . '/templates/errmsg.php');
            include($themepath . '/templates/admin/admin_footer.php');
            exit;
        }
        break;

    case '3':    // Install Theme

        break;

    default:
        RedirectUser('vconfig.php?cfg=vadvphp_theme');
}


RedirectUser('vconfig.php?cfg=vadvphp_theme');


?>