<?php
/*
 * ----------------------------------------------------------------------------
 * VConfig_VADV-PHP_Process.php                                      04/06/2014
 * This script processes info from the vconfig_.php script.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2014 Steve Winn. All Rights Reserved.
 *
 * For licensing information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

$GLOBALS['VA_ACTION'] = 'SysOp Function';

require_once('include_dir.php');
require_once($includeDir . 'vadv-php.inc.php');

$classVADVPHPCfg = new cfgVADVPHP;

if (($GLOBALS['USER']['userno'] == 0) ||
    ($GLOBALS['USER']['userno'] == $GLOBALS['CONFIG']['guestacct']) ||
    ($GLOBALS['USER']['securitylevel'] == 0)) {
    RedirectUser($rootDir . 'index.php');
}
if ($GLOBALS['USER']['securitylevel'] < 255) {
    $log = 'VConfig Error!  "' . $GLOBALS['USER']['handle'] . '" - Attempted Unauthorized VConfig Entry';
    WriteLog('VADV-PHP.LOG', $log);
    RedirectUser($rootDir . 'index.php');
}

// Check for system password.
if ($GLOBALS['CONFIG']['syspass']) {
    if (isset($_SESSION['systempw'])) {
        if ($_SESSION['systempw'] !== $GLOBALS['VA_MAIN']['systempw']) {
            RedirectUser($rootDir . 'index.php');
        }
    } else {
        RedirectUser($rootDir . 'index.php');
    }
}


// Load Who's Online list
$classControlDat = new datControl;
$who = $classControlDat->Get();

$maxChannel = 10;    // Display only first 10 channels.
if ($GLOBALS['VA_MAIN']['maxchannelno'] < $maxChannel) {
    $maxChannel = $GLOBALS['VA_MAIN']['maxchannelno'];
}
if ($who['nodetotal'] < $maxChannel) {
    $maxChannel = $who['nodetotal'];
}

// Get number of guests...

$totalGuests = 0;
for ($i = 1; $i <= $GLOBALS['VA_USERS'][0]; $i++) {
    if (($GLOBALS['VA_USERS'][$i]['userno'] == 0) || ($GLOBALS['VA_USERS'][$i]['userno'] == $GLOBALS['CONFIG']['guestacct'])) {
        $totalGuests++;
    }
}
$totalUsers = $GLOBALS['VA_USERS'][0] - $totalGuests;


if ((!isset($_SERVER['HTTP_REFERER'])) ||
    (strpos($_SERVER['HTTP_REFERER'], $_SERVER['HTTP_HOST']) === FALSE)) {
    die('<br /><h4>You are not allowed to access this script from an outside source.<br />Press the BACK button on your browser.</h4>');
}

if ((!isset($_POST['process'])) ||
    ($_POST['process'] != 1)) {
    die('<br /><h4>Invalid parameters. Please press the BACK button on your browser.</h4>');
}
if (!isset($_POST['submit'])) {
    die('<br /><h4>Invalid parameters. Please press the BACK button on your browser.</h4>');
}

if ($_POST['submit'] == 'Reset') {
    RedirectUser($_POST['referer']);
}
if ($_POST['submit'] == 'Cancel') {
    RedirectUser('vconfig.php');
}




// Process the incoming form data
//$newConfig = $GLOBALS['CONFIG'];        // <--- if we set this here, checking to see if it's set below is a moot point, isn't it??

if ((isset($_POST['telnet'])) &&
    ($_POST['telnet'] != $GLOBALS['CONFIG']['telnet'])) {
    $newConfig['telnet'] = $_POST['telnet'];
}
if ((isset($_POST['telnetport'])) &&
    ($_POST['telnetport'] != $GLOBALS['CONFIG']['telnetport'])) {
    $newConfig['telnetport'] = (integer) $_POST['telnetport'];
} else if((!isset($_POST['telnetport']) || $_POST['telnetport'] == '') &&
    ($_GET['page'] == 'gen')) {
    $newConfig['telnetport'] = 23;
}
if ((isset($_POST['hostname'])) &&
    ($_POST['hostname'] != $GLOBALS['CONFIG']['hostname'])) {
    $newConfig['hostname'] = $_POST['hostname'];
}
if ((isset($_POST['filehost'])) &&
    ($_POST['filehost'] != $GLOBALS['CONFIG']['filehost'])) {
    $newConfig['filehost'] = $_POST['filehost'];
}
if ((isset($_POST['bbsdir']) && $_POST['bbsdir'] != '') &&
    ($_POST['bbsdir'] != $GLOBALS['CONFIG']['bbsdir'])) {
    $newConfig['bbsdir'] = $_POST['bbsdir'];
} else if ((!isset($_POST['bbsdir']) || $_POST['bbsdir'] == '') &&
    ($_GET['page'] == 'gen')) {
    // This directory can NOT be blank and must be valid or system will freak!
    $errortype = 'VADV-PHP Configuration';
    $message = '<br /><span style="color: red;">BBS Directory can <b>NOT</b> be blank!</span>s<br /><br />';
    $message .= 'And it <b>MUST BE VALID</b>!<br /><br />Please press the BACK button on your browser.<br /><br />';
    include($themepath . '/templates/admin/admin_header.php');
    include($themepath . '/templates/errmsg.php');
    include($themepath . '/templates/admin/admin_footer.php');
    exit;
}
if ((isset($_POST['syspass'])) &&
    ($_POST['syspass'] != $GLOBALS['CONFIG']['syspass']) &&
    ($_POST['syspass'] != '')) {
    $newConfig['syspass'] = $_POST['syspass'];
} else if ((!isset($_POST['syspass'])) &&
    ($_GET['page'] == 'gen')) {
    $newConfig['syspass'] = 0;
}
if ((isset($_POST['webmaster'])) &&
    ($_POST['webmaster'] != $GLOBALS['CONFIG']['webmaster'])) {
    $newConfig['webmaster'] = $_POST['webmaster'];
}
if ((isset($_POST['defaulttheme'])) &&
    ($_POST['defaulttheme'] != $GLOBALS['CONFIG']['defaulttheme'])) {
    $newConfig['defaulttheme'] = $_POST['defaulttheme'];
}
if ((isset($_POST['themetracker'])) &&
    ($_POST['themetracker'] != $GLOBALS['CONFIG']['themetracker']) &&
    ($_POST['themetracker'] != '')) {
    $newConfig['themetracker'] = $_POST['themetracker'];
} else if ((!isset($_POST['themetracker'])) &&
    ($_GET['page'] == 'gen')) {
    $newConfig['themetracker'] = 0;
}
if ((isset($_POST['guestacct'])) &&
    ($_POST['guestacct'] != $GLOBALS['CONFIG']['guestacct'])) {
    $newConfig['guestacct'] = (integer) $_POST['guestacct'];
} else if((!isset($_POST['guestacct']) || $_POST['guestacct'] == '') &&
    ($_GET['page'] == 'user')) {
    $newConfig['guestacct'] = 0;
}
if ((isset($_POST['usersl'])) &&
    ($_POST['usersl'] != $GLOBALS['CONFIG']['usersl'])) {
    $newConfig['usersl'] = (integer) $_POST['usersl'];
} else if((!isset($_POST['usersl']) || $_POST['usersl'] == '') &&
    ($_GET['page'] == 'user')) {
    $newConfig['usersl'] = 0;
}
if ((isset($_POST['useraccflags'])) &&
    ($_POST['useraccflags'] != $GLOBALS['CONFIG']['useraccflags'])) {
    $newConfig['useraccflags'] = $_POST['useraccflags'];
}
if ((isset($_POST['userage'])) &&
    ($_POST['userage'] != $GLOBALS['CONFIG']['userage'])) {
    $newConfig['userage'] = (integer) $_POST['userage'];
}
if ((isset($_POST['newuseroneliner'])) &&
    ($_POST['newuseroneliner'] != $GLOBALS['CONFIG']['newuseroneliner']) &&
    ($_POST['newuseroneliner'] != '')) {
    $newConfig['newuseroneliner'] = $_POST['newuseroneliner'];
} else if ((!isset($_POST['newuseroneliner'])) &&
    ($_GET['page'] == 'user')) {
    $newConfig['newuseroneliner'] = 0;
}
if ((isset($_POST['purgetime'])) &&
    ($_POST['purgetime'] != $GLOBALS['CONFIG']['purgetime'])) {
    $newConfig['purgetime'] = (integer) $_POST['purgetime'];
} else if((!isset($_POST['purgetime']) || $_POST['purgetime'] == '') &&
    ($_GET['page'] == 'other')) {
    $newConfig['purgetime'] = 0;
}
if ((isset($_POST['purgeminlevel'])) &&
    ($_POST['purgeminlevel'] != $GLOBALS['CONFIG']['purgeminlevel'])) {
    $newConfig['purgeminlevel'] = (integer) $_POST['purgeminlevel'];
} else if((!isset($_POST['purgeminlevel']) || $_POST['purgeminlevel'] == '') &&
    ($_GET['page'] == 'other')) {
    $newConfig['purgeminlevel'] = 0;
}
if ((isset($_POST['purgemaxlevel'])) &&
    ($_POST['purgemaxlevel'] != $GLOBALS['CONFIG']['purgemaxlevel'])) {
    $newConfig['purgemaxlevel'] = (integer) $_POST['purgemaxlevel'];
} else if((!isset($_POST['purgemaxlevel']) || $_POST['purgemaxlevel'] == '') &&
    ($_GET['page'] == 'other')) {
    $newConfig['purgemaxlevel'] = 253;
}
if ((isset($_POST['newuserreq'])) &&
    ($_POST['newuserreq'] != $GLOBALS['CONFIG']['newuserreq'])) {
    $newConfig['newuserreq'] = (integer) $_POST['newuserreq'];
} else if((!isset($_POST['newuserreq']) || $_POST['newuserreq'] == '') &&
    ($_GET['page'] == 'other')) {
    $newConfig['newuserreq'] = 141;
}
if ((isset($_POST['banned'])) &&
    ($_POST['banned'] != $GLOBALS['CONFIG']['banned'])) {
    $newConfig['banned'] = $_POST['banned'];
}
if ((isset($_POST['refresh'])) &&
    ($_POST['refresh'] != $GLOBALS['CONFIG']['refresh'])) {
    $newConfig['refresh'] = (integer) $_POST['refresh'];
} else if((!isset($_POST['refresh']) || $_POST['refresh'] == '') &&
    ($_GET['page'] == 'other')) {
    $newConfig['refresh'] = 0;
}
if ((isset($_POST['cookielife'])) &&
    ($_POST['cookielife'] != $GLOBALS['CONFIG']['cookielife'])) {
    $newConfig['cookielife'] = (integer) $_POST['cookielife'];
} else if((!isset($_POST['cookielife']) || $_POST['cookielife'] == '') &&
    ($_GET['page'] == 'other')) {
    $newConfig['cookielife'] = 7;
}
if ((isset($_POST['fileupload'])) &&
    ($_POST['fileupload'] != $GLOBALS['CONFIG']['fileupload']) &&
    ($_POST['fileupload'] != '')) {
    $newConfig['fileupload'] = $_POST['fileupload'];
} else if ((!isset($_POST['fileupload'])) &&
    ($_GET['page'] == 'other')) {
    $newConfig['fileupload'] = 0;
}
if ((isset($_POST['fileuploadsl'])) &&
    ($_POST['fileuploadsl'] != $GLOBALS['CONFIG']['fileuploadsl'])) {
    $newConfig['fileuploadsl'] = (integer) $_POST['fileuploadsl'];
} else if((!isset($_POST['fileuploadsl']) || $_POST['fileuploadsl'] == '') &&
    ($_GET['page'] == 'other')) {
    $newConfig['fileuploadsl'] = 255;
}
if ((isset($_POST['newfilescan'])) &&
    ($_POST['newfilescan'] != $GLOBALS['CONFIG']['newfilescan'])) {
    $newConfig['newfilescan'] = (integer) $_POST['newfilescan'];
} else if((!isset($_POST['newfilescan']) || $_POST['newfilescan'] == '') &&
    ($_GET['page'] == 'other')) {
    $newConfig['newfilescan'] = 1;
}
if ((isset($_POST['requiresecurelogin'])) &&
    ($_POST['requiresecurelogin'] != $GLOBALS['CONFIG']['requiresecurelogin']) &&
    ($_POST['requiresecurelogin'] != '')) {
    $newConfig['requiresecurelogin'] = $_POST['requiresecurelogin'];
} else if ((!isset($_POST['requiresecurelogin'])) &&
    ($_GET['page'] == 'other')) {
    $newConfig['requiresecurelogin'] = 0;
}
if ((isset($_POST['encryption'])) &&
    ($_POST['encryption'] != $GLOBALS['CONFIG']['encryption'])) {
    $newConfig['encryption'] = $_POST['encryption'];
}
if ((isset($_POST['fileencryption'])) &&
    ($_POST['fileencryption'] != $GLOBALS['CONFIG']['fileencryption'])) {
    $newConfig['fileencryption'] = $_POST['fileencryption'];
}
if ((isset($_POST['rssfeed'])) &&
    ($_POST['rssfeed'] != $GLOBALS['CONFIG']['rssfeed']) &&
    ($_POST['rssfeed'] != '')) {
    $newConfig['rssfeed'] = $_POST['rssfeed'];
} else if ((!isset($_POST['rssfeed'])) &&
    ($_GET['page'] == 'other')) {
    $newConfig['rssfeed'] = 0;
}
if ((isset($_POST['rssfeedlimit'])) &&
    ($_POST['rssfeedlimit'] != $GLOBALS['CONFIG']['rssfeedlimit'])) {
    $newConfig['rssfeedlimit'] = (integer) $_POST['rssfeedlimit'];
} else if((!isset($_POST['rssfeedlimit']) || $_POST['rssfeedlimit'] == '') &&
    ($_GET['page'] == 'other')) {
    $newConfig['rssfeedlimit'] = 50;
}
if ((isset($_POST['showcustomdbs'])) &&
    ($_POST['showcustomdbs'] != $GLOBALS['CONFIG']['showcustomdbs']) &&
    ($_POST['showcustomdbs'] != '')) {
    $newConfig['showcustomdbs'] = $_POST['showcustomdbs'];
} else if ((!isset($_POST['showcustomdbs'])) &&
    ($_GET['page'] == 'other')) {
    $newConfig['showcustomdbs'] = 0;
}
if ((isset($_POST['flashterm'])) &&
    ($_POST['flashterm'] != $GLOBALS['CONFIG']['flashterm']) &&
    ($_POST['flashterm'] != '')) {
    $newConfig['flashterm'] = $_POST['flashterm'];
} else if ((!isset($_POST['flashterm'])) &&
    ($_GET['page'] == 'gen')) {
    $newConfig['flashterm'] = 0;
}
if ((isset($_POST['newslist'])) &&
    ($_POST['newslist'] != $GLOBALS['CONFIG']['newslist']) &&
    ($_POST['newslist'] != '')) {
    $newConfig['newslist'] = $_POST['newslist'];
} else if ((!isset($_POST['newslist'])) &&
    ($_GET['page'] == 'at2k')) {
    $newConfig['newslist'] = 0;
}
if ((isset($_POST['postitnt'])) &&
    ($_POST['postitnt'] != $GLOBALS['CONFIG']['postitnt']) &&
    ($_POST['postitnt'] != '')) {
    $newConfig['postitnt'] = $_POST['postitnt'];
} else if ((!isset($_POST['postitnt'])) &&
    ($_GET['page'] == 'at2k')) {
    $newConfig['postitnt'] = 0;
}
if ((isset($_POST['sysnews'])) &&
    ($_POST['sysnews'] != $GLOBALS['CONFIG']['sysnews']) &&
    ($_POST['sysnews'] != '')) {
    $newConfig['sysnews'] = $_POST['sysnews'];
} else if ((!isset($_POST['sysnews'])) &&
    ($_GET['page'] == 'at2k')) {
    $newConfig['sysnews'] = 0;
}

if (isset($newConfig)) {
    $classVADVPHPCfg->Write($newConfig);
}


// Show a successful save message and redirect back to page
$errortype = 'VADV-PHP Configuration';
$message = '<br /><b style="color: green;">Configuration Saved!</b><br /><br />';
$delay = 2;
$redirectURL = $_POST['referer'];
include($themepath . '/templates/admin/admin_header.php');
include($themepath . '/templates/errmsg.php');
include($themepath . '/templates/admin/admin_footer.php');
exit;

?>